/*
$Header: /vol/baal-vol3/projekt98/quellen/XCTL_32/DETECUSE/dllmain.cpp,v 1.6 2004/05/06 07:33:25 reinecke Exp $

Projekt   : XCTL
Subsystem : Detektoren
Autor     : Jan Picard <picard@informatik.hu-berlin.de> 2001-2002
          Institut fuer Informatik,
          Humboldt-Universitaet Berlin
Inhalt    : In dieser Datei finden sich allgemeine Dinge, die zum Erstellen
          der counters.dll noetig sind.
*/

#include "utils\u_utils.h"
#pragma hdrstop

#include "detecuse\detecuse.h"
#include "detecuse\detecgui.h"

#include "hardware\hwio.h"
#include "hardware\hwguids.h"

//#include "utils\CheckMemory.h"	// CHECKMEM

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

// Globale Deklarationen fuer das DLL-Handling
HINSTANCE hModuleInstance;
static char dlVersion[ ]= "V 1.52 ("__DATE__")";

//Verwaltungsstrukturen (Treiber)
DeviceList DetectorDrivers;
ControllerList DetectorControllers;

BOOL WINAPI DllMain(HINSTANCE hModule, DWORD dwFunction, LPVOID)
{
	switch (dwFunction)
	{
			case DLL_PROCESS_ATTACH:
				// Initialize function array.
				hModuleInstance= hModule;

	  			//Initialisieren der Gerteliste fr die Detectoren
				RegisterDrivers(&DetectorDrivers,GUID_RADICON,RADICON);
				RegisterDrivers(&DetectorDrivers,GUID_TAM9513,GENERIC);
				RegisterDrivers(&DetectorDrivers,GUID_BRAUNPSD,BRAUN);
				RegisterDrivers(&DetectorDrivers,GUID_STOEPSD,STOE);
				break;

			case DLL_PROCESS_DETACH:
				//CHECKMEM("COUNTERS.DLL");	//hp
				break;
	};
	return TRUE;
}

LPCSTR __declspec(dllexport) WINAPI dlGetVersion( void )
{
	return ( LPCSTR ) dlVersion;
};

HINSTANCE __declspec(dllexport) WINAPI dlGetInstance( void )
{
	return hModuleInstance;
};

Controller* GetController(EDeviceType DeviceID, LPTSTR HardwareID, ControllerList* Controllers, DeviceList* Drivers,
									 DWORD* index)
{
	char szDeviceName[257];
	memset(szDeviceName, '\0', 257);

	Controller* pCon= Controllers->GetController(DeviceID, HardwareID);

	if (!pCon)
	{ //neuen Controller anlegen
		switch (DeviceID)
		{
			case RADICON:
				strcpy(szDeviceName, "Radicon");
				pCon= new TRadiconController(DeviceID, HardwareID, Drivers);
				break;

			case BRAUN:
				strcpy(szDeviceName, "BraunPsd");
				pCon= new TBraunPsdController(DeviceID, HardwareID, Drivers);
				break;

			case GENERIC:
				strcpy(szDeviceName, "TAm9513");
				pCon= new TGenericController(DeviceID, HardwareID, Drivers);
				//pCon= new StandardController(DeviceID,HardwareID,Drivers);
				break;

			case STOE:
				strcpy(szDeviceName, "StoePsd");
				pCon= new StandardController(DeviceID, HardwareID, Drivers);
				break;

			default:
				strcpy(szDeviceName, "Unbekanntes Gert");
				pCon= new StandardController(DeviceID, HardwareID, Drivers);
				break;
		}

		if (!pCon)
		{
			MessageBox(0, "Fehler bei Initialisierung des Controllers", szDeviceName, MB_OK);
			return (0);
		}

		if (!pCon->AddClient())
		{
			MessageBox(0, "Maximale Anzahl von Clients berschritten.\nEs liegt eine Fehlkonfiguration vor.", szDeviceName, MB_OK);
			return (0);
		}

		Controllers->Add(pCon);
	}

	if (index)
		*index= Controllers->GetControllerIndex(DeviceID, HardwareID);

	return (pCon);
}
