//##############################################################################
//                                                                            //
// A_EXTERN.CPP                                                               //
//                                                                            //
// Subsystem: Diffraktometrie/ Reflektometrie                                 //
//            DAS MDI-Fenster fr AreaScan                                    //
// Benutzung durch andere Subsysteme erforderlich: JA                         //
//                                                                            //
//##############################################################################
//! Kommentierung und Aenderungen B. Buss, 2000/2001, HUB IfI

#include <direct.h>

#include "internls\evrythng.h" // GermanVersion
#include "winresrc\rc_def.h"   // Ressourcen-IDs
#include "help\help_def.h"     // Help-IDs
#pragma hdrstop

#include "difrkmty\a_extern.h" // SCHNITTSTELLE fr diese Datei

#include "datavisa\datavisa.h"
#include "motrstrg\motrstrg.h"
#include "workflow\workflow.h"
#include "difrkmty\a_intern.h" // TChooseScanDlg, TSetupAreaScanDlg, ...

#include "internls\l_layer.h" // 17.11.2002 fr extern lpDBase

//! neu: klier Allgemeine Einstellungen
#include "mespara\mespara.h"

//! neu: klier Protokollbuch
#include "protocol\protocol.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

__declspec(dllimport) LPDataBase lpDBase;
__declspec(dllimport) LPMList lpMList; //Komposition aus TMotor-Objekten

extern TMain Main; // in m_MAIN.CPP deklariertes Hauptprogramm
extern TSteering Steering;

//! neu: klier Allgemeine Einstellungen
extern TMeasurementParameter MeasurementParameter;

//#############################################################################
// globale Typen und Konstanten
//#############################################################################

struct TData // variables for data aquisition
{
	double dX, dY, dOmega, dTheta;
	float fDelta, fIntensity;
};

TModelessDlg* ChooseScanDlg= 0; //! neu Kullmann+Reinecker: TheModeless ersetzt durch ChooseScanDlg; extern entfernt

// #define Peak_and_Cross

//#############################################################################
// sprachspezifische Konstanten
//#############################################################################

#ifdef GermanVersion
  static const char szMsgFailure[]= "Fehler";
  static const char szMessage[]= "Meldung";

  static const char szTitle[]= "AreaScan: ";

  static const char szMsgLine001[]= "Messung! Omega: %s 2Theta: %s Intensitt: %%.3f";
  static const char szMsgLine002[]= "Der Detektor %s ist als Monitor gekennzeichnet!";
  static const char szMsgLine003[]= "Starte Omega/2Theta-Scan(PSD) \nmit Omega von %s bis %s ?";
  static const char szMsgLine004[]= "Starte Omega/2Theta-Scan(SLD) \nmit Omega von %s bis %s ?";
  static const char szMsgLine005[]= "Starte OmegaScan(PSD) \nmit Omega von %s bis %s ?";
  static const char szMsgLine006[]= "Theta ist relativ! \nOffset bercksichtigen ?";
  static const char szMsgLine007[]= "Omega ist relativ! \nOffset bercksichtigen ?";
  static const char szMsgLine008[]= "Scan-Nummer bersteigt %d !";
  static const char szMsgLine009[]= "Messung! Omega: %s";
  static const char szMsgLine010[]= "%s P(%s<>%%.1f) Integral Intensitt: %%.1f > %%d";
  static const char szMsgLine011[]= "%d Scan's wurden gemessen";
  static const char szMsgLine012[]= "Die Messung wurde abgeschlossen \nund gespeichert.";
  static const char szMsgLine013[]= "Messung wurde unterbrochen !";
  static const char szMsgLine014[]= "Inkorrekter Header.";
  static const char szMsgLine016[]= "Kein Detektor als Monitor spezifiziert!";
  static const char szMsgLine222[]= "Messung wurde abgebrochen !";

  //! neu eingefuehrt
  static const char szMsgLine017[]= "Bitte erst Daueranzeige deaktivieren!";
  static const char szMsgLine018[]= "Die Messung wurde abgeschlossen.";
  static const char szMsgLine019[]= "Die Messung wurde abgeschlossen. \r\nFehler beim Speichern!";
  static const char szMsgLine020[]= "Es ist ein Fehler aufgetreten. %d";
  static const char szMsgLine021[]= "Hardware ist nicht vollstndig verfgbar !";
  static const char szMsgLine023[]= "Ungltiger Darstellungstyp !";
  static const char szMsgLine024[]= "Kein Psd verfgbar !";
  static const char szMsgLine025[]= "Standard-Scan nur mit PSD.";
  static const char szMsgLine026[]= "Anzeige Psd-Spektrum ...";
  static const char szMsgLine026e[]= "Psd-Energiespek...";
  static const char szMsgLine026p[]= "Psd-Pos.-Spek...";
  static const char szMsgLine027[]= "Bitte die Darstellung >Curve< waehlen.";
  static const char szMsgLine028[]= "Scan %d von %d schreiben.";
  static const char szMsgLine029[]= "Scan %d schreiben.";
  static const char szMsgLine030[]= "Reportdatei \n\"%s\" \nfehlt oder ist defekt!";
  static const char szMsgLine031[]= "keine Datenbasis vorhanden";

  //! neu: klier Protokollbuch
  static const char szMsgLine032[]= "Soll die Messung im Protokollbuch gespeichert werden?";

  static const char szMsgLine200[]= "gewhlte Koordinaten auerhalb des Megebiets!";
  static const char szMsgLine201[]= "Eingabe wird verworfen !";
  static const char szMsgLine202[]= "[Header] \nGerade zwischen 2 Punkten \n";
  static const char szMsgLine203[]= "RLY aufsteigend geordnet\n";
  static const char szMsgLine204[]= "Probleme beim Anlegen der Datei !";
  static const char szMsgLine205[]= "Omega aufsteigend geordnet\n";
  static const char szMsgLine206[]= "Die Daten wurden in Datei %s gespeichert !";
  static const char szMsgLine207[]= "Daten-Erhebung - Information";
  static const char szMsgLine208[]= "Start AreaScan";
  static const char szMsgLine209[]= "Psd-Spektrum anzeigen";
  static const char szMsgLine210[]= "Datei nachladen";
  static const char szMsgLine211[]= "%d Scan's gelesen";
  static const char szMsgLine212[]= "archivierte Datendatei wurde gelesen";
  static const char szMsgLine213[]= "PSD-Kalibrierung";

  // x-Achse
  static const char szChannel[]=   "Kanle von %s";
  static const char szAngle[]=     "Winkel von %s";
  static const char szAngleUnit[]= "Winkel von %s\nin %s";
  static const char szAngleUnitEZ[]= "Winkel von %s";
  // y-Achse
  static const char szAngleOmegaUnit[]= "Winkel von\n%s\nin %s";	
  static const char szAngleOmegaUnitEZ[]= "%s";	
  static const char szEnergy[]=         "Kanle";
  static const char szFrequentLi[]=     "Hufigkeiten\nlinear skaliert";
  static const char szFrequentLo[]=     "Hufigkeiten\nlog10 skaliert";

  static const char szMsgLine312[]= "Ein kontinuierliches PSD-Spektrum wird gerade angezeigt.\nUm die PSD-Kalibrierung aufrufen zu knnen, muss diese Anzeige gestoppt werden.\n\nMchten Sie das kontinuierliche PSD-Spektrum jetzt automatisch stoppen lassen?";
  static const char szMsgLine313[]= "Dateiheader wird gelesen...";
  static const char szMsgLine314[]= "Messdaten werden ausgewertet...";
#else
  static const char szMsgFailure[]= "Failure";
  static const char szMessage[]= "Message";

  static const char szTitle[]= "AreaScan: ";

  static const char szMsgLine001[]= "Measurement! Omega: %s 2Theta: %s Intensity: %%.3f";
  static const char szMsgLine002[]= "The Detector %s is tagged as Monitor !";
  static const char szMsgLine003[]= "Starting Omega/2Theta-Scan(PSD) \nwith Omega from %s to %s ?";
  static const char szMsgLine004[]= "Starting Omega/2Theta-Scan(SLD) \nwith Omega from %s to %s ?";
  static const char szMsgLine005[]= "Starting OmegaScan(PSD) \nwith Omega from %s to %s ?";
  static const char szMsgLine006[]= "Theta is relative! \nDo you want to use the Offset ?";
  static const char szMsgLine007[]= "Omega is relative! \nDo you want to use the Offset ?";
  static const char szMsgLine008[]= "Scan-Number exceeds %d !";
  static const char szMsgLine009[]= "Measurement! Omega:%s";
  static const char szMsgLine010[]= "%s P(%s<>%%.1f) Integral Intensity: %%.1f > %%d";
  static const char szMsgLine011[]= "%d Scan's has been measured";
  static const char szMsgLine012[]= "The Measurement is completed \r\nand the data were saved.";
  static const char szMsgLine013[]= "Measurement has been interrupted !";
  static const char szMsgLine014[]= "Incorrect Header.";
  static const char szMsgLine016[]= "No Detector as Monitor specified!";
  static const char szMsgLine222[]= "The Measurement was stoped !";

  //! neu eingefuehrt
  static const char szMsgLine017[]= "Please deactivate Continuousdisplay first";
  static const char szMsgLine018[]= "The Measurement is completed.";
  static const char szMsgLine019[]= "The Measurement is completed. \r\nFailure on saving data.";
  static const char szMsgLine020[]= "There is a Failure appeared. %d";
  static const char szMsgLine021[]= "Hardware is not complete available !";
  static const char szMsgLine023[]= "Invalid Display Type !";
  static const char szMsgLine024[]= "No psd available .";
  static const char szMsgLine025[]= "Standard-Scan with PSD only";
  static const char szMsgLine026[]= "Display Psd-spectrum ...";
  static const char szMsgLine026e[]= "Psd-energyspec...";
  static const char szMsgLine026p[]= "Psd-pos.-spec...";
  static const char szMsgLine027[]= "Please choose the Display-type >Curve< .";
  static const char szMsgLine028[]= "Save Scan %d of %d .";
  static const char szMsgLine029[]= "Save Scan %d .";
  static const char szMsgLine030[]= "Reportfile \n\"%s\" \nis missing or damaged!";
  static const char szMsgLine031[]= "no DataBase existing";

  //! neu: klier Protokollbuch
  static const char szMsgLine032[]= "Do you want to save this measure into the protocolbook?";

  static const char szMsgLine200[]= "selected coordinates outside of the measurementarea!";
  static const char szMsgLine201[]= "Input is rejected !";
  static const char szMsgLine202[]= "[Header] \nLine between 2 points \n";
  static const char szMsgLine203[]= "RLY ascending arranged\n";
  static const char szMsgLine204[]= "Problems when creating the file !";
  static const char szMsgLine205[]= "Omega ascending arranged\n";
  static const char szMsgLine206[]= "The data were stored in the file %s !";
  static const char szMsgLine207[]= "Data-inquiries - Information";
  static const char szMsgLine208[]= "Starting AreaScan";
  static const char szMsgLine209[]= "Show Psd-Spectrum";
  static const char szMsgLine210[]= "reload File";
  static const char szMsgLine211[]= "%d scan's read";
  static const char szMsgLine212[]= "archived data-file was read";
  static const char szMsgLine213[]= "PSD-Calibration";

  static const char szChannel[]=   "channels of %s";
  static const char szAngle[]=     "angles of %s";
  static const char szAngleUnit[]= "angles of %s\nin %s";
  static const char szAngleUnitEZ[]= "angles of %s";
  static const char szAngleOmegaUnit[]= "angles of\n%s\nin %s";
  static const char szAngleOmegaUnitEZ[]= "%s";
  static const char szEnergy[]=         "channels";
  static const char szFrequentLi[]=     "frequents\nlinear scaling";
  static const char szFrequentLo[]=     "frequents\nlog10 scaling";

  static const char szMsgLine312[]= "A continuous Psd-Spectrum is displayed.\nIn order to run PSD-Calibration this display need to be stopped.\n\nDo you wish to stop the Psd-Spectrum automatic now?";
  static const char szMsgLine313[]= "reading fileheader...";
  static const char szMsgLine314[]= "translating measurementdata...";
#endif

//#############################################################################
// TAreaScanParameters
//#############################################################################

//! einlesen der Ini-daten zu [AreaScan] und setzen von default-werten fuer AreaScan
//! wird nur durch TAreaScanWindow-konstruktor aufgerufen
TAreaScanParameters::TAreaScanParameters() : Detector(0), Monitor(0)
{
	char Ident[10];
	strcpy(Ident, "AreaScan");
	char buf[ MaxString ];
	int nOldId= mlGetAxis();

	//! setzen von Defaultwerten
	strcpy( DataFile, "*.dtn" );
	eScanType= stOmega2ThetaScan;

	// Initialisieren der Auswahlbox mit dem ersten nutzbaren PSD
	SetDetector( TDetectorManager::DetectorManager().GetDetector(0, 1) );
	Monitor= 0;

	if (GetPsd() != 0)
		nAddedChannels= GetPsd()->GetAddedChannels();
	else
		nAddedChannels= 1;

	bThetaAddsPsd= TRUE;
	fMaxTime= 6.0;
	dwMaxCounts= 30000l;
	eSaveFormat= ffStandardFile;
	bSaveOnReady= FALSE;
	bSaveContinuous= FALSE;
	dMoveRelation= 2.0;
	nOmega= mlGetIdByName( Omega );
	nTheta= mlGetIdByName( Theta );
	bAbsorberUsed= FALSE;
	//! Werte fuer Datenbasis-Zusammensetzung
	strcpy( FirstFile, "Kurve whlen!" );
	strcpy( LastFile, "TESTXXXX.CRV" );
	MaxFiles= 0;

	ResetPosition();

	//! einlesen der Daten aus dem [AreaScan]-Abschnitt des Ini-Files
	GetPrivateProfileString( Ident, "ExposureTime", "1.0", buf, MaxString, GetCFile() );
	fMaxTime= atof( buf );
	if ( CreateDefaults() )
		WritePrivateProfileString( Ident, "ExposureTime", buf, GetCFile() );

	//! FIX Fehler 37
	bSaveOnReady= GetPrivateProfileInt(Ident, "SaveOnReady", 1, GetCFile() );
	//! FIX Fehler 56
	//21.04.2004 eNotifyValue= nvIntegralIntensity;
	//! auskommentiert von s.berndt j.ullrich
	//! mit physikern noch zu klaeren, ob ganz entfernen oder aenderungswunsch
	/*24.04.2004 GetPrivateProfileString( Ident, "Report", "Integral", buf, MaxString,
	                          GetCFile() );
	strupr( buf );
	//! festlegen, welche Informationen neben dem Omegawinkel und dem Thetawinkel
	//! als 3. wert im Scanreport gespeichert werden soll
	while ( 1 ) {
	  eNotifyValue= PeakPosition;
	  if ( !strcmp( buf, "MONITOR" ) ) {
	    eNotifyValue= MonitorIntensity; 
	    if ( ! TDList::DetectorList().->IsDetectorValid( MonitorDetector ) ) {
	      MessageBox( GetFocus(), szMsgLine016, szMessage, MBINFO );
	      break;
	    }
	    Monitor= TDList::DetectorList().->GetDetectorPtr( ptrDetectorList->GetIdByName( MonitorDetector ) );
	    break;
	  }
	  if ( !strcmp( buf, "ABSORBER" ) ) {
	    eNotifyValue= AbsorberPosition;
	    break;
	  } 
	  if ( !strcmp( buf, "INTEGRAL" ) ) {
	    eNotifyValue= IntegralIntensity;
	    break;
	  }
	  if ( !strcmp( buf, "TIME" ) ) {
	    eNotifyValue= MeasurementTime;
	    break;
	  } 
	  if ( !strcmp( buf, "PEAK" ) ) {
	    eNotifyValue= PeakPosition;
	    break;
	  }
	  break;
	}  */ 
	//! ermittelt Einheit des Thetamotors und Winkelwert eines Kanals + setzt den
	//! Motor , der zu Begin der Funktion gesetzt war

	mlSetAxis( nOldId );
	//! o-t-offset init.
	dOffsetOmega= dOffsetTheta= 0.0;

	//! psd-offset + Messkanalnr. ini.
	dPsdOffset= 0.0;
	nMeasurementChannel= 0;

	//! neu akk
	//! standardmaessig nicht akkumuliert darstellen
	bAccumulatedDisplay= FALSE;

	ReportUse.bMonitor= ReportUse.bAbsorber= ReportUse.bTime= ReportUse.bIntegral= FALSE;

	// ehemalig extern-Verweise aus A_INTERN.CPP
	strcpy(DataFile, "");
	bAquisitionActive= FALSE;
	nLinePoints= 100;
	bSetDXZero= bSetDYZero= bSetRLSave= FALSE;
	nEnvironment= 0;

	// ehemalig static in A_EXTERN.CPP
	strcpy(szODF, "");
	strcpy(szOWF, "");
	strcpy(szTDF, "");
	strcpy(szTWF, "");
	strcpy(DismantleFile, "");
};
//*****************************************************************************

void TAreaScanParameters::ResetPosition() {
	if (GetPsd() != 0) {
		fPsdRange= GetPsd()->GetAngleRange();
		nFirstReadColumn= GetPsd()->GetFirstChannel();
		nLastReadColumn= GetPsd()->GetLastChannel();
	} else {
		fPsdRange= 0;
		nFirstReadColumn= 0;
		nLastReadColumn= 0;
	}

	//! Omegamotor und zugehoerige Werte setzen
	mlSetAxis( nOmega );
	dOmegaWidth= mGetValue( Width );
	if ( !mGetDistance( dOmegaMin ) )
		dOmegaMin= mGetValue(MinDistanceRel);
	dOmegaMax= min( mGetValue(MaxDistanceRel), dOmegaMin+4.0 );

	//! Thetamotor und zughoerige Werte setzen
	mlSetAxis( nTheta );
	dThetaWidth= max( mGetValue(MinWidth), mGetValue(Width) ); // 27.07.2004 dMoveRelation * dOmegaWidth
	if ( !mGetDistance( dThetaMin ) )
		dThetaMin= mGetValue(MinDistanceRel);
	dThetaMin= max( mGetValue(MinDistanceRel), min( mGetValue(MaxDistanceRel), dThetaMin));  // 27.07.2004 dMoveRelation * dOmegaMin
	dThetaMax= max( mGetValue(MinDistanceRel), min( mGetValue(MaxDistanceRel), dThetaMin+CalcValueInUnit(mlGetUnit(nTheta), fPsdRange))); // 27.07.2004 dMoveRelation * dOmegaMax
	dThetaWindow= dThetaMax - dThetaMin;
	d2ThetaStart= dThetaMin;
}
//*****************************************************************************

TOneDimDetector* TAreaScanParameters::GetPsd()
{
	if (!Detector)
		return 0;
	if (Detector->GetDimension() != 1)
		return 0;
	return dynamic_cast<TOneDimDetector*>(Detector);
}

//#############################################################################
// TAreaScanWindow
//#############################################################################

//! registr. des ScanFensters und das ScanFensterMenue erstellen
//! setzen von weiteren Defaultwerten
TAreaScanWindow::TAreaScanWindow( HINSTANCE aInstance ) : TAreaScanParameters(), TPlotWindow(aInstance), ScanReport(0), ScanReport2(0), oldDetector(0)
{
	bInterrupted= FALSE;
	bCalibrationActive= FALSE;
	bShowPsdContinuous= FALSE;
	m_PsdContinousType= PsdUnknown;
	bSaveContinuous= FALSE;
	bThetaScanCompleted= FALSE;
	//! keine DB-Zusammensetzung
	bComposeDB= FALSE;
	LowerBound= 0.5;
	UpperBound= 800.0;
	WindowType= wtAreaScan;
	bAreaScanStarted= FALSE; 

	//! erstellen der Meneintraege des Areascanfensters
	hHoleMenu= LoadMenu(GetMainInstance(), MAKEINTRESOURCE(menu_AreaScan));
    // Fix fr PopupMens aus Ressourcen (Dummy Popup)
    TheMenu= GetSubMenu(hHoleMenu, 0); 

	// Fuer TPlotWindow
	LowerBound= 0.1f;
	UpperBound= 10000.0f;
	bXY_Scaling= TRUE;
	// pointer to output formats
	mlSetAxis( nOmega );
	strcpy( szODF, mGetDF() );
	strcpy( szOWF, mGetSF() );
	mlSetAxis( nTheta );
	strcpy( szTDF, mGetDF() );
	strcpy( szTWF, mGetSF() );

	ResetPosition(); // ruft auch TAreaScanParameters::ResetPosition() und initialisiert m_MotorUnit und m_DetektorUnit

	//! alt // Reportstruktur fuer Absorber-Position, Omega und ???
	//! initial. der Datenbasis + zusatzinfos
	ScanReport= lpDBase->GetScanReport();
	ScanReport2= new TCurve;
	
	/*lpDBase->New();
	nActiveScan= 0;
	MainCurve= lpDBase->GetCurve( nActiveScan );

	bOldDataLoaded= FALSE;
	//! FIX Fehler 39
	VisualDB.dThetaWindow= dThetaWindow;
	VisualDB.dMoveRelation= dMoveRelation;
	VisualDB.dOmegaMin= dOmegaMin;
	VisualDB.dOmegaMax= dOmegaMax;
	if ( GetPsd() != 0 ) {
		VisualDB.bPsd= TRUE;
		VisualDB.fAngleRange= GetPsd()->GetAngleRange();
		VisualDB.fAngleStep= GetPsd()->GetAngleStep();
	} else {
		VisualDB.bPsd= FALSE;
		VisualDB.fAngleRange= dThetaWindow;
		VisualDB.fAngleStep= dThetaWindow / dThetaWidth;
	}
	VisualDB.dThetaMinFirst= dThetaMin;
	VisualDB.dThetaMaxFirst= dThetaMin + (dOmegaMax - dOmegaMin) / dOmegaWidth * dOmegaWidth * dMoveRelation;*/
	New();

	VisualDB.dThetaMinLast= dThetaMin + VisualDB.fAngleRange;
	VisualDB.dThetaMaxLast= VisualDB.dThetaMaxFirst + VisualDB.fAngleRange;

	//! Scanstart ist erlaubt (param. ungueltig)
	//! FIX Fehler 77
	bScanSetupOk= FALSE;

	oldDetector= TDetectorManager::DetectorManager().GetDetector();

	// neu Kullmann, Reinecker
	bFirstScan= TRUE;
	bSavedSecondaryCoor = bSecondaryCoor; 
	strcpy(m_RepFileName, "");
};
//*****************************************************************************

//! loeschen der Datenbasis ,des Menues und speichern von Werten in der Ini-Datei
TAreaScanWindow::~TAreaScanWindow()
{
	char buf[ MaxString ];
	RECT rc, rcm;

	// Messung/ kont. Spektrenanzeige stoppen (falls aktiv)
	Interrupt();

	lpDBase->New();
	//! loeschen des Fenstermenue + senden von Detektorsignalen an das
	//! AreaScanfenster beenden
	if (Detector != 0)
	{
		Detector->MeasureStop();
		Detector->SetControlWnd( NULL );
	}
	if (Monitor != 0)
	{
		Monitor->MeasureStop();
		Monitor->SetControlWnd( NULL );
	}

	//! AreaScanfenster-eigenschaften sowie Datenpfad,Messzeit und SaveOnReady in
	//! Ini-File ablegen
	GetWindowRect( GetFrameHandle(), &rcm );
	GetWindowRect( GetHandle(), &rc );
	sprintf( buf, "%d", rc.left - rcm.left - 4 );
	WritePrivateProfileString( "AreaScan", "xo", buf, GetCFile() );
	sprintf( buf, "%d", rc.top - rcm.top - 42 );
	WritePrivateProfileString( "AreaScan", "yo", buf, GetCFile() );
	sprintf( buf, "%d", rc.right - rc.left );
	WritePrivateProfileString( "AreaScan", "dx", buf, GetCFile() );
	sprintf( buf, "%d", rc.bottom - rc.top );
	WritePrivateProfileString( "AreaScan", "dy", buf, GetCFile() );
	WritePrivateProfileString( "AreaScan", "DataPath", szDataPath, GetCFile() );
	sprintf( buf, "%.2f", fMaxTime );
	WritePrivateProfileString( "AreaScan", "ExposureTime", buf, GetCFile() );
	sprintf( buf, "%d", bSaveOnReady );
	// Kanal- oder Winkeldarstellung: zuletzt benutze Darstellungsoption speichern
	IniWriteBool( GetCFile(), "AreaScan", "ChannelsOnXAxis", bSecondaryCoor );

	//! Hauptfensterverweis auf AreaScanfenster loeschen + datenbasis loeschen
	Main.hAreaScanWindow= NULL;
	Main.AreaScanWindow= NULL;

	TDetectorManager::DetectorManager().SetDetector(oldDetector);
	if ( oldDetector ) oldDetector->MeasureStart();

	_FREEOBJ(ScanReport2); 
};
//*****************************************************************************

//! Darstellen des AreaScan-Fenster
void TAreaScanWindow::OnCreate()
{
	RECT rc;

	Main.hAreaScanWindow= GetHandle();
	Main.AreaScanWindow= this;

	// HotKey's fr F1
	LoadHotKeys( LoadAccelerators(GetMainInstance(), MAKEINTRESOURCE(ACC_AreaScan)) ); // Accelerator aus Ressourcen laden

	Delay( 2000 );

	//! einlesen der Fenstereigenschaften, des Datenpfades aus dem
	//! [AreaScan]-Abschnitt des Ini-Files
	rc.left= GetPrivateProfileInt( "AreaScan", "xo", 500, GetCFile() );
	rc.top= GetPrivateProfileInt( "AreaScan", "yo", 400, GetCFile() );
	rc.right= rc.left + GetPrivateProfileInt( "AreaScan", "dx", 170, GetCFile() );
	rc.bottom= rc.top + GetPrivateProfileInt( "AreaScan", "dy", 50, GetCFile() );
	GetPrivateProfileString( "AreaScan", "DataPath", "c:\\", szDataPath, MaxString, GetCFile() );
	if ( szDataPath[ max(0, strlen(szDataPath)-1) ] != '\\' )
		strcat( szDataPath, "\\" );
	// Kanal- oder Winkeldarstellung: zuletzt benutze Darstellungsoption wiederherstellen
	bSecondaryCoor = IniReadBool( GetCFile(), "AreaScan", "ChannelsOnXAxis", FALSE );

	//! setzen der Filter und der Extension
	strcpy( szFilter, "HRM Standard (*.psd)|*.psd||" );
	strcpy( szExtension, "psd" );

	//! Titelzeile des Fensters bestimmen +
	//! darstellen des Scanfensters
	SetTitle();
	SetWindowPos( GetHandle(), NULL, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, SWP_NOZORDER );
};
//*****************************************************************************

void TAreaScanWindow::ResetPosition() {
	TAreaScanParameters::ResetPosition();

	// umrechnen in Detektoreinheiten
	m_MotorUnit= mlGetUnit(nTheta);
	if ( GetPsd() ) m_DetectorUnit= GetPsd()->GetUnit();
	else m_DetectorUnit= utNone;
}
//*****************************************************************************

void TAreaScanWindow::InitializeAreaScanTask() {
	char buf[ 101 ];
	//klier 03.03.2003
	char bufPro[MaxString];
	char fmt[ MaxString ];
	char msg[ 101 ];

	//! Scan nicht bei kont. Anzeige erlaubt
	if ( bShowPsdContinuous )
	{
		if ( MessageBox(sth_StopContiniousPsd, szMsgLine208, MBASK) != IDYES ) return; // Spektrenanzeige nicht automatisch stoppen
		StopSensorContinuous(); // erst kont. Spektrenanzeige stoppen
	}
	// Alte Daten sichern bzw. neuen Namen vergeben
	//! test ob die Anzahl der Erwarteten Scans die max. Kapaz. der Datenbasis
	//! ueberschreitet
	if ( ( ( dOmegaMax - dOmegaMin ) / dOmegaWidth ) > lpDBase->GetMaxScanNumber() )
	{
		sprintf( msg, szMsgLine008, lpDBase->GetMaxScanNumber() );
		MessageBox( msg, szMsgLine208, MBSTOP );
		return;
	}
	//! FIX Fehler 44
	dThetaOffset= 0.0;
	// Motoren initialisieren
	mlSetAxis( nOmega );
	mSetValue( Speed, 10000.0 );

	//! wenn omega-relativ abfrage ob relative Null zuruecksetzen
	if ( eScanType==stOmega2ThetaScan && mIsDistanceRelative() ) {
		strcpy( msg, szMsgLine007 );
		if ( IDYES != MessageBox( msg, szMsgLine208, MBASK ) )
			mSetRelativeZero( FALSE, 0.0 );
	}
	mlSetAxis( nTheta );
	mSetValue( Speed, 10000.0 );
	//! wenn theta-relativ abfrage ob relative Null zuruecksetzen
	if ( eScanType==stOmega2ThetaScan && mIsDistanceRelative() ) {
			strcpy( msg, szMsgLine006 );
			if ( IDYES != MessageBox( msg, szMsgLine208, MBASK ) )
			{
				mSetRelativeZero( FALSE, 0.0 );
				dThetaOffset= 0.0;
			}
			else dThetaOffset= 0.0; // 03.06.2003 dThetaOffset= mlGetOffset( nTheta ); VERSUCH Positionsausgabe-Problem bei Scan mit Thetaoffset zu beheben
	}
	//! auswahl des Scanstartdialogs
	switch ( eScanType )
	{
		case stOmega2ThetaScan:
			if ( GetPsd() == 0)
			{
				sprintf( fmt, szMsgLine004, szODF, szODF );
				dThetaOffset= 0.0;
			}
			else
				sprintf( fmt, szMsgLine003, szODF, szODF );
			break;

		case stStandardScan:
			if ( GetPsd() == 0)
				break;
			sprintf( fmt, szMsgLine005, szODF, szODF );
			break;

		default:
			return;
	}
	//! dialog anzeigen
	sprintf( msg, fmt, dOmegaMin, dOmegaMax );
	if ( IDNO == MessageBox( msg, szMsgLine208, MBASK ) )
		return;

	//! FIX Fehler 70
	lpDBase->New();
	//! FIX Fehler 32
	if ( bSaveOnReady || bSaveContinuous)
		SaveFile( atNewName );

	//klier 03.03.2003
	if (MessageBox( szMsgLine032, szMessage, MBASK ) == IDYES)
	{
		SetProtocolDiffractometryOn();
		SetMeasurementProtocolParameter();
		if (bSaveContinuous || bSaveOnReady)
			SetProtocolDiffractometryMessdatei(FileName);
		SetProtocolDiffractometryNutzer(MeasurementParameter.GetUser());
		SetProtocolDiffractometryScanart("AreaScan");
		SetProtocolDiffractometryScanmethode("StepScan");
		if (dThetaMin != dThetaMax)
			SetProtocolDiffractometryScantyp("Omega2Theta");
		else
			SetProtocolDiffractometryScantyp("Omega");
		SetProtocolDiffractometryScanachse1("Omega");
		SetProtocolDiffractometryScanachse2("Theta");

		SetProtocolDiffractometryDetektor(Detector->GetCharacteristic());
		//		  SetProtocolDiffractometryDetektor(Detector->GetDimension());

		if ( GetPsd() != 0)
		{
			SetProtocolDiffractometryWinkelbereich( GetPsd()->GetAngleRange() );
			SetProtocolDiffractometryKanalabstand( GetPsd()->GetAngleStep() );
			//				 SetProtocolDiffractometryMesskanal( GetPsd()->GetWidth() );
			//				 SetProtocolDiffractometryAddiere( GetPsd()->GetAddedChannels() );
			SetProtocolDiffractometryMesskanal( nMeasurementChannel );
			SetProtocolDiffractometryAddiere( nAddedChannels );
		}
		if (Monitor != 0)
			SetProtocolDiffractometryMonitor(Monitor->GetCharacteristic());
		else
			SetProtocolDiffractometryMonitor("-");
		SetProtocolDiffractometryMesszeit(fMaxTime);
		SetProtocolDiffractometryImpulse(dwMaxCounts);

		sprintf(bufPro, szODF, dOmegaMin);
		SetProtocolDiffractometryMinimum1(bufPro);
		sprintf(bufPro, szOWF, dOmegaWidth);
		SetProtocolDiffractometrySchrittweite1(bufPro);
		sprintf(bufPro, szODF, dOmegaMax);
		SetProtocolDiffractometryMaximum1(bufPro);
		sprintf(bufPro, szODF, d2ThetaStart);
		SetProtocolDiffractometryMinimum2(bufPro);
		if (dThetaMin != dThetaMax)
		{
			sprintf(bufPro, szODF, dMoveRelation*dOmegaMax + d2ThetaStart);
			SetProtocolDiffractometryMaximum2(bufPro);
			sprintf(bufPro, szOWF, dMoveRelation*dOmegaWidth);
			SetProtocolDiffractometrySchrittweite2(bufPro);
		}
		else
		{
			sprintf(bufPro, szODF, d2ThetaStart);
			SetProtocolDiffractometryMaximum2(bufPro);
			SetProtocolDiffractometrySchrittweite2("");
		}

		ViewOnProtocolDiffractometryDlg();
	}
	else
		SetProtocolDiffractometryOff();

	// Sensoren initialisieren
	//JP wird von Steering.Reset als ersten Schritt getan
	//Detector->MeasureStop();
	bAreaScanStarted= FALSE; // fr Steering.Reset() abschalten
	Steering.Reset();
	bAreaScanStarted= TRUE; // nach Steering.Reset() wieder einschalten
	Steering.StartUp( GetHandle(), nOmega, Detector );
	//! Werte an Detektor
	Detector->SetControlWnd( GetHandle() );
	Detector->SetExposureSettings( TExposureSettings(fMaxTime, dwMaxCounts) );
	Detector->SetParameters();

	//! Monitordetektor initialisieren wenn als zusatzinfo gewollt
	if (Monitor != 0)
	{
		if ( Monitor == Detector )
		{
			sprintf( buf, szMsgLine002, Detector->GetCharacteristic() );
			MessageBox( buf, szMsgFailure, MBSTOP );
			return;
		}
		Monitor->MeasureStop();
		Monitor->SetControlWnd( GetHandle() );
		Monitor->SetExposureSettings( TExposureSettings(fMaxTime * 0.8, dwMaxCounts) );
	}

	// ******* Alte Daten verwerfen *********************************************
	bFirstScan= TRUE;
	//! Darstellungsoptionen fuer Scan setzen
	Steering.Visualising( FALSE, FALSE );	//Fortschritt in Statuszeile ausgeben
	//! einstellen psd-spez. werte
	switch ( eScanType )
	{
		case stOmega2ThetaScan:
			if ( GetPsd() != 0 )
			{
				//! art der Kurvenaktualisierung einstellen
				GetPsd()->SetSignalGrowUp( bAccumulatedDisplay ); //! neu akk
				//! einstellen der Anzahl der zusammenzufassenden Kanaele
				GetPsd()->SetAddedChannels( nAddedChannels );
				//! winkelbereich eines Spektrums ermitteln bei psd
				fPsdRange= GetPsd()->GetAngleRange();

				//! winkelbereich eines Spektrums ermitteln bei 0-dim. Det.
				//! Anweisungen sind doppelt
				GetPsd()->SetSignalGrowUp( bAccumulatedDisplay ); //! neu akk
				GetPsd()->SetAddedChannels( nAddedChannels );
				strcpy( buf, "" );
				//! Scan starten
				Steering.StartCmdExecution( Scan, ForAreaScan, stOmega2ThetaScan, buf, GetHandle() );
			} else {
				fPsdRange= dThetaWindow;
				bThetaScanCompleted= FALSE;
				mlSetAxis( nTheta );
				//!				mSetRelativeZero( TRUE, mGetValue( Distance ) );
				mlSetAxis( nOmega );
				//!				mSetRelativeZero( TRUE, mGetValue( Distance ) );
				strcpy( buf, "" );
				//! Scan starten
				Steering.StartCmdExecution( AreaScan, stOmega2ThetaScan, 0, buf, GetHandle() );
			}
			break;

		case stStandardScan:
			if ( GetPsd() == 0 )
			{
				SetInfo( szMsgLine025 );
				return;
			}
			//! art der Kurvenaktualisierung einstellen
			GetPsd()->SetSignalGrowUp( bAccumulatedDisplay ); //! neu akk
			//! einstellen der Anzahl der zusammenzufassenden Kanaele
			GetPsd()->SetAddedChannels( nAddedChannels );
			//! winkelbereich eines Spektrums ermitteln bei Psd
			fPsdRange= GetPsd()->GetAngleRange();
			GetPsd()->SetSignalGrowUp( bAccumulatedDisplay ); //! neu akk
			GetPsd()->SetAddedChannels( nAddedChannels );
			strcpy( buf, "" );
			//! Scan starten
			Steering.StartCmdExecution( Scan, ForAreaScan, stStandardScan, buf, GetHandle() );
			break;
	}
	//! akt.Kurve loeschen + AreaScan als aktiv kennzeichnen
	MainCurve->New();
	bMeasurementActive= TRUE;
}
//*****************************************************************************

void TAreaScanWindow::DoDataAquisition() {
	TModalDlg *dlg= 0;
	if ( bAquisitionActive )
	{
		int hFile; //! FILE * hFile;
		char buf[ MaxString ];
		int cnt, env, row, column;
		float Odelta, Tdelta, x, y, z, offset, value;
		double yDelta, xDelta, Omega, Theta, rlxDelta, rlyDelta;
		TCurve *Scan;
		bAquisitionActive= FALSE;
		OFSTRUCT of;

		SetRanges();

		//! Punkte ausserhalb des Koordinatensystems nicht zulassen
		if ( mPoint1.x > AltCoorSys.xMax || mPoint2.x > AltCoorSys.xMax ||
			 mPoint1.y > AltCoorSys.yMax || mPoint2.y > AltCoorSys.yMax ||
			 mPoint1.x < AltCoorSys.xMin || mPoint2.x < AltCoorSys.xMin ||
			 mPoint1.y < AltCoorSys.yMin || mPoint2.y < AltCoorSys.yMin )
		{
			MessageBox(szMsgLine200, szMsgFailure, MBINFO );
			return;
		}
		//! Beruecksichtigen, ob Gerade horizontal oder vertikal und nicht frei Hand...
		if (bSetDYZero)
			mPoint2.y= mPoint1.y;
		if (bSetDXZero)
			mPoint2.x= mPoint1.x;

		yDelta= (mPoint2.y - mPoint1.y) / nLinePoints;
		xDelta= (mPoint2.x - mPoint1.x) / nLinePoints;

		//! wenn Abstand der Messpunkte nicht gross genug...
		if ((fabs(yDelta) < 1e-7) && (fabs(xDelta) < 1e-7))
		{
			MessageBox(szMsgLine201, szMsgFailure, MBINFO );
			return;
		}

		//*** Point0 and Point1 are valid
		//! TData Struktur speichert errechnete Werte...
		TData *lpData= (TData*) new TData[nLinePoints];
		//! Berechnung der Punkte der Gerade je nach Darstellungstyp
		switch (eOutputType)
		{
			case otReciprokeLatticeBitmap:
				lpData[0].dX= mPoint1.x;
				lpData[0].dY= mPoint1.y;
				lpData[nLinePoints - 1].dX= mPoint2.x;
				lpData[nLinePoints - 1].dY= mPoint2.y;
				lpData[0].fDelta= lpData[0].fIntensity= 0.0;
				lpData[nLinePoints - 1].fDelta= lpData[nLinePoints - 1].fIntensity= 0.0;

				//! Zeile und Spalte im Bitmap berechnen
				row= (mPoint1.y - AltCoorSys.yMin) / AltCoorSys.ySF;
				column= (mPoint1.x - AltCoorSys.xMin) / AltCoorSys.xSF;

				//! Omega und Theta aus dem "Daten"Feld holen - Theta ist ohne Offset gespeichert
				if ( BSource->IsDatenInited() )
				{
					lpData[0].dOmega= BSource->GetOmega(row, column);
					lpData[0].dTheta= BSource->GetTheta(row, column);
				} else {
					lpData[0].dOmega= 0;
					lpData[0].dTheta= 0;
				}
				lpData[0].dX= mPoint1.x;
				lpData[0].dY= mPoint1.y;

				//! Zeile und Spalte im Bitmap berechnen
				row= (mPoint2.y - AltCoorSys.yMin) / AltCoorSys.ySF;
				column= (mPoint2.x - AltCoorSys.xMin) / AltCoorSys.xSF;

				//! Omega und Theta aus dem "Daten"Feld holen - Theta ist ohne Offset gespeichert
				if ( BSource->IsDatenInited() )
				{
					lpData[nLinePoints - 1].dOmega= BSource->GetOmega(row, column);
					lpData[nLinePoints - 1].dTheta= BSource->GetTheta(row, column);
				}
				else
				{
					lpData[nLinePoints - 1].dOmega= 0;
					lpData[nLinePoints - 1].dTheta= 0;
				}

				lpData[nLinePoints - 1].dX= mPoint2.x;
				lpData[nLinePoints - 1].dY= mPoint2.y;

				//! nLinePoints gibt an, wieviele Messpunkte auf der Gerade liegen sollen...
				yDelta= (lpData[nLinePoints - 1].dOmega - lpData[0].dOmega) / nLinePoints;
				xDelta= (lpData[nLinePoints - 1].dTheta - lpData[0].dTheta) / nLinePoints;
				rlxDelta= (lpData[nLinePoints - 1].dX - lpData[0].dX) / nLinePoints;
				rlyDelta= (lpData[nLinePoints - 1].dY - lpData[0].dY) / nLinePoints;

				for (cnt= 0; cnt<nLinePoints-1; cnt++)
				{
					lpData[cnt + 1].fDelta= lpData[cnt + 1].fIntensity= 0.0;
					lpData[cnt + 1].dOmega= lpData[cnt].dOmega + yDelta;
					lpData[cnt + 1].dTheta= lpData[cnt].dTheta + xDelta;
					lpData[cnt + 1].dX= lpData[cnt].dX + rlxDelta;
					lpData[cnt + 1].dY= lpData[cnt].dY + rlyDelta;
				}
				break;

			case otMatrixBitmap:
				//! nLinePoints gibt an, wieviele Messpunkte auf der Gerade liegen sollen...
				lpData[0].dTheta= mPoint1.x;
				lpData[0].dOmega= mPoint1.y;
				lpData[0].fDelta= lpData[0].fIntensity= 0.0;
				for (cnt= 1; cnt<nLinePoints; cnt++)
				{
					lpData[cnt].fDelta= lpData[cnt].fIntensity= 0.0;
					lpData[cnt].dOmega= lpData[cnt - 1].dOmega + yDelta;
					lpData[cnt].dTheta= lpData[cnt - 1].dTheta + xDelta;
				}
				break;
		} // switch (eOutputType)


		//*** search the related intensities
		//! berechnen der fehlenden Einheiten
		switch (eOutputType)
		{
			case otReciprokeLatticeBitmap:
				for (cnt= 0;cnt < nLinePoints;cnt++)
				{
					Omega= lpData[cnt].dOmega;
					Theta= lpData[cnt].dTheta;
					row= ScanReport->GetValueByValue(Omega, Odelta, offset);
					//** reverse connection between psd and theta-axis
					//! Omega-=Odelta;
					Scan= lpDBase->GetCurve(row);

					//** pick out the intensity
					column= Scan->GetValueByValue(Theta, Tdelta, value);

					//! Theta-Offset beruecksichtigen
					if (VisualDB.bPsd)
						lpData[cnt].dTheta= Theta + GetThetaOffset(row);
					else
						lpData[cnt].dTheta= Theta + GetThetaOffset(row) - VisualDB.dThetaMinFirst;

					//! Theta-=Tdelta;
					//! lpData[cnt].fIntensity=value;
					value= 0;
					//! nEnvironment liegt immer zwischen 0-3
					env= nEnvironment;
					//! beruecksichtigen der gewuenschten Umgebungsmesspunkte,
					//! damit eventuelle krasse Intensitaetsunterschiede wegfallen
					//! berechne Intensitaet
					if (Tdelta > Odelta)
						while (env + 1)
						{
							Scan->SetPP(column + env);
							Scan->PGet(x, y, z);
							value += y;
							Scan->SetPP(column - env);
							Scan->PGet(x, y, z);
							value += y;
							env--;
						}
					else
						while (env + 1)
						{
							Scan= lpDBase->GetCurve(row + env);
							Scan->SetPP(column);
							Scan->PGet(x, y, z);
							value += y;
							Scan= lpDBase->GetCurve(row - env);
							Scan->SetPP(column);
							Scan->PGet(x, y, z);
							value += y;
							env--;
						}
					//! bilde arithmetisches Mittel der Intensitaeten
					lpData[cnt].fIntensity= value / ((nEnvironment + 1) * 2);
					//! quadriere Deltas, damit sich pos./neg. Werte nicht gegenseitig aufheben
					lpData[cnt].fDelta= sqrt(pow(Odelta, 2) + pow(Tdelta, 2));
				}
				break;
		
			case otMatrixBitmap:
				for (cnt= 0;cnt < nLinePoints;cnt++)
				{
					Omega= lpData[cnt].dOmega;
					row= ScanReport->GetValueByValue(Omega, Odelta, offset);
					Theta= lpData[cnt].dTheta;

					if (VisualDB.bPsd)
					{
						//! Theta-Offset beruecksichtigen
						Theta= lpData[cnt].dTheta - (GetThetaOffset(row) - VisualDB.dThetaMinFirst);
						Theta -= AltCoorSys.xMin;
					}

					Scan= lpDBase->GetCurve(row);
					//! Omega-=Odelta;
					//** pick out the intensity
					column= Scan->GetValueByValue(Theta, Tdelta, value);
					//! Theta-=Tdelta;
					//! Omega und Theta in RL Koordinaten umrechnen
					Omega= DegToRad(Omega);
					Theta= DegToRad(lpData[cnt].dTheta);
					lpData[cnt].dX= ArToRLx(Omega, Theta) * (M_PI / (0.5* \
									 MeasurementParameter.GetWaveLength()));
					lpData[cnt].dY= ArToRLy(Omega, Theta) * (M_PI / (0.5* \
									 MeasurementParameter.GetWaveLength()));
					//! lpData[cnt].fIntensity=value;
					value= 0;
					//! nEnvironment liegt immer zwischen 0-3
					env= nEnvironment;
					//! beruecksichtigen der gewuenschten Umgebungsmesspunkte,
					//! damit eventuelle krasse Intensitaetsunterschiede wegfallen
					//! berechne Intensitaet
					if (xDelta > yDelta)
						while (env + 1)
						{
							Scan->SetPP(column + env);
							Scan->PGet(x, y, z);
							value += y;
							Scan->SetPP(column - env);
							Scan->PGet(x, y, z);
							value += y;
							env--;
						}
					else
						while (env + 1)
						{
							Scan= lpDBase->GetCurve(row + env);
							Scan->SetPP(column);
							Scan->PGet(x, y, z);
							value += y;
							Scan= lpDBase->GetCurve(row - env);
							Scan->SetPP(column);
							Scan->PGet(x, y, z);
							value += y;
							env--;
						}
					//! bilde arithmetisches Mittel der Intensitaeten
					lpData[cnt].fIntensity= value / ((nEnvironment + 1) * 2);
					//! quadriere Deltas, damit sich pos./neg. Werte nicht gegenseitig aufheben
					lpData[cnt].fDelta= sqrt(pow(Odelta, 2) + pow(Tdelta, 2));
				}
				break;
		} // switch

		//! Daten speichern
		hFile= OpenFile( DataFile, &of, OF_CREATE ); //! hFile=fopen(DataFile,"w");
		if ( hFile == HFILE_ERROR )
		{
			MessageBox(szMsgLine204, szMessage, MBINFO );
			_FREELIST(lpData);
			return;
		}
		//! ergaenzt um Header und Data Info
		_lwrite(hFile, szMsgLine202, strlen(szMsgLine202)); //! fwrite( buf,strlen(buf),1,hFile);
		//! FileType mit eingefuehrt - TScanWindow.eSaveFormat=dtnFile (beim Einlesen)
		sprintf( buf, "FileType=Aquisition\n", FileName );
		_lwrite(hFile, buf, strlen(buf)); //! fwrite( buf,strlen( buf ), 1,hFile );
		sprintf( buf, "Source= %s\n", FileName );
		_lwrite(hFile, buf, strlen(buf)); //! fwrite(buf,strlen(buf),1,hFile );

		//! Abfrage RL oder normale Koordinaten speichern
		if (!bSetRLSave)
		{
			sprintf( buf, "Omega Intens. Theta RLY RLX Delta\n", FileName );
			_lwrite(hFile, buf, strlen(buf)); //! fwrite( buf,strlen(buf),1,hFile );

			_lwrite(hFile, szMsgLine205, strlen(szMsgLine205)); //! fwrite(buf,strlen(buf),1,hFile);

			sprintf(buf, "[Data]\n", FileName);
			_lwrite(hFile, buf, strlen(buf)); //! fwrite(buf,strlen(buf),1,hFile);

			//! Unterscheidung eingebaut, damit Omega aufsteigend abgespeichert
			if (lpData[0].dOmega < lpData[nLinePoints - 1].dOmega)
				for (cnt= 0;cnt < nLinePoints;cnt++)
				{
					sprintf( buf, "%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f",
							 lpData[cnt].dOmega, lpData[cnt].fIntensity, lpData[cnt].dTheta, lpData[cnt].dY, lpData[cnt].dX, lpData[cnt].fDelta );
					strcat(buf, EOL);
					_lwrite(hFile, buf, strlen(buf)); //! fwrite(buf,strlen(buf),1,hFile );
				}
			else
				for (cnt= nLinePoints - 1;cnt >= 0;cnt--)
				{
					sprintf( buf, "%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f",
							 lpData[cnt].dOmega, lpData[cnt].fIntensity, lpData[cnt].dTheta, lpData[cnt].dY, lpData[cnt].dX, lpData[cnt].fDelta);
					strcat(buf, EOL);
					_lwrite(hFile, buf, strlen(buf)); //! fwrite(buf,strlen(buf),1,hFile);
				}
		}
		else
		{ // bSetRLSave==TRUE
			sprintf(buf, "RLY Intens. RLX Omega Theta Delta\n", FileName);
			_lwrite(hFile, buf, strlen(buf)); //! fwrite(buf,strlen(buf),1,hFile);
			_lwrite(hFile, szMsgLine203, strlen(szMsgLine203)); //! fwrite(buf,strlen(buf),1,hFile);

			sprintf(buf, "[Data]\n", FileName);
			_lwrite(hFile, buf, strlen(buf)); //! fwrite(buf,strlen(buf),1,hFile);

			//! Unterscheidung eingebaut, damit RLY aufsteigend abgespeichert
			if (lpData[0].dY < lpData[nLinePoints - 1].dY)
				for (cnt= 0;cnt < nLinePoints;cnt++)
				{
					sprintf( buf, "%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f",
							 lpData[cnt].dY, lpData[cnt].fIntensity, lpData[cnt].dX, lpData[cnt].dOmega, lpData[cnt].dTheta, lpData[cnt].fDelta );
					strcat(buf, EOL);
					_lwrite(hFile, buf, strlen(buf)); //! fwrite(buf,strlen(buf),1,hFile );
				}
			else
				for (cnt= nLinePoints - 1;cnt >= 0;cnt--)
				{
					sprintf( buf, "%.8f\t %.8f\t %.8f\t %.8f\t %.8f\t %.8f",
							 lpData[cnt].dY, lpData[cnt].fIntensity, lpData[cnt].dX, lpData[cnt].dOmega, lpData[cnt].dTheta, lpData[cnt].fDelta);
					strcat(buf, EOL);
					_lwrite(hFile, buf, strlen(buf)); //! fwrite(buf,strlen(buf),1,hFile );
				}
		}
		_lclose(hFile);
		_FREELIST(lpData);

		char *buf2= new char[ strlen(szMsgLine206)+strlen(DataFile)+1 ];
		sprintf(buf2, szMsgLine206, DataFile);
		MessageBox( buf2, szMsgLine207, MBINFO );
		_FREELIST(buf2);
		return;
	}
	dlg= new TAquisitionDlg(this);
	if ( dlg ) dlg->ExecuteDialog( GetHandle() );
	_FREEOBJ(dlg);
	UpdateWnd();
}

LRESULT TAreaScanWindow::OnEvent ( HWND aHandle, UINT message, WPARAM wParam, LPARAM lParam ) {
	switch ( message ) {
		case cm_UpdateRanges:
			SetRanges();
			UpdateWnd();
			return 01;

		default:
			return TPlotWindow::OnEvent( aHandle, message, wParam, lParam );
	}
}

//! behandeln der Windowsbotschaften
LRESULT TAreaScanWindow::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	TModalDlg *dlg= 0;
	WPARAM Cmd= GET_WM_COMMAND_ID(wParam, lParam);
	switch (Cmd)
	{
		case cm_New:  // Hauptmen 
			StopSensorContinuous();
			Steering.Reset();
			bAreaScanStarted= FALSE; // fr Steering.Reset() abschalten
			bInterrupted= FALSE;
			SetFileName("");
			ResetPosition();
			New(); // das alles darf nicht in New() verschoben werden = NUR HIER wenn Menpunkt geklickt wurde
			return 0l;

		//! aufruf der Dialogbox 'Einstellungen AreaScan'
		case cm_SetupAreaScan:
			//! FIX Fehler 74
			if ( !mlIsAxisValid( Omega ) || ((!mlIsAxisValid(Theta) && ! TDetectorManager::DetectorManager().DimAvailable(1))) )
			{
				MessageBox(szMsgLine021, szMsgFailure, MBINFO);
				return 01;
			}
			dlg= ( TSetupAreaScanDlg* ) new TSetupAreaScanDlg( this ); // in dlg_if.cpp
			if ( dlg ) dlg->ExecuteDialog( GetHandle() );
			_FREEOBJ(dlg);
			//! Scanstart ist erlaubt (param. gueltig)
			//! FIX Fehler 77
			bScanSetupOk= TRUE;
			UpdateWnd();
			return 01; // behandelt

		case cm_InitializeAreaScan: // AreaScan starten
			InitializeAreaScanTask();
			return 01; // Botschaft behandelt		

		//! Aufruf durch Menue "Data Aquisition"/"Daten Erhebung"
		//! Benutzer zieht Gerade ueber ein Bitmap und es werden alle
		//! Punkte (Anzahl der Punkte vom Nutzer einstellbar) der Gerade berechnet
		//! Es werden berechnet Theta,Omega,RLX,RLY,Intensitaet,Delta
		//! Delta gibt die gemittelte Abweichung des berechneten Koordinatenpaars
		//! von einem tatsaechlich vorhandenen Messkoordinatenpaar an
		case cm_DataAquisition:
			DoDataAquisition();
			return 01;

		//! 'Choose Scan'
		//! aufruf der Dialogbox zur Auswahl der scans
		case cm_ChooseScan:
			//! FIX Fehler 46
			if (bShowPsdContinuous)
			{
				MessageBox(szMsgLine017, szMessage, MBINFO);
				return 0l;
			}
			//! keine Datenbasis im speicher
			if ( 2 > lpDBase->GetCNumber() )
			{
				MessageBox(szMsgLine031, szMessage, MBINFO);
				return 0l;
			}
			//! neu Kullmann+Reinecker: TheModeless ersetzt durch ChooseScanDlg
			if ( (!ChooseScanDlg) || (!ChooseScanDlg->GetHandle()) )
			{ // !GetHandle() ist wichtig fr den Fall, dass sich das Dialogfenster selbst zerstrt hat !!!
				ChooseScanDlg= ( TChooseScanDlg* ) new TChooseScanDlg( this, &ChooseScanDlg );
				if ( ChooseScanDlg )
					ChooseScanDlg->Initialize( GetMainInstance(), GetFrameHandle() );
			}
			else
				_FREEOBJ(ChooseScanDlg);
			return 0l;

		//! Aufruf Dialog DB-Zusammensetzung
		case cm_ComposeDB:
			ComposeDB();
			return 0l;

		//! Aufruf Dialog DB-Zerlegung
		case cm_DismantleDB:
			DismantleDB();
			return 0l;

		// Aufruf Dialog 'PSD-Kalibrierung'
		case cm_CalibratePsd:   
			CalibratePsd();
			return 0l;

		//! 'Show Energy-Spectrum'
		//! kont. Anzeige des Energiespektrums aktivieren
		case cm_ShowPsdE_Data:
			ShowSensorContinuous( PsdEnergyData );
			return 0l;

		//! 'Show Position-Spectrum'
		//! kont. Anzeige des Positionsspektrums aktivieren
		case cm_ShowPsdP_Data:
			ShowSensorContinuous( PsdPositionData );
			return 0l;

		//! 'Settings...'
		//! aufruf der Psd-Einstellungsbox
		case cm_SetupPsd:
			if ( ( Detector != 0 ) && ( Detector->HasSpecificParametersDlg() == TRUE ) ) Detector->RunSpecificParametersDlg( GetHandle() );
			return 01;

		case cm_Help:
			WinHelp(GetHandle(), GetHelpFile(), HELP_CONTEXT, Help_AreaScan);
			return 0l; // Botschaft verarbeitet		

		default:
			return TPlotWindow::OnCommand(wParam, lParam);
	}
}
//*****************************************************************************
// Mausbedienung
//*****************************************************************************

void TAreaScanWindow::OnPopupMenuInit(WPARAM, LPARAM lParam)
{
	//! sperren von Psd-spezifischen Menuepunkten wenn kein Psd angeschlossen ist
	if ( ! TDetectorManager::DetectorManager().DimAvailable(1) )
	{
		EnableMenuItem( TheMenu, cm_ShowPsdE_Data, MF_GRAYED );
		EnableMenuItem( TheMenu, cm_SetupPsd, MF_GRAYED );
		EnableMenuItem( TheMenu, cm_CalibratePsd, MF_GRAYED );
		EnableMenuItem( TheMenu, cm_ShowPsdP_Data, MF_GRAYED );
	}

	//! DB-Zerlegung nur zugelassen, wenn DB im Speicher
	if ( lpDBase->GetCNumber() < 2 )
		EnableMenuItem( TheMenu, cm_DismantleDB, MF_GRAYED );
	else
		EnableMenuItem( TheMenu, cm_DismantleDB, MF_ENABLED );
	//! sperren von 'Start AreaScan' wenn bereits ein Scan laeuft der nicht unterbrochen wurde
	if ( ( bAreaScanStarted && !bInterrupted ) || !bScanSetupOk )
		EnableMenuItem( TheMenu, cm_InitializeAreaScan, MF_GRAYED );
	else
		EnableMenuItem( TheMenu, cm_InitializeAreaScan, MF_ENABLED ); // Scan muss initialisiert worden sein

	//! sperren von 'Choose Scan' wenn irgendeine nichtmodale Dialogbox aktiv ist
	//! neu Kullmann+Reinecker: TheModeless ersetzt durch ChooseScanDlg
	if ( (ChooseScanDlg) && (ChooseScanDlg->GetHandle()) )
		EnableMenuItem( TheMenu, cm_ChooseScan, MF_GRAYED ); // !GetHandle() ist wichtig fr den Fall, dass sich das Dialogfenster selbst zerstrt hat !!!
	else
		EnableMenuItem( TheMenu, cm_ChooseScan, MF_ENABLED );

	//! sperren von 'Settings...' wenn kein Psd verfuegbar ist
	if ( ( Detector == 0 ) || ( Detector->GetDimension() != 1) )
		EnableMenuItem( TheMenu, cm_SetupPsd, MF_GRAYED );
	else
		EnableMenuItem( TheMenu, cm_SetupPsd, MF_ENABLED );
	//! sperren von 'Fixing' wenn Darstellungsart ungleich Kurve + sperren von
	//! 'Inquire Data' wenn Darstellungsart gleich Kurve
	switch ( eOutputType ) {
		case otReciprokeLatticeBitmap:
		case otMatrixBitmap:
			EnableMenuItem( TheMenu, cm_FreezeCurve, MF_GRAYED );
			EnableMenuItem( TheMenu, cm_DataAquisition, MF_ENABLED );
			break;

		default:
			EnableMenuItem( TheMenu, cm_DataAquisition, MF_GRAYED );
			//! neu fixscan
			if (1 > SecondCurve->GetPNumber())
			{
				EnableMenuItem( TheMenu, cm_FreezeCurve, MF_ENABLED );
				EnableMenuItem( TheMenu, cm_SaveSecondCurve, MF_GRAYED );
				EnableMenuItem( TheMenu, cm_KillSecondCurve, MF_GRAYED );
				//! dieser Befehl macht bei Win31 probleme
				//! ModifyMenu( TheMenu, 8, MF_STRING|MF_BYPOSITION,8,"Scan" );
			}
			else
			{
				//! ModifyMenu( TheMenu, 8, MF_STRING|MF_BYPOSITION,8,"fixierten Scan" );
				EnableMenuItem( TheMenu, cm_FreezeCurve, MF_GRAYED );
				EnableMenuItem( TheMenu, cm_SaveSecondCurve, MF_ENABLED );
				EnableMenuItem( TheMenu, cm_KillSecondCurve, MF_ENABLED );
			}
	}
};
//*****************************************************************************

//! aufruf wenn linke Maustaste losgelassen wurde(d.h. Endpunkt erreicht)
//! wird in 2 Faellen aktiv
//! - messen der Entfernung zwischen zwei Punkten ueber TPlotWindow
//! - bei Dataaquisition (DataaquisitionActive==true) zusaetzlich Kommando senden
void TAreaScanWindow::OnLButtonUp( WPARAM wParam, LPARAM lParam )
{
	TPlotWindow::OnLButtonUp( wParam, lParam );
	if ( DataaquisitionActive )
	{
		DataaquisitionActive= false;
		PostMessage( GetHandle(), WM_COMMAND, cm_DataAquisition, 0l );
	}
};
//*****************************************************************************

//! aufruf wenn linke Maustaste gedrueckt wurde(d.h Startpunkt wurde gewaehlt)
//! wird in 2 Faellen aktiv
//! - messen der Entfernung zwischen zwei Punkten (!DataaquisitionActive)
//! - bei Dataaquisition (DataaquisitionActive==true)
void TAreaScanWindow::OnLButtonDown( WPARAM wParam, LPARAM lParam )
{
	if ( bAquisitionActive )
		DataaquisitionActive= true;
	else
		DataaquisitionActive= false;
	TPlotWindow::OnLButtonDown( wParam, lParam );
};
//*****************************************************************************

//! loescht aktuelle datenbasis + baut AreaScanfenster neu auf
//! Rueckkehrcode immer True
BOOL TAreaScanWindow::New( void )
{
	lpDBase->New();
	nActiveScan= 0;
	MainCurve= lpDBase->GetCurve( nActiveScan );

	bOldDataLoaded= FALSE;

	//! FIX Fehler 39
	VisualDB.bPsd= ( GetPsd() != 0 );
	VisualDB.dThetaWindow= dThetaWindow;
	VisualDB.dMoveRelation= dMoveRelation;
	VisualDB.dOmegaMin= dOmegaMin;
	VisualDB.dOmegaMax= dOmegaMax;
	if ( GetPsd()!=0 )
	{
		VisualDB.fAngleRange= GetPsd()->GetAngleRange();
		VisualDB.fAngleStep= GetPsd()->GetAngleStep();
	}
	else
	{
		VisualDB.fAngleRange= dThetaWindow;
		VisualDB.fAngleStep= dThetaWindow / dThetaWidth;
	}
	VisualDB.dThetaMinFirst= dThetaMin;
	VisualDB.dThetaMaxLast= VisualDB.dThetaMinLast + VisualDB.fAngleRange;
	VisualDB.dThetaMaxFirst= dThetaMin + VisualDB.fAngleRange;
	if (eScanType == stStandardScan)
		VisualDB.dThetaMinLast= dThetaMin;
	else
		VisualDB.dThetaMinLast= dThetaMin + (dOmegaMax - dOmegaMin) / dOmegaWidth * dOmegaWidth * dMoveRelation;

	ScanReport2->New();
	return TPlotWindow::New();
};
//*****************************************************************************

//! setzt Titel des AreaScanFensters
//! Rueckkehrcode immer True
BOOL TAreaScanWindow::SetTitle()
{
	strcpy( m_Title, szTitle );
	//! haengt "<untitled.psd>" bei neuer Datei , sonst FileName an
	//! und schreibt ihn ins Fenster
	if ( bIsNewFile )
		strcat( m_Title, "<untitled.psd>" );
	else
		strcat( m_Title, FileName );
	return TMDIWindow::SetTitle();
};
//*****************************************************************************

//! zeichnet in abhaengigkeit des eingestellten Darstellungstyps das AreaScan-
//! fenster neu
void TAreaScanWindow::UpdateWnd( EPaintType act )
{
	switch ( eOutputType )
	{
		case otReciprokeLatticeBitmap:
			BSource->UpdateBitmapSource();
			break;

		case otMatrixBitmap:
			BSource->UpdateBitmapSource();
			break;
	}
	//! behandelt Darstellungstyp Curve
	TMDIWindow::UpdateWnd( act );
};
//*****************************************************************************

//! setzt die Achsen-min. und -max. abhaengig von der Darstellungsart
void TAreaScanWindow::SetRanges( void )
{
	float xshift;
	float fRangeSec= 1.0;
	TDisplay DParam;
	// spezielle Darstellung ist aktiv oder Datei wurde geladen: Detektor- und Motoreinstellungen nicht ndern!
	bool bUnchangeData= (bShowPsdContinuous || bMeasurementActive || bOldDataLoaded);

	// Kanalbereich aktualisieren 
	if ( !bUnchangeData ) 
		if ( GetPsd() ) {
			fPsdRange= GetPsd()->GetAngleRange();
			nFirstReadColumn= GetPsd()->GetFirstChannel();
			nLastReadColumn= GetPsd()->GetLastChannel();
		} else {
			fPsdRange= 0;
			nFirstReadColumn= 0;
			nLastReadColumn= 0;
		}

	//! Datenbasis spez. Darstellung
	DParam.bPsd= VisualDB.bPsd;
	DParam.dThetaWindow= VisualDB.dThetaWindow;
	DParam.dMoveRelation= VisualDB.dMoveRelation;
	DParam.dOmegaMin= VisualDB.dOmegaMin;
	DParam.dOmegaMax= VisualDB.dOmegaMax;

	// spezielle Darstellung ist aktiv oder Datei wurde geladen
	if ( bUnchangeData ) { 
		DParam.bPsd= ( GetPsd() != 0 );
		DParam.dThetaWindow= dThetaWindow;
		DParam.dMoveRelation= dMoveRelation;
		DParam.dOmegaMin= dOmegaMin;
		DParam.dOmegaMax= dOmegaMax;
	}

	// Kanalbereich aktualisieren 
	if ( bUnchangeData && GetPsd() ) { 
		DParam.fAngleRange= GetPsd()->GetAngleRange();
		DParam.fAngleStep= GetPsd()->GetAngleStep();
		fRangeSec= GetPsd()->GetAngleRange() / DParam.fAngleRange;
	} else {
		DParam.fAngleRange= VisualDB.fAngleRange;
		DParam.fAngleStep= VisualDB.fAngleStep;
		fRangeSec= CalcValueInUnit(utSekunden, (nLastReadColumn-nFirstReadColumn+1)/*GetChannelNumber() nimmt die Kanaleinstellung vom PSD, kann hier also nicht verwendet werden*/ * DParam.fAngleStep) / DParam.fAngleRange; // Kullmann, Reinecker
	}

	// neu, Thetapositionen haben immer gefehlt
	DParam.dThetaMinFirst= DParam.dThetaMinLast= dThetaMin;
	DParam.dThetaMaxFirst= DParam.dThetaMaxLast= dThetaMin+CalcValueInUnit(m_MotorUnit, DParam.fAngleRange);
	DParam.dThetaWindow= DParam.dThetaMaxFirst-DParam.dThetaMinFirst;

	switch ( eOutputType )
	{
		case otReciprokeLatticeBitmap: //! RL-Bitmap
			CoorSys.zMax= UpperBound;
			CoorSys.zMin= LowerBound;
			// The AltCoorSys is now used and will be setted in
			// TransformDBaseToBitmap()
			break;

		case otMatrixBitmap://! RAW-Matrix
			CoorSys.zMax= UpperBound;
			CoorSys.zMin= LowerBound;
			CoorSys.yMin= DParam.dOmegaMin;			
			CoorSys.yMax= DParam.dOmegaMax;

			//! setzen der x-Achse in Abhngigkeit von Kurvenpunktzahl
			if ( MainCurve->GetPNumber() < 7 )
			{
				CoorSys.xMin= DParam.dOmegaMin * DParam.dMoveRelation;
				CoorSys.xMax= CoorSys.xMin + DParam.fAngleRange;
				/*GetPsd()->GetAngleRange();*/
				break;
			}
			xshift= GetThetaOffset( 0 );
			CoorSys.xMin= MainCurve->GetMin( P_X ) + xshift;
			//! dies muss mit rein! B.Buss
			xshift= GetThetaOffset(lpDBase->GetCNumber() - 1);
			CoorSys.xMax= MainCurve->GetMax( P_X ) + xshift;
			break;

		case otCurve://! Kurve
			CoorSys.yMin= LowerBound;
			CoorSys.yMax= UpperBound;
			if ( !DParam.bPsd )
			{
				//! wenn kein Psd dann test ob Punkte in Kurve
				if ( MainCurve->GetPNumber() < 1 )
				{
					//! wenn nicht x-Achse( -xx/2 -> xx/2)
					CoorSys.xMin= - DParam.dThetaWindow / 2.0;
					CoorSys.xMax= DParam.dThetaWindow / 2.0;
					break;
				}

				//! sonst x-Achse (min: auf min.Winkelwert der Kurve -> max: min + xx)
				CoorSys.xMin= MainCurve->GetMin( P_X );
				CoorSys.xMax= CoorSys.xMin + DParam.dThetaWindow;
				break;
			}
			//! Psd angeschlossen
			if ( MainCurve->GetPNumber() < 2 )
			{
				//! kurve hat keine Punkte
				if ( bSecondaryCoor ) //! Kanaldarstellung 
				{
					CoorSys.xMin= 0.0;
					CoorSys.xMax= DParam.fAngleRange / DParam.fAngleStep * fRangeSec;
					/*! GetPsd()->GetAngleRange( Sekunden ) /
					  GetPsd()->GetAngleStep();*/
				} else { //! Winkeldarstellung 					
					CoorSys.xMin= DParam.dThetaMinFirst; // 27.07.2004 DParam.dOmegaMin * DParam.dMoveRelation;
					CoorSys.xMax= DParam.dThetaMaxFirst; // 27.07.2004 CoorSys.xMin + DParam.fAngleRange
					/*GetPsd()->GetAngleRange();*/
				}
				break;
			}
			//! Kurve hat Punkte
			if ( bSecondaryCoor ) // Kanaldarst.
			{
				CoorSys.xMin= MainCurve->GetMin( P_Z );
				CoorSys.xMax= MainCurve->GetMax( P_Z );
			} else { // Winkeldarst.
				//! liefert 0 wenn kein Psd ansonsten den ThetaOffset und setzt
				//! entsprechend die x-Achse
				xshift= GetThetaOffset( 0 );
				CoorSys.xMin= MainCurve->GetMin( P_X ) + xshift;
				CoorSys.xMax= MainCurve->GetMax( P_X ) + xshift;
			}
			break;

		default:
			MessageBox( szMsgLine023, szMessage, MBINFO );
			break;
	}
};

//*****************************************************************************
//Schnittstellen fuer Ablaufsteuerung
//*****************************************************************************

double TAreaScanWindow::GetActAngle( const LPCSTR aName, BOOL &aValid ) const
{
	int Index = -1;
	aValid= FALSE;
	TMotor *Mtr = 0;

	for (UINT i= 0; i < lpMList->GetAxisNumber(); i++) 
	{
		if ( (strcmp( aName, lpMList->MP(i)->pCharacteristic()) == 0) )
		{
			Mtr= lpMList->MP( i );
			break;
		}
	}
	if (!Mtr) return 0.0; // nicht gefunden
		
	if (Mtr->IsMoveFinish())
		aValid= Mtr->GetAngle( 1 ); // mGetDistance
	else
		aValid= Mtr->GetAngle( 0 ); // mGetDistanceProcess
	return Mtr->GetAngle(); // aValid == TRUE <--> Position erfolgreich ausgelesen und umgerechnet
};
//*****************************************************************************

//! behandelt eigentlichen Scanablauf sowie die kont. Anzeige, Calibrate ...
//! Aufruf durch cm_CounterSet
void TAreaScanWindow::CounterSetRequest( LPARAM lParam )
{
	float absorber, channel, psdtheta, peakpos;
	//! FIX Fehler 30
	float x, y, x2, y2, z2, intens, integral, time;
	//! FIX Fehler 47
	char buf[ 3 * MaxString ], fmt[ 3 * MaxString ], msg[ MaxString ];
	double dTheta, dOmega;
	static float fMonitorSignal;
	int nNumOffs= 0;
	BOOL bValid= false;

	//! bei kont. Anzeige
	if ( bShowPsdContinuous )
	{
		if ( m_PsdContinousType==PsdEnergyData ) strcpy( msg, szMsgLine026e );
		else if ( m_PsdContinousType==PsdPositionData ) strcpy( msg, szMsgLine026p );
		else strcpy( msg, szMsgLine026 );
		//! Kurvenspektrum+ integrale Intensitaet von Psd holen
		GetPsd()->FillInCurve( *MainCurve, mlGetUnit(nTheta) );
		GetPsd()->GetIntegral( integral );
		//! wenn keine Calibr. dann Messung neu starten
		//! (sonst wird dies in TCalibr. gemacht)
		if ( !bCalibrationActive && Detector->IsDataValid() )
			Detector->MeasureStart();
		dTheta = GetActAngle( "Theta", bValid );
		dOmega = GetActAngle( "Omega", bValid );
		//>>TK
		sprintf( fmt, "%s O:%s  T:%s  Peak( %s | %s) Integr.Intensity: %s", msg, "%.4f", "%.4f", szTDF, "%.2f", "%.2f");
		//! in abhaengigkeit von x-achsen-art(Kanal,Winkel) statuszeilen ausgabe
		if ( bSecondaryCoor ) //! Kanaldarst.
		{			
			channel= GetPsd()->GetMaximumChannel();
			intens= GetPsd()->GetMaximumIntensity();
			sprintf( buf, fmt, dOmega, dTheta, channel, intens, integral);
		} else { //! Winkeldarst.			
			MainCurve->GetGravityCenter( psdtheta, intens, channel );
			psdtheta += GetThetaOffset( 0 );
			sprintf( buf, fmt, dOmega, dTheta, psdtheta, intens, integral);
		}
		SetInfo( buf );
		UpdateWnd();
		return;
	}
	//! bei unterbrochenem Scan + Scan nicht aktiviert abbruch
	if ( bInterrupted )
		return;
	if ( !bMeasurementActive )
		return;
	//! ab hier ablauf bei laufendem AreaScan
	//! Monitorintensitaet ermitteln und merken (in static-var.) bis
	//! Messdetektor auch fertig ist
	if ( ( Monitor != 0 ) && ( lParam == Monitor->GetId() ) )
	{
		Monitor->GetIntegral( fMonitorSignal );
		return;
	}

	bFileChanged= TRUE;
	//! position der motoren holen + bei theta offset dazurechnen
	dOmega= mlGetValue( nOmega, Distance );
	dTheta= mlGetValue( nTheta, Distance );
	//! o-t-offset in reale Motorpositionen einrechnen
	x= ( float ) (dOmega + dOffsetOmega);
	// Theta will be stored in absolute Koordinates
	y= ( float ) (dTheta + dOffsetTheta - dThetaOffset);

	//***************************************************************************
	//**** Datenbasis aktualisieren *********************************************
	//***************************************************************************
	//! erste Messung(erstes Spektrum wird nicht benutzt) weil Datenbasis schon

	//! mit einer Kurve init. wurde
	if ( bFirstScan )
		nNumOffs= ( Detector->IsDataValid() ) ? 0 : 0;
	else
		nNumOffs= ( Detector->IsDataValid() ) ? 0 : 1;
	switch ( eScanType )
	{
		case stOmega2ThetaScan://! Omega2Thetascan
			//###########################################################
			//! Scan mit Psd
			if ( GetPsd() != 0 )
			{
				//! wenn Detektordaten gueltig
				//! wenn nicht 1.Spektrum in Datenbasis neues Spektrum hinzufuegen
				//! Spektrum + integr. vom detektor holen
				MainCurve= lpDBase->GetLastCurve();
				GetPsd()->FillInCurve( *MainCurve, mlGetUnit(nTheta) );
				GetPsd()->GetIntegral( integral );
				if ( GetPsd()->IsDataValid() )
				{
					bFileChanged= TRUE;
					//! neues Spektrum in datei speichern bei kont. Speichern
					if ( bSaveContinuous )
						UpdateFile();
					//! nur wenn Messzeit abgelaufen kurve in Datenbasis
					//! speichern und Datenbasis vergroessern
					lpDBase->AddCurve(); // 10.04.2004 Parameterbergabe nicht mehr notwendig MainCurve->GetPNumber() 
					nActiveScan= lpDBase->GetCNumber() - 1;
				}
				//! Kurve + integrale Int. vom Detektor holen + Kurve in Datenbasis
				//! Thetawinkel der Peakpos. holen*/
				//! absorberposition ermitteln
				if (ReportUse.bAbsorber )
					absorber= mlGetValue( mlGetIdByName( Absorber ), Distance );
				else
					absorber= GetPsd()->GetMaximumChannel();

				MainCurve->GetGravityCenter( psdtheta, intens, peakpos );
				psdtheta += y;
				//! in abhaengigkeit von der eingestellten Reportart zum Spektrum die
				//! omega- , Thetapos. sowie den jeweiligen Reportwert im Scanreport
				//! speichern ueberfluessig (wahrscheinlich als Erweiterung geplant)
				if ( Detector->IsDataValid() )
				{
					time= Detector->GetRealTime();
					//! monitordet. reset
					if ( Monitor != 0 )
						Monitor->MeasureStop();
					else
						fMonitorSignal= 0.0;
					//! Zusatzinfos anlegen
					ScanReport->PAdd( x, y, integral);
					ScanReport2->PAdd( time, fMonitorSignal, absorber);
					//! naechste pos. anfahren
					Steering.DetectorRequest();
				}

				//###########################################################
				//! Scan mit 0-dim. Detektor
			}
			else
			{ // GetPsd() == 0
				//! im ersten schritt keine neue Kurve in Datenbasis
				if ( bFirstScan )
					bFirstScan= FALSE;
				//! wenn 0-dim. detektor ueber gesamten Thetabereich gelaufen dann
				//! eine neue Kurve in Datenbasis
				else if ( bThetaScanCompleted )
				{
					bThetaScanCompleted= FALSE;
					//! bei kont. speichern akt. maincurve an datei anhaengen
					//! FIX Fehler 34
					if ( bSaveContinuous )
						UpdateFile();
					// save data about last scan
					//! FIX Fehler 30,40
					MainCurve->SetPP();
					MainCurve->PGet(x2, y2, z2);
					//! neu info
					//!MainCurve->GetGravityCenter(intens,intens,peakpos,2);
					ScanReport->PAdd(z2, x2, intens= 0);
					lpDBase->AddCurve( ); // 10.04.2004 Parameterbergabe nicht mehr notwendig MainCurve->GetPNumber() 
					MainCurve= lpDBase->GetLastCurve();
					nActiveScan= lpDBase->GetCNumber() - 1;
				}
				//! intens.wert vom Detektor holen + an Kurve anhaengen
				Detector->GetIntegral( intens );
				//! FIX Fehler 30,40
				MainCurve->PAdd( y, intens, x );
				bFileChanged= TRUE;

				//! naechste pos. anfahren
				Steering.DetectorRequest();
			}
			break;

		//#######################################################################
		case stStandardScan:
			//! standardscan nur mit Psd erlaubt
			if ( GetPsd() == 0 )
				return;
			//! wenn Detektordaten gueltig
			//! wenn nicht 1.Spektrum in Datenbasis neues Spektrum hinzufuegen
			//! Spektrum + integr. vom detektor holen
			MainCurve= lpDBase->GetLastCurve();
			GetPsd()->FillInCurve( *MainCurve, mlGetUnit(nTheta) );
			GetPsd()->GetIntegral( integral );
			if ( GetPsd()->IsDataValid() )
			{
				bFileChanged= TRUE;
				//! neues Spektrum in datei speichern bei kont. Speichern
				if ( bSaveContinuous )
					UpdateFile();
				//! nur wenn Messzeit abgelaufen kurve in Datenbasis
				//! speichern und Datenbasis vergroessern
				lpDBase->AddCurve( ); // 10.04.2004 Parameterbergabe nicht mehr notwendig MainCurve->GetPNumber() 
				nActiveScan= lpDBase->GetCNumber() - 1;
			}
			//! Kurve + integrale Int. vom Detektor holen + Kurve in Datenbasis
			//! absorberposition ermitteln
			if ( ReportUse.bAbsorber )
				absorber= mlGetValue( mlGetIdByName( Absorber ), Distance );
			else
				absorber= GetPsd()->GetMaximumChannel();

			//! Thetawinkel der Peakpos. holen
			MainCurve->GetGravityCenter( psdtheta, intens, peakpos );
			psdtheta += y;
			//! in abhaengigkeit von der eingestellten Reportart zum Spektrum die
			//! omega- , Thetapos. sowie den jeweiligen Reportwert im Scanreport
			//! speichern ueberfluessig (wahrscheinlich als Erweiterung geplant)
			if ( Detector->IsDataValid() )
			{
				//! neu info
				//! monitordet. reset
				if ( Monitor != 0 )
					Monitor->MeasureStop();
				else
					fMonitorSignal= 0.0;
				time= Detector->GetRealTime();
				//! zusatzinfos anlegen
				ScanReport->PAdd(x, y, integral);
				ScanReport2->PAdd(time, fMonitorSignal, absorber);

				//! naechste pos. anfahren
				Steering.DetectorRequest();
			}
			break;
	} // switch ( eScanType )

	//***************************************************************************
	//**** Anzeige fuer Signalaufbau aktualisieren ******************************
	//***************************************************************************
	//! UpdateWindow:
	switch ( eScanType )
	{
		case stOmega2ThetaScan:
			//! Anzeige bei 0-dim.Det.
			if ( GetPsd() == 0 )
			{
				//! string fuer Statusleiste erstellen
				sprintf( fmt, szMsgLine001, szODF, szTDF );

				sprintf( buf, fmt, x, y, intens );

				//! wenn akt. Kurve keine Punkte dann Fenster neuzeichnen sonst den
				//! neuen Punkt der Kurve einzeichnen
				if ( 1 == MainCurve->GetPNumber() )
					UpdateWnd();
				else
					UpdateWnd( ptPaintPoint );

				//! Anzeige bei Psd
			}
			else
			{
				//! string fuer Statusleiste erstellen
#ifdef GermanVersion
				sprintf( fmt, "Messung laeuft! O:%s T:%s", szODF, szTDF );
				sprintf( buf, "%s P(%s<>%%.1f) Gesamt-Intensitaet:%%.1f > %%d", fmt, szTDF );
#else
				sprintf( fmt, "Measurement ! O:%s T:%s", szODF, szTDF );
				sprintf( buf, "%s P(%s<>%%.1f) Integral Intensity:%%.lf > %%d", fmt, szTDF );
#endif
				strcpy( fmt, buf );
				nNumOffs += lpDBase->GetCNumber() - 1;
				if ( bSecondaryCoor )
					sprintf( buf, fmt, x, y, peakpos, intens, integral, nNumOffs );
				else
					sprintf( buf, fmt, x, y, psdtheta, intens, integral, nNumOffs );
				//! neue Kurve zeichnen
				UpdateWnd();
				//! wenn integr. Int. zu hoch dann Overflow ausgeben
				if ( GetPsd()->IsSoftOverflow() )
					strcat( buf, " > 'OverflowIntensity' !" );
			}
			break;

		case stStandardScan:
			//! nur fuer Psd erlaubt
			if ( GetPsd() == 0 )
				return;
			//! string fuer Statusleiste erstellen
			sprintf( fmt, szMsgLine009, szODF );
			sprintf( buf, szMsgLine010, fmt, szTDF );
			strcpy( fmt, buf );
			nNumOffs += lpDBase->GetCNumber() - 1;
			if ( bSecondaryCoor )
				sprintf( buf, fmt, x, peakpos, intens, integral, nNumOffs );
			else
				sprintf( buf, fmt, x, psdtheta, intens, integral, nNumOffs );
			//! neue Kurve zeichnen
			UpdateWnd();
			//! wenn integr. Int. zu hoch dann Overflow ausgeben
			if ( GetPsd()->IsSoftOverflow() )
				strcat( buf, " Overflow !" );
			break;
	} // switch ( eScanType )
	//! String in Statusleiste schreiben
	SetInfo( buf );
};
//*****************************************************************************

//! wird augerufen nachdem AreaScan abgeschlossen wurde
//! aus m_main.cpp bei cm_SteeringReady
void TAreaScanWindow::SteeringReady( LPARAM lParam )
{
	if ( !bAreaScanStarted ) return;
	char buf[ MaxString ];

	// Funktion behandelt Meldung cm_CmdExecuted
	bAreaScanStarted= FALSE;
	bMeasurementActive= FALSE;
	Detector->MeasureStop();
	// Scan wurde ausgefuehrt
	switch ( HIWORD( lParam ) )
	{
		case R_Failure:
			//klier 16.08.02
			SetProtocolDiffractometryOff();

			sprintf( buf, szMsgLine020, LOWORD( lParam ) );
			MessageBox( buf, szMsgFailure, MBINFO );
			break;

		default://! keine Fehler aufgetreten
			//! neu akk
			//! letztes Spektrum bei Scan mit Psd wieder loeschen
			//! es wird immer eins zuviel angelegt
			if ( GetPsd() != 0 )
				lpDBase->DelCurve();
			//! Info in Statusleiste
			sprintf( buf, szMsgLine011, lpDBase->GetCNumber() );
			SetInfo( buf );
			//! FIX Fehler 30,40
			if ( (eScanType == stOmega2ThetaScan) && (GetPsd() == 0) )
			{
				//! die Werte zu der letzten Scankurve in Report-
				//! kurve ablegen
				//! FIX Fehler 30,40
				float x2, y2, z2, intens /*,peakpos*/;
				MainCurve->SetPP();
				MainCurve->PGet(x2, y2, z2);
				ScanReport->PAdd(z2, x2, intens= 0);
				bFileChanged= TRUE;
				//! letztes Spektrum in datei speichern bei kont. Speichern
				if ( bSaveContinuous )
					UpdateFile();
			}
			//! wenn savecont. ausgewaehlt dann Headerinfo aktualisieren + Scanreport
			if ( bSaveContinuous )
			{ // Header aktualisieren
				SaveMeasurementInfo( TRUE );
				SaveReport();
			}
			//! FIX Fehler 76
			if ( bSaveOnReady )
			{
				if ( SaveFile( atNoAsk ) )
					sprintf( buf, szMsgLine012 );
				else
					sprintf( buf, szMsgLine019 );
				//! FIX Fehler 76
			}
			else if ( bSaveContinuous )
				sprintf( buf, szMsgLine012 );
			else
				sprintf( buf, szMsgLine018 );
			MessageBox( buf, szMessage, MBINFO );

			//klier 01.03.2003
			if (IsProtocolDiffractometryOn())
			{
				if (!bSaveContinuous && !bSaveOnReady)
				{
					SetMeasurementProtocolParameter();
					SaveProtocolDiffractometryParameter();
				}
				ViewOnProtocolDiffractometryDlg();
				SetProtocolDiffractometryReadOnly();
				SetProtocolDiffractometryOff();
			}
	} // switch ( HIWORD(lParam) )
	//! Detektor stoppen
	Detector->MeasureStop();
	Detector->PopSettings();
	Detector->SetControlWnd( NULL );
};
//-----------------------------------------------------------------------------

//! wird augerufen nachdem AreaScan abgeschlossen wurde
//! aus m_main.cpp bei cm_SteeringReset
void TAreaScanWindow::SteeringReset( LPARAM lParam )
{
	if ( !bAreaScanStarted ) return;

	// Funktion behandelt Meldung cm_CmdExecuted
	bAreaScanStarted= FALSE;
	bMeasurementActive= FALSE;
	if ( Detector ) Detector->MeasureStop();	
	SetInfo(szMsgLine222);
}
//*****************************************************************************

//! Fkt. wird bei unterbrechen/fortsetzen eines AreaScans aufgerufen oder zum
//! ausschalten einer kont. Anzeige
void TAreaScanWindow::Interrupt()
{
	//! kont. Anzeige ausschalten wenn aktiv
	if ( bShowPsdContinuous )
	{
		StopSensorContinuous();
		return;
	}

	if ( !bAreaScanStarted ) return;

	//! Hauptmenueeintrag aendern und bInterrupted negieren
	TMDIWindow::Interrupt();
	if ( bInterrupted ) { //! Messung unterbrechen (wenn Messung nicht luft, mssen wir auch eine andere Makroverarbeitung abbrechen knnen - wenn gerade unser Fenster geffnet ist) 
		//! Messung unterbrechen + in Statusleiste anzeigen
		Steering.ToggleInterrupt();
		SetInfo( szMsgLine013 );
	} else { // Messung weiterfueren		
		Steering.ToggleInterrupt();
	}
};
//*****************************************************************************

//! aufruf zur PsdCalibrierung
//! FIX Fehler 35
void TAreaScanWindow::CalibratePsd( void )
{
	BOOL bsCoor;

	//! nur wenn Thetamotor und Psd verfuegbar
	if ( !mlIsAxisValid( Theta ) || !TDetectorManager::DetectorManager().DimAvailable(1) )
	{
		MessageBox( szMsgLine021, szMsgFailure, MBINFO );
		return;
	}
	if ( bShowPsdContinuous )
	{
		if ( MessageBox(szMsgLine312, szMsgLine213, MBASK) != IDYES ) return; // Spektrenanzeige nicht automatisch stoppen
		StopSensorContinuous(); // erst kont. Spektrenanzeige stoppen
	}


	bCalibrationActive= TRUE;
	int sChann= 0;
	if ( GetPsd() ) sChann= GetPsd()->GetAddedChannels();
	bsCoor= bSecondaryCoor;
	StartSensorContinuous(PsdPositionData, TRUE);

	//! Calibrierungsdialogbox
	TDetectorGUI::RunPsdCalibrateDialog(GetHandle(), *MainCurve);
	
	StopSensorContinuous();
	bSecondaryCoor= bsCoor;
	bCalibrationActive= FALSE;
	if ( GetPsd() && sChann ) GetPsd()->SetAddedChannels(sChann);

	Detector->MeasureStart();
	UpdateWnd();
};

//*****************************************************************************
// kont. Spektrenanzeige
//*****************************************************************************

void TAreaScanWindow::StartSensorContinuous( EPsdDataType type, BOOL CalibrateSpecial ) {

	if ( bShowPsdContinuous || type==PsdUnknown ) return; // ist schon gestartet oder unbekannte Spektrenart

	//! kont. Anzeige NUR bei Kurvendarst. erlaubt
	if ( eOutputType != otCurve )
	{
		MessageBox( szMsgLine027, szMsgLine209, MBSTOP );
		return;
	}

	//! kont. Anzeige nur fuer Psd erlaubt
	if ( !TDetectorManager::DetectorManager().DimAvailable(1) || !GetPsd() )
	{
		MessageBox( szMsgLine024, szMessage, MBINFO );
		return;
	}

	TDetectorManager::DetectorManager().SetDetector( 0, 1 );
	SetDetector( TDetectorManager::DetectorManager().GetDetector() );
	Detector->MeasureStop();

	bShowPsdContinuous= TRUE; // ist gestartet
	m_PsdContinousType= type;

	//! FIX Fehler 46
	TCurve *dummy= new TCurve;
	MainCurve= dummy;

	// Eingeschraenkte Aufloesung einstellen
	GetPsd()->SetSignalGrowUp( FALSE );
	Detector->SetControlWnd( GetHandle() );

	//! Anzeigeart an Psd uebergeben
	if ( type==PsdEnergyData || type==PsdPositionData )
		GetPsd()->SetDataType( type );

	if ( type==PsdEnergyData ) {
		bSavedSecondaryCoor = bSecondaryCoor; // aktuelle Darstellung merken 
		bSecondaryCoor= TRUE; // immer Kanaldarstellung
	}

	// im Menue kennzeichnen
	CheckMenuItem( TheMenu, cm_ShowPsdE_Data, ( type == PsdEnergyData ) ? MF_CHECKED : MF_UNCHECKED );
	CheckMenuItem( TheMenu, cm_ShowPsdP_Data, ( type == PsdPositionData ) ? MF_CHECKED : MF_UNCHECKED );
	Detector->MeasureStart();
}
//*****************************************************************************

void TAreaScanWindow::StopSensorContinuous() {
	if ( !bShowPsdContinuous || m_PsdContinousType==PsdUnknown ) return; // ist schon gestoppt oder unbekannte Spektrenart

	TDetectorManager::DetectorManager().SetDetector( 0, 1 );
	SetDetector( TDetectorManager::DetectorManager().GetDetector() );
	Detector->MeasureStop();

	bShowPsdContinuous= FALSE; // ist gestoppt

	//! FIX Fehler 46
	_FREEOBJ(MainCurve); // zuerst den alten <dummy> wieder freigeben
	MainCurve= lpDBase->GetCurve(nActiveScan);		

	//! alte Werte in Psd zuruecksetzen und im Menue Kennzeichnung entfernen
	// Kullmann, Reinecker Detector->PopSettings();
	Detector->SetControlWnd( NULL );
	Detector->MeasureStart();
	//TPlotWindow::bSecondaryCoor= FALSE;
	UpdateWnd();

	if ( m_PsdContinousType==PsdEnergyData )
	{
		CheckMenuItem( TheMenu, cm_ShowPsdE_Data, MF_UNCHECKED );
		GetPsd()->SetDataType( PsdPositionData );
		bSecondaryCoor = bSavedSecondaryCoor; // gemerkte Beschriftung wieder herstellen
	} 
	else if ( m_PsdContinousType==PsdPositionData )
		CheckMenuItem( TheMenu, cm_ShowPsdP_Data, MF_UNCHECKED );	
}
//*****************************************************************************

//! diese Fkt. schaltet die kont. Spektrumsanzeige fuer Psd an oder aus
void TAreaScanWindow::ShowSensorContinuous( EPsdDataType type ) {
	if ( bShowPsdContinuous ) { // Spektrenanzeige der Art <datatype> ist gerade aktiv: diese stoppen
		StopSensorContinuous(); // aktuelle stoppen
		if ( type!=m_PsdContinousType ) StartSensorContinuous(type); // neue Art Starten
	} else { // Anzeige ist aus: neue Einschalten
		StartSensorContinuous(type); 
	}
};
//*****************************************************************************

void TAreaScanWindow::GetTitleX(int i, int titlesx, char *buf, bool reduceLines) {
	if ( bShowPsdContinuous && m_PsdContinousType==PsdEnergyData ) { // Energiespektrum aktiv
		// Klasseneinteilung der Intensitten
		TPlotWindow::GetTitleX(i, titlesx, buf, reduceLines); 

		// letzte Beschriftung = Beschriftung der Abzissen-Achse
		if ( i==tilesx ) 
			sprintf(buf, szEnergy ); // "Kanaele"
	} else {
		// Zahlenwerte
		TPlotWindow::GetTitleX(i, titlesx, buf, reduceLines); 
	
		// letzte Beschriftung = Beschriftung der Abzissen-Achse
		if ( i==tilesx ) { 
			char unit[_MAXLENUNIT+1];
			if ( Detector && Detector->GetDimension()==1 ) strcpy(unit, dynamic_cast<TOneDimDetector*>(Detector)->GetUnitName());
			else strcpy(unit, "");
			if ( eOutputType==otReciprokeLatticeBitmap )
				sprintf(buf, "qx");		
			else if ( bSecondaryCoor ) 
				sprintf(buf, szChannel, mlGetAxisName(nTheta));
			else if ( strlen(unit)==0 ) {
				sprintf(buf, szAngle, mlGetAxisName(nTheta));
			}
			else {
				if ( reduceLines ) sprintf(buf, szAngleUnitEZ, mlGetAxisName(nTheta));
				else sprintf(buf, szAngleUnit, mlGetAxisName(nTheta), unit);
			}
		}
	}
}
void TAreaScanWindow::GetTitleY(int i, int titlesy, char *buf, bool reduceLines) {
	TCoorSystem *pCoorSys;
	switch (eOutputType)
	{
		case otReciprokeLatticeBitmap:
		case otMatrixBitmap:
			pCoorSys= &AltCoorSys;
			break;

		default:
			pCoorSys= &CoorSys;
	}

	if ( bShowPsdContinuous && m_PsdContinousType==PsdEnergyData ) { // Energiespektrum aktiv
		// keine Zahlenwerte (Einteilung der Skala unbekannt (theoretisches Maximum von 1 entsprche integraler Intensitt)
		strcpy(buf, "");

		// letzte Beschriftung = Beschriftung der Ordinaten-Achse
		if ( i==tilesy ) {
			TPlotWindow::GetTitleY(i, titlesy, buf, reduceLines); 	
			if ( !reduceLines ) {
				if ( pCoorSys->yScal==sLinear ) sprintf(buf, szFrequentLi);
				else if ( pCoorSys->yScal==sLogarithmic ) sprintf(buf, szFrequentLo);
			} // ansonsten <buf> unverndert lassen; d.h. "linear"/ "log10 skaliert"
		}
	} else {
		// Zahlenwerte bzw. "linear"/ "log 10"
		TPlotWindow::GetTitleY(i, titlesy, buf, reduceLines); 

		// letzte Beschriftung = Beschriftung der Ordinaten-Achse
		if ( i==tilesy ) {
			switch ( eOutputType ) {
				case otReciprokeLatticeBitmap:
					sprintf(buf, "qz");
					break;

				case otMatrixBitmap:
					if ( reduceLines ) sprintf(buf, szAngleOmegaUnitEZ, mlGetAxisName(nOmega));
					else sprintf(buf, szAngleOmegaUnit, mlGetAxisName(nOmega), mlGetUnitName(nOmega));
					break;

				// ansonsten <buf> unverndert lassen: dann wird "linear"/ "log 10" beschriftet
			}
		}
	}
}

//#############################################################################
// Read/Write (Reportdatei)
//#############################################################################

//! Funktion laedt die zu einer .psd datei gehoerigen zusatzinfos
//! Rueckkehrcode False wenn Fehler bei oeffnen der Datei, wenn weniger als 15
//! Punkte in der Datei waren oder das vorgefundene Format(Titelzeile) nicht
//! stimmt
//! true sonst
BOOL TAreaScanWindow::LoadReport( void )
{
	// es sind keine Zusatzinfos enthalten
	ReportUse.bIntegral= ReportUse.bTime= ReportUse.bMonitor= ReportUse.bAbsorber= FALSE;

	TTxtRead ReportFile( GetRepFileName() ); // Datei ffenen
	if ( !ReportFile.Exists() || (ReportFile.GetLines() < 3) ) return FALSE;

	HCURSOR hOldCursor= SetDefaultCursor( IDC_WAIT );	

	// Kennzeichnung Reportdatei
	char *Line= ReportFile.NextLine(); 
	if ( !strcmp(Line, "# Report:") ) { 
		SetCursor( hOldCursor );
		return FALSE; 
	}

	// 2.Zeile: Einlesen welche Zusatzinfos sind vorhanden
	Line= ReportFile.NextLine();
	int EntryCount= 0;
	char *Entry= strtok( Line, " :\n\r" ); // den ersten Eintrag auslesen
	while ( Entry ) { //! spaltenweises Einlesen der Eintrge (enden jeweils mit Leerzeichen/ Doppelpunkt/ Zeilenumbruch)
		bool bValidEntry= true;
		if ( !strcmp(Entry, "IntegralIntensity") )
			ReportUse.bIntegral= TRUE;
		else if ( !strcmp(Entry, "MeasurementTime") )
			ReportUse.bTime= TRUE;
		else if ( !strcmp(Entry, "MonitorSignal") )
			ReportUse.bMonitor= TRUE;
		else if ( !strcmp(Entry, "AbsorberPosition") )
			ReportUse.bAbsorber= TRUE;
		else if ( !strcmp(Entry, "Omega") || !strcmp(Entry, "Theta") || !strcmp(Entry, "MaxIntensity") || !strcmp(Entry, "PeakPosition") )
			/*sind auch gltige Eintrge*/;
		else 
			bValidEntry= false; // ansonsten unbekannt

		if ( bValidEntry ) EntryCount++;
		Entry= strtok( NULL, " :\n\r" ); // den nchsten Eintrag auslesen
	}
	if (EntryCount < 4) {
		SetCursor( hOldCursor );	
		return FALSE;
	}

	// erstellen eines formatierten Strings abhaengig von den Zusatzinfos	
	char buf[MaxString];
	strcpy(buf, "");
	strcat(buf, "%d");
	for (int i= 0; i < min(8, EntryCount)/*max. Platz fr 8 Eintrge*/; i++) 
		strcat(buf, " %f");

	ScanReport->New(); 
	ScanReport2->New();

	// Textzeilen mit den Daten einlesen
	while ( !ReportFile.IsEOF() ) { // zeilenweise
		Line= ReportFile.NextLine();
		// die ersten 4 Infos sind immer da, die folgenden je nach Scan
		float fOmega= 0, fTheta= 0, fMax= 0, fPeak= 0;
		float fValue[4];
		fValue[0]= fValue[1]= fValue[2]= fValue[3]= 0;
		sscanf( Line, buf, &EntryCount, &fOmega, &fTheta, &fMax, &fPeak, &fValue[0], &fValue[1], &fValue[2], &fValue[3] );

		// der Rest gilt als Zusatzinfo (je nachdem was in der 2. Zeile angegeben wurde - in folgender Reihenfolge:)
		float fIntegral= 0, fTime= 0, fMonitor= 0, fAbsorber= 0;
		int Idx= 0;		
		if ( ReportUse.bIntegral )	
			fIntegral= fValue[Idx++];
		if ( ReportUse.bTime )	
			fTime= fValue[Idx++];
		if ( (ReportUse.bMonitor) || (Monitor) ) 
			fMonitor= fValue[Idx++];
		if ( ReportUse.bAbsorber )	
			fAbsorber= fValue[Idx++];

		ScanReport->PAdd( fOmega, fTheta, fIntegral );  // 1.Reportkurve
		ScanReport2->PAdd( fTime, fMonitor, fAbsorber); // 2.Reportkurve
	}
	SetCursor( hOldCursor );
	if ( ScanReport->GetPNumber()<3 ) return FALSE;

	return TRUE;
};
//*****************************************************************************

//! speichert die zur Datenbasis gehoerigen zusatzinfos in einer Datei unter
//! dem aktuellen Dateinamen mit der Extension .rep ab
//! Rueckkehrcode immer true
BOOL TAreaScanWindow::SaveReport( void )
{
	float fOmega, fIntegral, fTheta;
	char buf[ MaxString *3];
	char fmt[ MaxString *3];
	int hFile, cnt;
	OFSTRUCT of;

	hFile= OpenFile( GetRepFileName(), &of, OF_CREATE );
	HCURSOR hOldCursor= SetDefaultCursor( IDC_WAIT );

	//! Headerteil anlegen in abhaengigkeit von den vorhandenen zusatzinfos
	sprintf(buf, "# Report: ");
	_lwrite( hFile, (LPSTR) buf, strlen( buf ) );

	strcpy( buf, EOL );
	_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );

	sprintf(buf, "ScanId : Omega : Theta : MaxIntensity : PeakPosition ");
	if (ReportUse.bIntegral )
		strcat( buf, ": IntegralIntensity " );
	if (ReportUse.bTime || ( Monitor != 0) )
		strcat( buf, ": MeasurementTime " );
	if ( ReportUse.bMonitor || ( Monitor != 0 ) )
		strcat( buf, ": MonitorSignal " );
	if (ReportUse.bAbsorber)
		strcat( buf, ": AbsorberPosition " );
	_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );

	strcpy( buf, EOL );
	_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );

	ScanReport->SetPP();
	ScanReport2->SetPP();
	cnt= 0;
	//! alle zusatzinfos in Tabelle speichern +datei schliessen
	while ( ScanReport->PGet( fOmega, fTheta, fIntegral ) )
	{
		char buf2[MaxString];
		float fdummy, fPeakPos, fTime, fMonitor, fAbsorber;
		TCurve* DummyCurve= lpDBase->GetCurve( cnt);
		sprintf(fmt, "%d %s %s %.0f %s", cnt, szODF, szTDF, DummyCurve->GetMax(1), szTDF );
		DummyCurve->GetGravityCenter(fPeakPos, fdummy, fdummy);
		ScanReport2->PGet(fTime, fMonitor, fAbsorber);
		if (VisualDB.bPsd)
			fPeakPos= fTheta + fPeakPos;
		if ( ReportUse.bIntegral )
		{
			sprintf(buf2, " %.0f", fIntegral);
			strcat( fmt, buf2 );
		}
		if ( ReportUse.bTime )
		{
			sprintf(buf2, " %.3f", fTime);
			strcat( fmt, buf2 );
		}
		if ( ReportUse.bMonitor || ( Monitor != 0 ) )
		{
			sprintf(buf2, " %.0f", fMonitor);
			strcat( fmt, buf2 );
		}
		if ( ReportUse.bAbsorber )
		{
			sprintf(buf2, " %.3f", fAbsorber);
			strcat( fmt, buf2 );
		}
		sprintf( buf, fmt, fOmega, fTheta, fPeakPos );
		_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		strcpy( buf, EOL );
		_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		cnt++;
	}
	_lclose( hFile );
	SetCursor( hOldCursor );
	return TRUE;
};

//#############################################################################
// Read/Write (psd-Datei)
//#############################################################################

//! liest gespeicherte Kurve (.psd)
//! Rueckkehrcode false wenn Fehler beim oeffnen der Datei, Extension ungl.
//! .psd, fehlerhaften Headerinfo. oder keine Eintraege nach[DATA]
//! sonst auch false (fehler)
BOOL TAreaScanWindow::LoadOldData()
{
	float omega, theta, intens, channel;
	//! FIX Fehler 39
	int cnt, column, rows;

	//! ins Arbeitverzeichnis wechseln + 'Datei nachladen'-Dialog oeffnen + Dateinamen prfen
	char NewFilename[ _MAX_PATH ];
	sprintf( NewFilename, "*.%s", szExtension );
	_chdir( szDataPath );
	if ( !FileOpenDialog( szMsgLine210, szFilter, NewFilename, szDataPath ) ) 
		return FALSE; // 'Abbruch' geklickt
	if ( strlen(NewFilename)==0 || strcmp(NewFilename, "*")==0 ) 
		return FALSE;
	char drv[ _MAX_DRIVE+1 ], dir[ _MAX_DIR+1 ], name[ _MAX_FNAME+1 ], ext[ _MAX_EXT+1 ];
	_splitpath( NewFilename, drv, dir, name, ext );
	char buf[MaxString];
	sprintf( buf, ".%s", szExtension);
	if ( _stricmp(ext, buf)!=0 )
		return FALSE;
	strcpy( FileName, NewFilename);

	StopSensorContinuous();
	Steering.Reset();
	bAreaScanStarted= FALSE; // fr Steering.Reset() abschalten
	bInterrupted= FALSE;

	//*** Database freigeben, Fenster neu zeichnen
	lpDBase->New();
	nActiveScan= 0;
	MainCurve= lpDBase->GetCurve( nActiveScan );
	UpdateWnd();

	// set waiting cursor
	HCURSOR hOldCursor= SetDefaultCursor( IDC_WAIT );

	//*** Datei ffnen, Header einladen
	TTxtRead Datei( FileName );	
	SetInfo( szMsgLine313 );
	if ( !LoadMeasurementInfo(Datei) ) {
		SetCursor( hOldCursor ); // restore cursor before waiting cursor
		MessageBox( szMsgLine014, szMsgFailure, MBINFO );
		return FALSE;
	}

	// zeilenweises Einlesen der Reihen
	TCurve *TheCurve= 0;
	rows= 1;
	Datei.Restart();
	bool DataGef= false;
	SetInfo( szMsgLine314 );
	while ( !Datei.IsEOF() ) { // zeilenweise
		char *line= Datei.NextLine(); // nicht freigeben, das erleigt TTxtRead fr uns
		if ( strstr(line, "[Data]") ) { // [Data] gefunden :-)
			DataGef= true; 
			continue; // Zeile berlesen
		}
		if ( !DataGef ) continue; // solange [Data] nicht gefunden: Zeilen berlesen

		//! alle 5 gelesenen Scans Info ausgeben
		if ( !(lpDBase->GetCNumber() % 5) ) {
			sprintf( buf, szMsgLine211, lpDBase->GetCNumber() );
			SetInfo( buf );
		}

		// letzte Kurve auswhlen (Daten dort hinein schreiben)
		TheCurve= lpDBase->GetCurve( lpDBase->GetCNumber()-1 );
		//07.05.2004 TheCurve->FastOpen();

		//! in Abhngigkeit von Detektor der Datenbasis (Psd oder 0-dim.) den Thetastartwert je Kurve berechnen
		theta= (VisualDB.bPsd) ? 0.0 : dThetaMin + (rows - 1) * dOmegaWidth * VisualDB.dMoveRelation - 0.5 * VisualDB.dThetaWindow;
		channel= 0.0;
		column= 0;

		char *actual= strtok( line, " \t\n\r" ); // den ersten Messwert auslesen
		while ( actual ) { //! spaltenweises Einlesen der Messwerte (enden jeweils mit Leerzeichen/ Tab/ Zeilenumbruch)
			intens= atof( actual );

			// Messwert in Kurve speichern
			if ( column <= nLastReadColumn )
			{
				if ( column >= nFirstReadColumn )
					TheCurve->PAdd( theta, intens, channel ); //07.05.2004 FastP...
				column++;
				channel += nAddedChannels;
				//! in Abhngigkeit von Detektor der Datenbasis (Psd oder 0-dim.) de Scanreportwerte der Datenbasis
				theta += (VisualDB.bPsd) ? (fPsdRange) * nAddedChannels : dThetaWidth; // contains here the PsdStep
			}
			actual= strtok( NULL, " \t\n\r" ); // den nchsten Messwert auslesen
		}
		//07.05.2004 TheCurve->FastClose();
		if ( column>0 ) lpDBase->AddCurve( ); // nur neue Kurve anhngen, wenn TheCurve benutzt wurde; d.h. columns>0
		rows++; //! FIX Fehler 39
	}
	if ( !DataGef ) { // [Data] nicht vorhanden
		SetCursor( hOldCursor ); // restore cursor before waiting cursor
		return FALSE;
	}

	if ( rows>1 ) lpDBase->DelCurve(); // die zuletzt selbst angehngte Kurve lschen (wre fr nchste Zeile gewesen, die nicht mehr gekommen ist)

	//! Bereich des PSD aus Min und Max der letzten Kurve ermitteln
	TheCurve= lpDBase->GetCurve( lpDBase->GetCNumber()-1 );
	fPsdRange= TheCurve->GetMax( 0 ) - TheCurve->GetMin( 0 );

	//*** Generation of ScanRep from ranges which corrections of measurement area
	{
		//! FIX Fehler 39
		omega= VisualDB.dOmegaMin;
		theta= VisualDB.dThetaMinFirst;
		//! unterscheiden O2T und Standard-Scan
		if (dThetaMin == dThetaMax)
			dThetaWidth= 0.0;
		else
			dThetaWidth= dOmegaWidth * dMoveRelation;
		//! dOmegaMax= dOmegaMin + dOmegaWidth * ( lpDBase->GetCNumber() - 1 );

		//! test ob zugehoerige reportdatei exist. bzw. defekt ist
		if ( !LoadReport() )
		{
			char *msg= new char[ strlen(szMsgLine030) + strlen(GetRepFileName()) + 1 ]; // + Nullterminierung
			sprintf(msg, szMsgLine030, GetRepFileName() );
			MessageBox( msg, szMsgFailure, MBINFO );
			_FREELIST(msg);
			ScanReport->New();
			//07.05.2004 ScanReport->FastOpen();
			ScanReport2->New();
			//07.05.2004 ScanReport2->FastOpen();
			//! ScanReport erstellen
			float dummy;
			for ( cnt= 0; cnt < lpDBase->GetCNumber(); cnt++ )
			{
				//! NEU! Fehler 33
				TheCurve= lpDBase->GetCurve(cnt);
				TheCurve->GetGravityCenter(dummy, intens, dummy);
				ScanReport->PAdd( omega, theta, intens ); //07.05.2004 FastP...
				dummy= 0.0;
				ScanReport2->PAdd(dummy, dummy, dummy); //07.05.2004 FastP...
				omega += dOmegaWidth;
				theta += dThetaWidth;
			}
			//07.05.2004 ScanReport2->FastClose();
			//07.05.2004 ScanReport->FastClose();
		}
	}

	//*** Fenster neu zeichnen
	//! automatisch Bitmap errechnen wenn entspr. Ausgabetyp gewaehlt
	if ( eOutputType==otReciprokeLatticeBitmap || eOutputType==otMatrixBitmap )
		BSource->FormatDBaseToBitmapSource();
	UpdateWnd();
	SetInfo( szMsgLine212 );
	
	//**** Daten aquirieren Peak- und Cross-Scan speichern **********************
#ifdef Peak_and_Cross //! ? nicht eingeschaltet ?
	float psdtheta, intens, channel, maxintens= 0.0;
	int maxcu, maxch;
	XShift= 0.0;
	for ( Idx= 0; Idx < lpDBase->GetCNumber(); Idx++ )
	{
		TheCurve= lpDBase->GetCurve( Idx );
		TheCurve->GetGravityCenter( psdtheta, intens, channel, 2 );
		if ( intens > maxintens )
		{
			maxintens= intens;
			maxcu= Idx;
			maxch= channel;
		}
	}
	TheCurve= lpDBase->GetCurve( maxcu );
	*SecondCurve= *TheCurve;
	SaveSecondCurve();
	SecondCurve->Delete();
	for ( Idx= 0; Idx < lpDBase->GetCNumber(); Idx++ )
	{
		TheCurve= lpDBase->GetCurve( Idx );
		TheCurve->SetPP( maxch );
		TheCurve->PGet( psdtheta, intens, channel );
		psdtheta= OmegaMin + Idx * OmegaWidth;
		SecondCurve->PAdd( psdtheta, intens, channel );
	}
	// Speichern der Curven
	SaveSecondCurve();
#endif

	SetCursor( hOldCursor ); // restore cursor before waiting cursor
	bFileChanged= FALSE;
	bIsNewFile= FALSE;
	bOldDataLoaded= TRUE;
	return TRUE;
};
//*****************************************************************************

//! Funktion speichert einen Messdatensatz
//! 1.Parameter gibt an ob neuer Dateiname zu waehlen ist (SaveWithNewName)
//! oder ob automatisch unter altem Namen (NoAskForSave) gespeichert werden
//! soll
//! Rueckkehrcode False wenn Fehler bei anlegen der Datei oder bei speichern
//! der headerinfos sonst immer true
BOOL TAreaScanWindow::SaveFile( EAskType ask )
{
	TCurve *TheCurve;
	float fIntensity;
	float d0, d2;
	char msg[ MaxString ];
	int hFile, idx, numbercolumn, nCIdx;
	OFSTRUCT of;

	//! anlegen der Datei (event. mit eingabe des Dateinamen)
	if ( !TPlotWindow::SaveFile( ask ) )
		return FALSE;

	//*** explicite repaint of window, since it's normally not possible.
	UpdateWnd();

	//! speichern der reportkurve
	SaveReport();

	//****************************
	//! ueberschreiben der Datei mit Headerinfo.
	if ( !SaveMeasurementInfo( FALSE ) )
	{
		MessageBox( szMsgLine014, szMsgFailure, MBINFO );
		return FALSE;
	}

	hFile= OpenFile( FileName, &of, OF_WRITE );
	HCURSOR hOldCursor= SetDefaultCursor( IDC_WAIT );

	// Daten an den Header anhaengen
	_llseek( hFile, 0, SEEK_END );
	char *buf;
	// 1. Scan ist noch nicht mit gueltigen Daten belegt
	if ( !bSaveContinuous || lpDBase->GetCNumber()>1 ) {
		numbercolumn= lpDBase->GetCurve( 0 )->GetPNumber();
		buf= new char [ max(20 * numbercolumn, strlen(szMsgLine028)+21/*Platz fr 2 ints und Nullterminierung*/) ];
		//! alle Kurven der Datenbasis durchlaufen und jeweils alle Intens.werte
		//! der Kurve in Datei ablegen
		for ( nCIdx= 0; nCIdx < lpDBase->GetCNumber(); nCIdx++ )
		{
			sprintf( buf, szMsgLine028, nCIdx + 1, lpDBase->GetCNumber() );
			SetInfo( buf );

			TheCurve= lpDBase->GetCurve( nCIdx );
			TheCurve->SetPP();
			//07.05.2004 TheCurve->FastOpen();
			for ( idx= 0; idx < numbercolumn; idx++ )
			{
				if ( TheCurve->PGet( d0, fIntensity, d2 ) ) //07.05.2004 FastP...
				{ //! formatieren der Intensitaetswerte mit untersch. Genauigkeit
					// 22.04.2003 Kullmann+Reinecker: while(1)-Schleifen durch if-then-else ersetzt
					if ( 0.00001 > fIntensity )
						sprintf( msg, "0 " );
					else if ( 10.0 > fIntensity )
						sprintf( msg, "%.4f ", fIntensity );
					else if ( 100.0 > fIntensity )
						sprintf( msg, "%.3f ", fIntensity );
					else if ( 1000.0 > fIntensity )
						sprintf( msg, "%.2f ", fIntensity );
					else
						sprintf( msg, "%.1f ", fIntensity );
				}
				else
					strcpy( msg, "0 " );
				if ( 0 == idx )
					strcpy( buf, msg );
				else
					strcat( buf, msg );
			}
			//! ablegen einer Kurve als zeile in Datei
			strcat( buf, EOL );
			//07.05.2004 TheCurve->FastClose();
			_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
		}
		_FREELIST(buf);
	}

	//! schliessen der Datei
	_lclose( hFile );
	SetCursor( hOldCursor );
	bFileChanged= FALSE;
	return TRUE;
};
//*****************************************************************************

//! haengt aktuelles Kurve an Datei mit FileName an
//! aufruf nur bei kontinuierlichem Speichern
//! Rueckkehrcode immer true
BOOL TAreaScanWindow::UpdateFile( void )
{
	TCurve* TheCurve;
	float fIntensity;
	float d0, d2;
	char buf[ MaxString ], fmt[ MaxString ];
	int hFile, idx, numbercolumn;
	OFSTRUCT of;
	//! nicht von Diffr.gruppe auskommentiert
	//! int nOldId= mlGetAxis();
	HCURSOR hOldCursor= SetDefaultCursor( IDC_WAIT );

	//! Datei oeffnen + Statusinfo ausgeben
	hFile= OpenFile( FileName, &of, OF_WRITE );
	_llseek( hFile, 0, SEEK_END );
	lpDBase->GetLastCurve() ->SetPP(); // first point of last curve
	sprintf( buf, szMsgLine029, lpDBase->GetCNumber() - 1 );
	SetInfo( buf );

	//! letzte Kurve der Datenbasis auswaehlen + alle Intens.werte der Kurve
	//! auslesen und als zeile an Datei anhaengen
	numbercolumn= lpDBase->GetCurve( 0 )->GetPNumber();
	TheCurve= lpDBase->GetLastCurve();
	// 07.05.2004 TheCurve->FastOpen();
	TheCurve->SetPP();
	for ( idx= 0; idx < numbercolumn; idx++ )
	{
		//! bestimmt anzahl dez.-stellen und legt Intensitaetswert demenstpr.
		//! formatiert ab
		if ( (TheCurve->PGet(d0, fIntensity, d2)) && (fIntensity != 0.0) ) //07.05.2004 FastP...
		{
			short pp= 3 - log10( fIntensity );
			if ( pp < 0 )
				pp= 0;
			strcpy( fmt, "%.3f " );
			fmt[ 2 ]= ( char ) ( '0' + pp );
			sprintf( buf, fmt, fIntensity );
			goto Ready;
		}
		sprintf( buf, "0 " );
Ready:
		_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );
	}
	// 07.05.2004 TheCurve->FastClose();
	strcpy( buf, EOL );
	_lwrite( hFile, ( LPSTR ) buf, strlen( buf ) );

	//! Datei schliessen
	_lclose( hFile );
	SetCursor( hOldCursor );
	bFileChanged= FALSE;
	return TRUE;
};

//#############################################################################
// Read/Write (psd-Datei - Kommentar+Header)
//#############################################################################

//! laden der Messungsinfos aus einer .psd datei
//! hFile ist Filehandle der Messdatei
//! Rueckkehrcode False wenn Datei zu kurz ,[HEADER] nicht vorhanden,
//! Filetyp ungl. 1 oder OmegaStep= 0
//! true sonst
BOOL TAreaScanWindow::LoadMeasurementInfo( TTxtRead &aFile ) {
	int columns;

	nFirstReadColumn= nLastReadColumn= columns= 0;
	dThetaOffset= 0.0;
	//! FIX Fehler 39
	VisualDB.bPsd= FALSE;
	//! Messkanal auf default-wert
	nMeasurementChannel= 0;
	//! Kullmann, Reinecker: fehlende Initialisierungen nachgebessert
	fPsdRange= fMaxTime= 0;
	dThetaMin= dThetaMax= dThetaWindow= VisualDB.dThetaWindow= dThetaWidth= 0;
	dMoveRelation= VisualDB.dMoveRelation= 0;
	dOmegaMin= VisualDB.dOmegaMin= dOmegaMax= VisualDB.dOmegaMax= 0;
	nAddedChannels= 1;
	eSaveFormat= ffStandardFile;

	// Header-Informationen auswerten
	aFile.Restart();
	bool HeaderGef= false;
	while ( !aFile.IsEOF() ) { // zeilenweise einlesen
		char *line= aFile.NextLine(); // line nicht freigeben, das erledigt TTxtRead
		if ( strstr(line, "[Header]") ) { // [Header] gefunden :-)
			HeaderGef= true; 
			continue; // Zeile berlesen
		}
		if ( !HeaderGef ) continue; // solange [Header] nicht gefunden: Zeilen berlesen
		if ( strstr(line, "[Data]") ) break; // bei [Data]: Header komplett = fertig :-)


		char *keyword= strtok( line, " =\n\r" ); // den ersten Teil vor "=" auslesen
		char *info= strtok( NULL, " =\n\r" ); // den ersten Teil nach "=" auslesen
		while ( keyword && info ) { // solange weitere Daten in dieser Zeile

			/*if ( !strcmp(keyword, "Date") ||
				 !strcmp(keyword, "DataRows") ||
				 !strcmp(keyword, "Time") ||
				 !strcmp(keyword, "HV") ) 
			{
				// einfach berlesen

			} else */if ( !strcmp(keyword, "User") ) {
				MeasurementParameter.SetUser( info );

			} else if ( !strcmp(keyword, "Target") ) {
				MeasurementParameter.SetTarget( info );

			} else if ( !strcmp(keyword, "Substrat") ) {
				MeasurementParameter.SetTargetBulk( info );

			} else if ( !strcmp(keyword, "Reflection") ) {
				MeasurementParameter.SetReflection( info );

			} else if ( !strcmp(keyword, "Orientation") ) {
				MeasurementParameter.SetOrientation( info );

			} else if ( !strcmp(keyword, "DataColumns") ) {
				columns= atof( info );

			} else if ( !strcmp(keyword, "FirstColumn") ) {
				nFirstReadColumn= atof( info );

			} else if ( !strcmp(keyword, "LastColumn") ) {
				nLastReadColumn= atof( info );

			} else if ( !strcmp(keyword, "WaveLength") ) {
				MeasurementParameter.SetWaveLength( info );

			} else if ( !strcmp(keyword, "PsdStep") ) {
				fPsdRange= atof( info );
				//! Gradwert in Sekunden umrechnen
				//        ::fPsdRange *= 3600.0;
				//! FIX Fehler 39
				VisualDB.bPsd= TRUE;

			} else if ( !strcmp(keyword, "ThetaMin") ) {
				dThetaMin= atof( info );

			} else if ( !strcmp(keyword, "ThetaMax") ) {
				dThetaMax= atof( info );

			} else if ( !strcmp(keyword, "MoveRelation") ) {
				dMoveRelation= atof( info );
				//! FIX Fehler 39
				VisualDB.dMoveRelation= dMoveRelation;

			} else if ( !strcmp(keyword, "OmegaMin") ) {
				dOmegaMin= atof( info );
				//! FIX Fehler 39
				VisualDB.dOmegaMin= dOmegaMin;

			//! FIX Fehler 39
			} else if ( !strcmp(keyword, "OmegaMax") ) {
				dOmegaMax= atof( info );
				VisualDB.dOmegaMax= dOmegaMax;

			} else if ( !strcmp(keyword, "OmegaStep") ) {
				dOmegaWidth= atof( info );

			//! FIX Fehler 39
			} else if ( !strcmp(keyword, "ThetaWindow") ) {
				dThetaWindow= atof( info );
				VisualDB.dThetaWindow= dThetaWindow;
				dThetaWidth= dThetaWindow / (columns - 1);

			} else if ( !strcmp(keyword, "TimePerScan") ) {
				fMaxTime= atof( info );

			} else if ( !strcmp(keyword, "PsdAddedChannels") ) {
				nAddedChannels= atoi( info );

			} else if ( !strcmp(keyword, "MeasurementChannel") ) {
				nMeasurementChannel= atoi( info );

			//! Test auf folgende Eintraege bei DB-Zusammensetzung
			} else if ( bComposeDB ) {
				if ( !strcmp( keyword, "Point_Number" ) ) {
					columns= atoi( info );
				} else if ( !strcmp( keyword, "Zerlegung" ) ) {
					if ( !strcmp( info, "PSD" ) ) VisualDB.bPsd= TRUE;
				} else {
					nFirstReadColumn= 0;
					nLastReadColumn= columns;
				}

			} else if ( !strcmp(keyword, "FileType") ) {
				if ( !strcmp(info, "1") || !strcmp(info, "Standard") )
					eSaveFormat= ffStandardFile;
				else 
					return FALSE; // falsches Dateiformat
			}

			keyword= strtok( NULL, " =\n\r" ); // den nchsten Teil vor "=" auslesen
			info= strtok( NULL, " =\n\r" ); // den nchsten Teil nach "=" auslesen
		}
	}
	if ( !HeaderGef ) return FALSE; // [Header] nicht vorhanden

	//! einige Headerwerte berprfen und ggf. auf gltige Werte setzen
	if ( !nLastReadColumn )
		nLastReadColumn= columns;
	else if ( nLastReadColumn > columns )
		nLastReadColumn= columns;
	if ( !nFirstReadColumn )
		nFirstReadColumn= 0;
	dThetaOffset= 0.0;
	if ( !dOmegaWidth ) {
		// 17.05.2004 Meldung wird sonst doppelt ausgegeben MessageBox( szMsgLine014, szMsgFailure, MBINFO );
		return FALSE;
	}

	//! FIX Fehler 39
	if ( VisualDB.bPsd)
	{
		VisualDB.fAngleStep= fPsdRange;
		VisualDB.fAngleRange= fPsdRange * (columns + 1) * nAddedChannels;
		//! psd-offset in kurve einrechnen
		VisualDB.dThetaMinFirst= dThetaMin - nMeasurementChannel * VisualDB.fAngleStep;
		VisualDB.dThetaMaxFirst= VisualDB.dThetaMinFirst + VisualDB.fAngleRange;
		//! psd-offset in kurve einrechnen
		VisualDB.dThetaMinLast= dThetaMax - nMeasurementChannel * VisualDB.fAngleStep;
		VisualDB.dThetaMaxLast= VisualDB.dThetaMinLast + VisualDB.fAngleRange;
	}
	else
	{
		VisualDB.fAngleStep= VisualDB.dThetaWindow / (columns - 1);
		VisualDB.fAngleRange= VisualDB.dThetaWindow;
		VisualDB.dThetaMinFirst= dThetaMin - 0.5 * VisualDB.dThetaWindow;
		VisualDB.dThetaMaxFirst= dThetaMin + 0.5 * VisualDB.dThetaWindow;
		VisualDB.dThetaMinLast= dThetaMax - 0.5 * VisualDB.dThetaWindow;
		VisualDB.dThetaMaxLast= dThetaMax + 0.5 * VisualDB.dThetaWindow;
	}
	return TRUE;
};
//*****************************************************************************

//! Funktion speichert Headerinformationen zu einem Areascan in einer Datei
//! 1.Parameter gibt an, ob die Datei neu erstellt(=0) werden soll oder nur
//! aktualisiert (ungl. 0) werden soll
//! Rueckkehrcode false wenn probleme beim erstellen bzw. oeffnen der Datei
//! sonst immer true
BOOL TAreaScanWindow::SaveMeasurementInfo( BOOL UpdateHeader )
{
	int hFile;
	UINT nSize;
	TCurve *Report= lpDBase->GetScanReport();
	char buf[ MaxString + 1 ], buf2[ MaxString / 2 ], buf3[ MaxString / 2 ];
	char format[ 2 * MaxString + 1 ];
	int ival;
	OFSTRUCT of;
	SYSTEMTIME t;

	//klier 01.03.2003
	SetMeasurementProtocolParameter();
	SaveProtocolDiffractometryParameter();

	//! oeffnet oder erstellt Datei + wenn Fehler dann Meldung + abbruch
	if ( UpdateHeader )
		hFile= OpenFile( FileName, &of, OF_WRITE );
	else
		hFile= OpenFile( FileName, &of, OF_CREATE );
	if ( hFile==HFILE_ERROR )
	{
		MessageBox( sth_CannotOpenFile, szMsgFailure, MBSTOP );
		return FALSE;
	}
	//! Systemzeit + datum holen
	GetLocalTime( &t );
	//! Headerinformationen in String kopieren
	char *data= new char[ DATAOFFSET+1 ];
	strcpy( format, "Comment=%s" );
	sprintf( buf, format, MeasurementParameter.GetComment() );
	strcpy( data, buf );
	strcat( data, EOL );

	strcat( data, "[Header]" );
	strcat( data, EOL );
	strcpy( format, "User=%s Date=%02i.%02i.%i Time=%2d:%02d:%02d" );
	sprintf( buf, format, MeasurementParameter.GetUser(),
			 t.wDay, t.wMonth, t.wYear, t.wHour, t.wMinute, t.wSecond );
	strcat( data, buf );
	strcat( data, EOL );

	strcpy( format, "DataRows=%d DataColumns=%d FileType=%d" );
	// HD 960106
	strcat( format, EOL );
	strcat( format, "FirstColumn=0 LastColumns=%d" );
	ival= lpDBase->GetCurve( 0 )->GetPNumber() + GetAdditionalColumns();
	sprintf( buf, format, lpDBase->GetCNumber(), ival, ( BOOL ) ( eSaveFormat == ffStandardFile ), ival - 1 );
	strcat( data, buf );
	strcat( data, EOL );

	// aktuelle Bereiche abspeichern
	sprintf( format, "OmegaMin=%s OmegaStep=%s OmegaMax=%s", szODF, szOWF, szODF );
	sprintf( buf, format, Report->GetMin( P_X ), dOmegaWidth, Report->GetMax( P_X ) );
	strcat( data, buf );

	//klier 30.01.2003  Der Wert fr das Offset wird mit ausgegeben
	//	 sprintf( format, " OmegaOffset=%s", szODF );
	//	 sprintf( buf, format, mlGetOffset(nOmega) );
	//	 strcat( data, buf );
	strcat( data, EOL );

	sprintf( format, "ThetaMin=%s ThetaStep=%s ThetaMax=%s MoveRelation=%%.2f", szTDF, szTWF, szTDF );
	//! in abhaengigkeit von art des Scans haben die Thetaeintraege verschiedene
	//! bedeutungen
	if (VisualDB.bPsd)
		sprintf( buf, format, Report->GetMin( P_Y ) - dPsdOffset, dOmegaWidth * VisualDB.dMoveRelation, Report->GetMax( P_Y ) - dPsdOffset, VisualDB.dMoveRelation ); //! speichern einer Psd-Datenbasis
	//! speichern einer SLD-DatenBasis mit zentren der Thetawindows als Thetawerte
	else
		sprintf( buf, format, VisualDB.dThetaMinFirst + 0.5* VisualDB.dThetaWindow, dOmegaWidth * VisualDB.dMoveRelation, VisualDB.dThetaMinFirst + 0.5* VisualDB.dThetaWindow + (Report->GetPNumber() - 1)* dOmegaWidth * VisualDB.dMoveRelation, VisualDB.dMoveRelation );
	strcat( data, buf );

	//klier 30.01.2003  Der Wert fr das Offset wird mit ausgegeben
	//    sprintf( format, " ThetaOffset=%s", szTDF );
	//    sprintf( buf, format, mlGetOffset(nTheta) );
	//    strcat( data, buf );
	strcat( data, EOL );

	strcpy( format, "Target=%s Reflection=%s Orientation=%s" );
	MeasurementParameter.GetReflection(buf2);
	MeasurementParameter.GetOrientation(buf3);
	sprintf( buf, format, MeasurementParameter.GetTarget(), buf2, buf3 );
	strcat( data, buf );
	strcat( data, EOL );

	strcpy( format, "WaveLength=%.3f Current=%d HV=%d" );
	sprintf( buf, format, MeasurementParameter.GetWaveLength(), MeasurementParameter.GetCurrent(), MeasurementParameter.GetVoltage() );
	strcat( data, buf );
	strcat( data, EOL );

	//! in Abhngigkeit vom Detektor (0-dim. oder psd ) Fehler
	if ( VisualDB.bPsd )
	{
		strcpy( format, "TimePerScan=%.2f PsdStep=%.9f PsdAddedChannels=%d MeasurementChannel=%d" );
		sprintf( buf, format, fMaxTime, (bOldDataLoaded) ? VisualDB.fAngleStep : VisualDB.fAngleStep / 3600.0
				 /* GetPsd()->GetWidth()*/,   nAddedChannels,
				 nMeasurementChannel );
		strcat( data, buf );
	}
	else
	{
		//! FIX Fehler 39
		strcpy( format, "TimePerScan=%.2f ThetaWindow=%.2f" );
		sprintf( buf, format, fMaxTime, VisualDB.dThetaWindow );
		strcat( data, buf );
	}
	//! auffllen de Strings mit Leerzeichen + ablegen des Strings in der Datei
	//! + schliessen der Datei
	for ( nSize= strlen( data ); nSize < DATAOFFSET - 10; nSize++ )
		data[ nSize ]= ' ';
	data[ nSize ]= 0x0;
	strcat( data, EOL );
	strcat( data, "[Data]" );
	strcat( data, EOL );
	_lwrite( hFile, data, strlen( data ) );
	_lclose( hFile );
	_FREELIST(data);
	return TRUE;
};
//*****************************************************************************

//! ?
//! Rueckkehrcode bei ShiftedStandard ist die Anzahl der Psd-kanaele die
//! benoetigt werden um den Thetabereich zu ueberdecken
//! sonst immer 0
int TAreaScanWindow::GetAdditionalColumns( void )
{
	if ( eSaveFormat != ffShiftedStandard )
		return 0;
	if ( dOmegaWidth == 0.0 )
		return 0;
	return GetShift( ( ( dOmegaMax - dOmegaMin ) / dOmegaWidth ) + 1 );
};
//*****************************************************************************

//! Funktion liefert zu Anzahl der Scans (1.Parameter) Anzahl der Psd-kanaele
//! die benoetigt werden um den Thetabereich zu ueberdecken
//! (nur bei ShiftedStan.) sonst 0 als Rueckkehrcode
int TAreaScanWindow::GetShift( int ScanNumber )
{
	if ( GetPsd()->GetWidth() == 0.0 )
		return 0;
	if ( eScanType == stStandardScan )
		return 0;
	return ScanNumber * ( dOmegaWidth * dMoveRelation ) / GetPsd()->GetWidth();
};
//*****************************************************************************
// Read/Write
//*****************************************************************************

//! Zusammensetzen einer Datenbasis
BOOL TAreaScanWindow::ComposeDB( void )
{
	//>>>
	TModalDlg * dlg;
	const int LLength= 2500;
	LPSTR lpBuf;
	char buf[ MaxString ];
	float x, x2, x3, y, z, z2, z3;
	int hFile, cnt, idx, idx2;
	OFSTRUCT of;
	char name[ _MAX_PATH+1 ], oldname[ _MAX_PATH+1 ];
	BOOL bReady= FALSE;
	TCurve *TheCurve;
	float dummy;

	//! Aufruf des Dialoges DB zusammensetzen
	MaxFiles= 0;
	dlg= ( TComposeDBDlg * ) new TComposeDBDlg( this );
	if ( dlg ) dlg->ExecuteDialog( GetHandle() );
	_FREEOBJ(dlg);
	if ( MaxFiles <= 0 )
		return TRUE; //! wenn Zahl keine Kurven

	HCURSOR hOldCursor= SetDefaultCursor( IDC_WAIT );
	bComposeDB= TRUE;
	bFileChanged= TRUE;
	//! neue DB
	lpDBase->New();
	nActiveScan= 0;
	TheCurve= lpDBase->GetCurve( nActiveScan );
	strcpy( name, FirstFile );
	name[ max(0, strlen(name)-8) ]= '\0';
	strcpy( oldname, name );
	idx= idx2= atoi( &FirstFile[ max(0, strlen(FirstFile)-8) ] );
	//! neuer Scan-Report
	ScanReport->New();
	//! fuer jede Kurve Datei oeffnen + Header einlesen + Datenaufnahme
	for ( idx; idx < (idx2 + MaxFiles); idx++ )
	{
		strcpy( name, oldname );
		sprintf( buf, "%.4d.CRV", idx );
		strcat( name, buf );
		SetInfo(name);

		TTxtRead Datei(name);
		if ( !LoadMeasurementInfo(Datei) ) {
			SetCursor( hOldCursor ); // restore cursor before waiting cursor
			return FALSE;
		}
		hFile= OpenFile( name, &of, OF_READ );

		nActiveScan= lpDBase->GetCNumber() - 1;
		TheCurve= lpDBase->GetLastCurve();
		lpBuf= new char [ LLength ];
		if ( !SetFPOnData( hFile ) )
		{
			SetCursor(hOldCursor);
			return FALSE;
		}
		bReady= FALSE;
		for ( cnt= 0; !bReady; cnt++ )
			switch ( GetFileLine( hFile, lpBuf, LLength ) )
			{
				case R_Overflow:
					cnt++;
					bReady= TRUE;
					continue;

				case R_EndOfFile:
					cnt++;
					bReady= TRUE;
					//Fehler? Kullmann+Reinecker: Fehlt hier ein break?

				default:
					if ( 3 != sscanf( lpBuf, "%f %f %f", &x, &y, &z ) )
						continue;
					if ( cnt == 0 )
						x2= x;
					if ( VisualDB.bPsd )
						x -= x2;
					TheCurve->PAdd( x, y, z );
			}
		if ( idx < (idx2 + MaxFiles) - 1 )
			lpDBase->AddCurve( ); // 10.04.2004 Parameterbergabe nicht mehr notwendig TheCurve->GetPNumber() 
		_lclose( hFile );
		TheCurve->GetGravityCenter(dummy, y, dummy);
		ScanReport->PAdd( z, x2 , y );
		_FREELIST(lpBuf);
	} // for (idx...
	//! erste Datei wiederholt lesen
	//! Bestimmung der Report-Informationen fuer Omega, Theta, Relation, Schritt,..

	TTxtRead Datei(FirstFile);
	if ( !LoadMeasurementInfo(Datei) ) {
		SetCursor( hOldCursor ); // restore cursor before waiting cursor
		return FALSE;
	}
	ScanReport->SetPP();
	ScanReport->PGet(x, z, y);
	ScanReport->SetPP( 1 );
	ScanReport->PGet(x2, z2, y);
	ScanReport->SetPPLast();
	ScanReport->PGet(x3, z3, y);
	if ( VisualDB.bPsd )
	{
		if ( nLastReadColumn > 0 )
			nAddedChannels= 4096 / (nLastReadColumn + 1);
		else
			nAddedChannels= 1;
		VisualDB.dOmegaMin= dOmegaMin= x;
		VisualDB.dOmegaMax= dOmegaMax= x3;
		dThetaMin= d2ThetaStart= z;
		dThetaMax= z3;
		dOmegaWidth= ( x3 - x ) / ( lpDBase->GetCNumber() - 1 );
		dThetaWidth= ( z3 - z ) / ( lpDBase->GetCNumber() - 1 );
		dMoveRelation= VisualDB.dMoveRelation= dThetaWidth / dOmegaWidth;
		TheCurve= lpDBase->GetCurve( 0 );
		TheCurve->SetPP();
		TheCurve->PGet(x, y, z);
		TheCurve->SetPP( 1 );
		TheCurve->PGet(x2, y, z);
		VisualDB.fAngleStep= x2 - x;
		VisualDB.fAngleRange= VisualDB.fAngleStep * TheCurve->GetPNumber();
	}
	else
	{
		VisualDB.dOmegaMin= dOmegaMin= x;
		VisualDB.dOmegaMax= dOmegaMax= x3;
		dThetaMin= d2ThetaStart= z;
		dThetaMax= z3;
		dOmegaWidth= ( x3 - x ) / ( lpDBase->GetCNumber() - 1 );
		dThetaWidth= ( z3 - z ) / ( lpDBase->GetCNumber() - 1 );
		dMoveRelation= VisualDB.dMoveRelation= dThetaWidth / dOmegaWidth;
		TheCurve= lpDBase->GetCurve( 0 );
		TheCurve->SetPP();
		TheCurve->PGet(x, y, z);
		TheCurve->SetPPLast();
		TheCurve->PGet(x2, y, z);
		VisualDB.dThetaWindow= x2 - x;
		VisualDB.fAngleStep= VisualDB.dThetaWindow / (TheCurve->GetPNumber() - 1);
		VisualDB.fAngleRange= VisualDB.dThetaWindow;
	}
	VisualDB.dThetaMinFirst= dThetaMin;
	if (dThetaWidth != 0)
		VisualDB.dThetaMinLast= dThetaMin + (dOmegaMax - dOmegaMin) * dMoveRelation;
	else
		VisualDB.dThetaMinLast= dThetaMin;
	VisualDB.dThetaMaxFirst= dThetaMin + VisualDB.fAngleRange;
	VisualDB.dThetaMaxLast= VisualDB.dThetaMinLast + VisualDB.fAngleRange;
	//! Fenster-Aktualisierung + DB-Zusammenfassung deaktiviert
	UpdateWnd();
	bComposeDB= FALSE;
	SetCursor(hOldCursor);
	return TRUE;
};
//*****************************************************************************

//! Sichern einer aktuellen Kurve der DB in crv-Datei
BOOL TAreaScanWindow::SaveDismantleCurve( int counter )
{
	int hFile;
	OFSTRUCT of;
	UINT nSize;
	char format[ MaxString ];
	char buf[ 2 * MaxString ], buf2[ 20 ], buf3[ 20 ], fmt[ 30 ];
	SYSTEMTIME t;
	float v, x, y, z, fOmega, fTheta;

	//! Dateinamen anlegen
	sprintf( buf, "%.4d.CRV", counter );
	strcpy( FileName, szDataPath );
	strcat( FileName, DismantleFile );
	strcat( FileName, buf );
	SetInfo(FileName);
	//! Kurve auslesen
	MainCurve= lpDBase->GetCurve( counter );
	ScanReport->SetPP( counter );
	ScanReport->PGet( fOmega, fTheta, z );
	MainCurve->SetPP();
	//! Datei anlegen + Header
	hFile= OpenFile(FileName, &of, OF_CREATE);
	if ( hFile==HFILE_ERROR )
		return FALSE;

	_llseek (hFile, 0, SEEK_END );
	sprintf( fmt, "%s %s %s\r\n", mGetSF(), "%.4f", "%.4f" );
	// 07.05.2004 MainCurve->FastOpen();
	GetLocalTime( &t );
	char *data= new char[ DATAOFFSET + 1 ];
	strcpy( format, "Comment=%s" );
	sprintf( buf, format, MeasurementParameter.GetComment() );
	strcpy( data, buf );
	strcat( data, EOL );
	strcat( data, "[Header]" );
	strcat( data, EOL );
	//! Neu im Header: Zerlegungs-Information
	if ( VisualDB.bPsd )
		strcat( data, "Zerlegung=PSD" );
	else
		strcat( data, "Zerlegung=SLD" );
	strcat( data, EOL );
	strcpy( format, "User=%s Date=%02i.%02i.%i Time=%2d:%02d:%02d DataOffset=%d" );
	sprintf( buf, format, MeasurementParameter.GetUser(), t.wDay, t.wMonth, t.wYear, t.wHour, t.wMinute, t.wSecond, DATAOFFSET );
	strcat( data, buf );
	strcat( data, EOL );
	strcpy( format, "Point_Number=%d FileType=Standard" );
	sprintf( buf, format, MainCurve->GetPNumber());
	strcat( data, buf );
	strcat( data, EOL );
	strcpy( format, "Target=%s Reflection=%s Orientation=%s" );
	MeasurementParameter.GetReflection(buf2);
	MeasurementParameter.GetOrientation(buf3);
	sprintf( buf, format, MeasurementParameter.GetTarget(), buf2, buf3 );
	strcat( data, buf );
	strcat( data, EOL );
	sprintf( format, "ArgumentMin=%s ArgumentWidth=%s ArgumentMax=%s Scanaxis=Theta", mGetDF(), mGetSF(), mGetDF() );
	if ( VisualDB.bPsd )
		sprintf( buf, format, fTheta + MainCurve->GetMin(0)*VisualDB.fAngleStep,
				 (MainCurve->GetMax(0) - MainCurve->GetMin(0)) / MainCurve->GetPNumber(),
				 MainCurve->GetMax(0) + fTheta);
	else
		sprintf( buf, format, MainCurve->GetMin(0), dThetaWidth, MainCurve->GetMax(0));
	strcat( data, buf );
	strcat( data, EOL );
	strcpy( format, "WaveLength=%.3f Current=%d HV=%d" );
	sprintf( buf, format, MeasurementParameter.GetWaveLength(),
			 MeasurementParameter.GetCurrent(), MeasurementParameter.GetVoltage() );
	strcat( data, buf );
	strcat( data, EOL );
	strcpy( format, "TimePerScan=%.2f" );
	sprintf( buf, format, fMaxTime );
	strcat( data, buf );
	for ( nSize= strlen(data); nSize < DATAOFFSET - 10; nSize++ )
		data[ nSize ]= ' ';
	data[ nSize ]= 0x0;
	strcat( data, EOL );
	strcat( data, "[Data]" );
	strcat( data, EOL );
	_lwrite(hFile, data, strlen(data));
	while ( MainCurve->PGet( x, y, z ) ) //07.05.2004 FastP...
	{
		if ( VisualDB.bPsd )
			x += fTheta;
		ScanReport->SetPP( counter );
		ScanReport->PGet( z, v, v );
		sprintf( buf, fmt, x, y, z );
		_lwrite( hFile, buf, strlen( buf ) );
	}
	_lclose(hFile);
	// 07.05.2004 MainCurve->FastClose();
	_FREELIST(data);
	bFileChanged= FALSE;
	return TRUE;
};
//*****************************************************************************

//! Zerlegen der DB
BOOL TAreaScanWindow::DismantleDB( void )
{
	//! Dialogboxaufruf
	TModalDlg *dlg= ( TDismantleDBDlg * ) new TDismantleDBDlg( this );
	if ( dlg ) dlg->ExecuteDialog( GetHandle() );
	_FREEOBJ(dlg);

	//! alle Kurven durchlaufen und einzeln speichern
	HCURSOR hOldCursor= SetDefaultCursor( IDC_WAIT );
	if ( strcmp(DismantleFile, "") )
		for (int counter= 0; counter < lpDBase->GetCNumber(); counter++ )
			if (!SaveDismantleCurve( counter ))
				break;
	SetCursor(hOldCursor);
	return TRUE;
};
//*****************************************************************************
// Protokoll
//*****************************************************************************

//! klier 01.03.2003 Protokollbuch
//! Speichert Informationen im Protokollbuch
void TAreaScanWindow::SetMeasurementProtocolParameter( void )
{
	TCurve* Report= lpDBase->GetScanReport();
	char buf[ MaxString ];

	if (!IsProtocolDiffractometryOn())
		return;

	sprintf(buf, szODF, Report->GetMin( P_X ));
	SetProtocolDiffractometryMinimum1(buf);
	sprintf(buf, szOWF, dOmegaWidth);
	SetProtocolDiffractometrySchrittweite1(buf);
	sprintf(buf, szODF, Report->GetMax( P_X ));
	SetProtocolDiffractometryMaximum1(buf);

	//klier 30.01.2003  Der Wert fr das Offset wird mit ausgegeben
	sprintf(buf, szODF, mlGetOffset(nOmega));
	SetProtocolDiffractometrySOffset1(buf);

	//! in abhaengigkeit von art des Scans haben die Thetaeintraege verschiedene
	//! bedeutungen
	if (VisualDB.bPsd)
	{ //! speichern einer Psd-Datenbasis
		sprintf(buf, szTDF, Report->GetMin( P_Y ) - dPsdOffset);
		SetProtocolDiffractometryMinimum2(buf);
		sprintf(buf, szTDF, Report->GetMax( P_Y ) - dPsdOffset);
		SetProtocolDiffractometryMaximum2(buf);
		if (dThetaMin != dThetaMax)
		{
			sprintf(buf, szTWF, dOmegaWidth * VisualDB.dMoveRelation);
			SetProtocolDiffractometrySchrittweite2(buf);
		}
	}
	else
	{ //! speichern einer SLD-DatenBasis mit zentren der Thetawindows als Thetawerte
		sprintf(buf, szTDF, VisualDB.dThetaMinFirst + 0.5* VisualDB.dThetaWindow);
		SetProtocolDiffractometryMinimum2(buf);
		sprintf(buf, szTDF, VisualDB.dThetaMinFirst + 0.5*VisualDB.dThetaWindow + (Report->GetPNumber() - 1)* dOmegaWidth * VisualDB.dMoveRelation);
		SetProtocolDiffractometryMaximum2(buf);
		if (dThetaMin != dThetaMax)
		{
			sprintf(buf, szTWF, dOmegaWidth * VisualDB.dMoveRelation);
			SetProtocolDiffractometrySchrittweite2(buf);
		}
	}

	//klier 30.01.2003  Der Wert fr das Offset wird mit ausgegeben
	sprintf(buf, szTDF, mlGetOffset(nTheta));
	SetProtocolDiffractometrySOffset2(buf);

	MeasurementParameter.GetReflection(buf);
	SetProtocolDiffractometryUReflex(buf);
	MeasurementParameter.GetOrientation(buf);
	SetProtocolDiffractometryOrientierung(buf);

	sprintf(buf, "%.3f", MeasurementParameter.GetWaveLength());
	SetProtocolDiffractometryWellenlaenge(buf);
	sprintf(buf, "%d", MeasurementParameter.GetCurrent());
	SetProtocolDiffractometryStrom(buf);
	sprintf(buf, "%d", MeasurementParameter.GetVoltage());
	SetProtocolDiffractometrySpannung(buf);
};
//*****************************************************************************

LPCSTR TAreaScanWindow::GetRepFileName()
{
	char drive[ _MAX_DRIVE+1 ], path[ _MAX_DIR+1 ], name[ _MAX_FNAME+1 ], ext[ _MAX_EXT+1 ];
	//! ermitteln des Dateinamen + anhaengen der Extension .rep
	_splitpath( FileName, drive, path, name, ext );
	_makepath( m_RepFileName, drive, path, name, "rep" );
	return m_RepFileName;
}
//*****************************************************************************

//! Funktion liefert den absoluten Thetawert als Rueckkehrcode
//! 1.Param. scid gibt Kurvennr. an, deren absoluter Thetawert gesucht ist
//! nur bei RL-Bitmap benutzt
double TAreaScanWindow::GetThetaOffset( int scid )
{
	float theta, v;

	// this function returns an absolute Theta Value
	switch ( eOutputType )
	{
		case otReciprokeLatticeBitmap:
			//! liefert 0 wenn zuwenig Kurven in Datenbasis sonst den Thetawert der
			//! scid-ten Kurve der Datenbasis
			if ( 2 > lpDBase->GetCNumber() )
				return 0.0;

			ScanReport->SetPP( scid );
			ScanReport->PGet( v, theta, v );
			return theta - dThetaOffset;

		case otMatrixBitmap:
			//! liefert 0 wenn zuwenig Kurven in Datenbasis sonst den Thetawert der
			//! 0-ten Kurve der Datenbasis
			if ( 2 > lpDBase->GetCNumber() )
				return 0.0;

			//! Aenderung B.Buss ScanReport->SetPP( 0 );
			ScanReport->SetPP( scid );
			ScanReport->PGet( v, theta, v );
			return theta - dThetaOffset;

		case otCurve:
			//! bei kont.Anzeige den akt. Thetawinkel als Offset zurueck
			if ( bShowPsdContinuous )
				return ( mlGetValue( nTheta, Distance ) /*Theta soll relativ sein - mlGetOffset( nTheta )*/ );

			//! wenn kein Psd angeschl. offset=0
			//! FIX Fehler 39
			if ( VisualDB.bPsd )
			{
				//! neu akk
				//! waehrend des Scans existiert noch keine reportkurve
				//! deshalb akt. motorposition
				if ( !bMeasurementActive )
				{
					//! Offset= thetawert der letzten Kurve holen wenn dieser gueltig ist
					//! sonst 0
					ScanReport->SetPP( nActiveScan );
					ScanReport->PGet( v, theta, v );
					if ( ( theta > 1000.0 ) || ( theta < -1000.0 ) )
						return 0.0;
					else 
						return theta;
				} else 
					return ( mlGetValue( nTheta, Distance ) /*Theta soll relativ sein - mlGetOffset( nTheta )*/ + dOffsetTheta );
			} else return 0.0;

		default:
			MessageBox( szMsgLine023, szMessage, MBINFO );
			return 0.0;
	}
};
//***************************************************************************** 

//! bildn. Darstellung ausschl. in TPlotWindow verwendet
BOOL TAreaScanWindow::SetMeasurementArea( TKSystem &ks )
{
	/*
	fPsdRange wird fuer jede Messung mit GetPsd()->GetAngleRange() oder nach dem Einlesen in LoadMeasurementInfo() und LoadOldData() gesetzt.
	*/
	switch ( eOutputType )
	{
		case otReciprokeLatticeBitmap:
			ks[ 0 ].x= DegToRad ( VisualDB.dThetaMinFirst );
			ks[ 0 ].y= DegToRad ( VisualDB.dOmegaMin ); //! FIX Fehler 39
			ks[ 0 ].Ord= 0;
			ks[ 1 ].x= DegToRad ( VisualDB.dThetaMaxFirst );   //! FIX Fehler 39
			ks[ 1 ].y= DegToRad ( VisualDB.dOmegaMin ); //! FIX Fehler 39
			ks[ 1 ].Ord= 1;
			ks[ 2 ].x= DegToRad ( VisualDB.dThetaMaxLast ); //! FIX Fehler 39
			ks[ 2 ].y= DegToRad ( VisualDB.dOmegaMax ); //! FIX Fehler 39
			ks[ 2 ].Ord= 2;
			ks[ 3 ].x= DegToRad ( VisualDB.dThetaMinLast );
			ks[ 3 ].y= DegToRad ( VisualDB.dOmegaMax ); //! FIX Fehler 39
			ks[ 3 ].Ord= 3;
			break;

		case otMatrixBitmap:
			ks[ 0 ].x= VisualDB.dThetaMinFirst /*0.0*/;
			ks[ 0 ].y= VisualDB.dOmegaMin; //! FIX Fehler 39
			ks[ 0 ].Ord= 0;
			ks[ 1 ].x= VisualDB.dThetaMaxFirst /*fAngleRange*/; //! FIX Fehler 39
			ks[ 1 ].y= VisualDB.dOmegaMin; //! FIX Fehler 39
			ks[ 1 ].Ord= 1;
			//! B.Buss geaendert ks[ 2 ].x= ::fPsdRange;
			//! FIX Fehler 39
			ks[ 2 ].x= VisualDB.dThetaMaxLast /*GetThetaOffset(lpDBase->GetCNumber()-1)-GetThetaOffset(0) +   VisualDB.fAngleRange*/;
			ks[ 2 ].y= VisualDB.dOmegaMax; //! FIX Fehler 39
			ks[ 2 ].Ord= 2;
			ks[ 3 ].x= VisualDB.dThetaMinLast /*0.0*/;
			ks[ 3 ].y= VisualDB.dOmegaMax; //! FIX Fehler 39
			ks[ 3 ].Ord= 3;
			break;
	}
	return TRUE;
};