#ifndef _L_LAYER_H
#define _L_LAYER_H

#include "utils\u_values.h"

//Datum: 03.02.2003 #define    W_ImageWindow       250
//Datum: 03.02.2003 #define    W_OffLineWindow     256

//Datum: 03.02.2003 #define    I_Position          280
//Datum: 03.02.2003 #define    I_Intensity         281
//Datum: 03.02.2003 #define    I_Report            282

// Voreinstellungen
//Datum: 03.02.2003 #define    CONTROL             0x02
//Datum: 03.02.2003 #define    NOCONTROL           0xFD
//Datum: 03.02.2003 #define    ECHO                0x04
//Datum: 03.02.2003 #define    NOECHO              0xFB
//Datum: 03.02.2003 #define    MAXERROR            10

/*#if defined (Build_Library)
#define _CURVECLASS __declspec(dllexport)
#elif defined(Use_Library)
#define _CURVECLASS __declspec(dllimport)
#else
#define _CURVECLASS
#endif*/

//*** Return-Codes
/* Benutzt in m_main.cpp */
#define  R_Stopped         200

/* Benutzt in m_main.cpp */
#define  R_NoWindow        203

/* Benutzt in m_main.cpp */
#define   TimerIdSteering    398

/* NICHT BENUTZT */
//! #define  R_Started         201

/* NICHT BENUTZT */
//! #define  R_InvalidFile     204

/* NICHT BENUTZT */
//! #define  R_MeasStop        207

/* NICHT BENUTZT */
//! #define  R_NoCommunication 208

/* NICHT BENUTZT */
//! #define  R_NoMemory        209

/* NICHT BENUTZT */
//! #define  R_NoMfSelected    210

/* NICHT BENUTZT */
//! #define  R_Restarted       211

/* NICHT BENUTZT */
//! #define  R_Interrupted     212

/* NICHT BENUTZT */
//! #define  R_DataValid       213

/* NICHT BENUTZT */
//! #define O_Common     0x0004

// Identifikation der Timer
/* NICHT BENUTZT */
//! #define MotorTimerIdStart    200

/* NICHT BENUTZT */
//! #define GenericTimerIdStart  300

/* Benutzt in m_main.cpp */
enum EWorkPlace { 
	HRM= 1, RTK, ScanTable, PDI_Diffractometer, Diff2, Diff3, Expert
};

// fr die SetInfo-Methoden und TMain::DrawStatus()
const UINT DRAWSTATUS0= 1000;
const UINT DRAWSTATUS1= 1001;
const UINT DRAWSTATUS2= 1002;

#define MainWindow_Style WS_CLIPCHILDREN | WS_OVERLAPPED | WS_CAPTION | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_SYSMENU
#define ClientWindow_Style WS_CHILD | WS_CLIPCHILDREN | WS_VSCROLL | WS_HSCROLL

//DATUM: 31.08.2002
/*struct T_Font {
 short      nFontType;
 LOGFONT    lf;
 TEXTMETRIC tm;
};*/

//##############################################################################
// VERWALTUNG VON FileLocations
//##############################################################################

//erlaubt Uebernahme des Ausfhrungspfades aus M_MAIN.CPP
void _CURVECLASS WINAPI InitializeFileLocations ( LPCSTR );

//liefert FileLocations.GetDirectory
LPCSTR _CURVECLASS WINAPI GetDirectory ( void );
//liefert FileLocations.GetName
LPCSTR _CURVECLASS WINAPI GetName ( void );
//liefert FileLocations.GetHWFile
LPCSTR _CURVECLASS WINAPI GetHWFile ( void );
//liefert FileLocations.GetCFile
LPCSTR _CURVECLASS WINAPI GetCFile ( void );
//liefert FileLocations.GetHelpFile
LPCSTR _CURVECLASS WINAPI GetHelpFile ( void );
//liefert FileLocations.GetPTopoName
LPCSTR _CURVECLASS WINAPI GetPTopoName ( void );
//liefert FileLocations.GetPTopoFile
LPCSTR _CURVECLASS WINAPI GetPTopoFile ( void );
//liefert FileLocations.PTopoDirectory
LPCSTR _CURVECLASS WINAPI GetPTopoDirectory ( void );
//klier 25.02.2003
//liefert FileLocations.PTopoBackupDirectory
LPCSTR _CURVECLASS WINAPI GetPTopoBackupDirectory ( void );
//klier 16.03.2003
//verndert FileLocations.PTopoBackupDirectory
BOOL _CURVECLASS WINAPI SetPTopoBackupDirectory ( LPCSTR );
//klier 16.03.2003
//verndert FileLocation.szPTopoFileName
BOOL _CURVECLASS WINAPI SetPTopoFile ( LPCSTR FileName );
//liefert FileLocations.GetPDiffName
LPCSTR _CURVECLASS WINAPI GetPDiffName ( void );
//liefert FileLocations.GetPDiffFile
LPCSTR _CURVECLASS WINAPI GetPDiffFile ( void );
//liefert FileLocations.PDiffDirectory
LPCSTR _CURVECLASS WINAPI GetPDiffDirectory ( void );
//klier 25.02.2003
//liefert FileLocations.PDiffBackupDirectory
LPCSTR _CURVECLASS WINAPI GetPDiffBackupDirectory ( void );
//klier 16.03.2003
//verndert FileLocations.PDiffBackupDirectory
BOOL _CURVECLASS WINAPI SetPDiffBackupDirectory ( LPCSTR );
//verndert FileLocation.szPDiffFileName
BOOL _CURVECLASS WINAPI SetPDiffFile ( LPCSTR FileName );

//liefert FileLocations.GetTestDevFile
LPCSTR _CURVECLASS WINAPI GetTestDevFile ( void );
//liefert FileLocations.GetMacroFile; <macroname> sollte auf ".mak" enden (z.B. "scan.mak" oder "standard.mak")
LPCSTR _CURVECLASS WINAPI GetMacroFile ( LPCSTR macroname );

//##############################################################################
// VERWALTUNG VON MainParameters
//##############################################################################

BOOL _CURVECLASS WINAPI InitializeMainParameters( HINSTANCE, HWND, HWND, UINT, UINT, BOOL );

HINSTANCE _CURVECLASS WINAPI GetMainInstance( void );
HWND _CURVECLASS WINAPI GetFrameHandle( void );
HWND _CURVECLASS WINAPI GetScanHandle( void );
void _CURVECLASS WINAPI SetScanHandle( HWND );
HWND _CURVECLASS WINAPI GetClientHandle( void );
UINT _CURVECLASS WINAPI GetDrawMsg( void );
UINT _CURVECLASS WINAPI GetWakeUpMsg( void );
BOOL _CURVECLASS WINAPI CreateDefaults( void );

//##############################################################################
// Verwaltung der SPLIB.DLL
//##############################################################################

#ifdef __cplusplus

extern "C"
{
#endif
	void _CURVECLASS WINAPI AboutTheMaker ( void );
	LPCSTR _CURVECLASS WINAPI spGetVersion ( void );
	HINSTANCE _CURVECLASS WINAPI spGetInstance ( void );
	//Datum: 03.02.2003 LPSTR WINAPI      UnitStr ( TUnitType );
	//Datum: 03.02.2003 int WINAPI  GetBufferLine ( LPSTR, LPSTR, int );
	//Datum: 16.08.2002 maxi, maxl, maxf, maxd, mini, minl, minf, mind verschoben nach U_VALUES.H

#ifdef __cplusplus
}
#endif

//##############################################################################
// Rest
//##############################################################################

// Info's in Statuszeile ausgeben
void _CURVECLASS WINAPI SetInfo( LPCSTR );
void _CURVECLASS WINAPI SetStaticInfo( LPCSTR );
void _CURVECLASS WINAPI SetStatus( LPCSTR );

// Dateiffnung- und -schliedialog
BOOL _CURVECLASS WINAPI FileOpenDialog( LPCSTR, LPSTR, LPSTR, LPCSTR );
BOOL _CURVECLASS WINAPI FileOpenDialog( LPCSTR, LPSTR, LPSTR, LPCSTR, DWORD& ); // WIEVOR, jedoch mit zustzlichem FilterIndex (Auswahl des Dateityps)
BOOL _CURVECLASS WINAPI FileSaveDialog( LPCSTR, LPSTR, LPSTR, LPCSTR);
BOOL _CURVECLASS WINAPI FileSaveDialog( LPCSTR, LPSTR, LPSTR, LPCSTR, DWORD& ); // WIEVOR, jedoch mit zustzlichem FilterIndex (Auswahl des Dateityps)

// Dateizugriff (Textdateien); stattdessen bitte TTxtRead verwenden!!!
#define  R_Overflow        218
#define  R_EndOfFile       219
int _CURVECLASS WINAPI GetFileLine( int, LPSTR, int );
BOOL _CURVECLASS WINAPI SetFPOnData( HFILE hfile );
BOOL _CURVECLASS WINAPI PathCanWrite(LPSTR); // ==> kann angegebener Path beschrieben werden?

// Funktionen zum Warten
void _CURVECLASS WINAPI InitializeDelay();
void _CURVECLASS WINAPI DelayTime( int );
void _CURVECLASS WINAPI Delay( long );

// wartet die angebene Tick-Count - whrenddessen werden Windowsbotschaften weiter verarbeitet 
// (System steht also nicht vllig)
// ACHTUNG, wenn whrend des Vorganges ein Wartemauszeiger angezeigt wird, muss er nach diesem Aufruf erneuert werden - ansonsten verschwindet er wenn der Anwender die Maus bewegt (dem Programm stehen ja Ressourcen zur Verfgung)!!!
void _CURVECLASS WINAPI ProcessMessages( UINT32 ); 

#endif // ifdef _L_LAYER_H
