//******************************************************************************
//Datei     : TProtocolDiffractometry.h
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Interface der Klasse TProtocolDiffractometry
//******************************************************************************
//!neu klier Protokollbuch

class TProtocolDiffractometry : public TProtocol
{
public:
#include "protocol\TProtocolDiffractometryParameter.h" // enthlt enum TDiffractometryParameter

	TProtocolDiffractometry( void );
	BOOL SearchProtocolString( LPCSTR );
	BOOL SearchProtocolString( LPCSTR, LPCSTR, LPCSTR, LPCSTR, LPCSTR );

	BOOL IsMaxLfdNr( void );
	BOOL TestLfdNr( LPCSTR );
	LPSTR GetParameterLfdNr( LPSTR );
	LPSTR GetParameterDate( LPSTR );
	void SetParameterDate( LPCSTR );
	void SaveLfdNr( LPCSTR );
	LPSTR GetNewLfdNr( LPSTR );

private:

	LPCSTR GetPName( void );
	LPCSTR GetPDirectory( void );
	LPCSTR GetPBackupDirectory( void );
	BOOL SetPBackupDirectory( LPCSTR );
	LPCSTR GetPFile( void );
	BOOL SetPFile( LPCSTR );
	void SetDefaultParameterReadOnly( void );
	void SetOnDefaultParameterReadOnly( void );
	void InitializeDefaultParameter( void );
	void SetDefaultParameter( void );
	void ClearOldParameter( void );

	char DefaultScanart[MaxString];
	char DefaultScanmethode[MaxString];
	char DefaultMessdatei[MaxString];
	char DefaultScantyp[MaxString];
	char DefaultScanachse1[MaxString];
	char DefaultSOffset1[MaxString];
	char DefaultMinimum1[MaxString];
	char DefaultMaximum1[MaxString];
	char DefaultSchrittweite1[MaxString];
	char DefaultGeschwindigkeit1[MaxString];
	char DefaultScanachse2[MaxString];
	char DefaultSOffset2[MaxString];
	char DefaultMinimum2[MaxString];
	char DefaultMaximum2[MaxString];
	char DefaultSchrittweite2[MaxString];
	char DefaultGeschwindigkeit2[MaxString];
	char DefaultDetektor[MaxString];
	char DefaultMonitor[MaxString];
	char DefaultMesszeit[MaxString];
	char DefaultImpulse[MaxString];
	char DefaultWinkelbereich[MaxString];
	char DefaultKanalabstand[MaxString];
	char DefaultMesskanal[MaxString];
	char DefaultAddiere[MaxString];
};

// LastLine
