//******************************************************************************
//Datei     : TProtocolDlg.h
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Interface der Klasse TProtocolDlg
//******************************************************************************
//!neu klier Protokollbuch

#include "protocol\TManageComboboxProtocolDlg.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

#define SHOW SW_SHOW
#define HIDE SW_HIDE
#define ENABLE TRUE
#define DISABLE FALSE

class TProtocolManagePrintDlg;

class TProtocolDlg
{
public:
	TProtocolDlg();
	~TProtocolDlg();
	void RefreshPic( void );
	void ShowLfdNr( LPCSTR );
	BOOL TestChangeDlg( void );
	void InitializeManagePrintDlg( TProtocolManagePrintDlg* );
	BOOL GetPasswort( HWND );
	char Passwort[MaxString];
	WNDPROC wpOrigProc;
	TManageComboboxProtocolDlg ProtocolCombobox;

protected:

	enum TAction {Save, Refresh, ChangeTest, DefaultTest, Enable, Disable};

	// Ermittelt die Koordinaten des Rechteckes einen Dialogelementes
	void GetDlgItemRect( HWND , int, LPRECT );

	// Sichtbarmachen(+ Aktivieren)/Verstecken(+ Deaktivieren) eines Dialogelementes
	void ShowDlgItem( int, int );
	void ShowDlgItem( HWND, int, int );

	// Aktivieren/Deaktivieren eines Dialogelementes
	void EnableDlgItem( int, BOOL );
	void EnableDlgItem( HWND, int, BOOL );

	void Dlg_OnInit( HWND, HWND, LPARAM );
	void Dlg_OnDestroy( HWND );
	BOOL Dlg_OnCommand( HWND, int , UINT);
	void Dlg_OnLButtonUp( HWND, int, int, UINT );
	void Dlg_OnLButtonDown( HWND, UINT, int, int, UINT );
	void Dlg_OnMouseMove( HWND, int, int, UINT );
	void Dlg_OnRButtonDown( HWND, UINT, int, int, UINT );

	void NewMeasurement( HWND );
	void LoadMeasurement( HWND );
	void SetParameterStatus( void );

	void SaveDlg( HWND, int );
	void RefreshDlg( HWND, int );
	BOOL TestDlg( HWND, int );
	void EnableDlg( HWND, int, BOOL );
	BOOL ManageDlgItem( HWND, int, int, TAction );
	void EnableDialog( BOOL );
	void EnableOk( BOOL );
	void EnableReadOnly( BOOL );

	virtual void ShowDialog( int, int )= 0;

	virtual void InitializeDlgItems( HWND )= 0;
	virtual void SaveDlgItems( HWND )= 0;

	virtual void SetDlgItemText_LfdNr( HWND )= 0;
	virtual LPSTR GetDlgItemText_LfdNr( HWND, LPSTR )= 0;
	virtual BOOL TestDlgItemText_LfdNr( HWND, LPSTR )= 0;
	virtual void EnableDlgItem_LfdNr( BOOL )= 0;

	virtual BOOL IsDlgItemModify( void )= 0;

	virtual int GetDlg( int )= 0;
	virtual BOOL ManageDlg( HWND, int, TAction )= 0;
	virtual BOOL TestPflichtDlg( HWND )= 0;
	virtual void RefreshCombobox( void ) {}

	virtual int GetStatusId( void )= 0;
	virtual int GetDatumId( void )= 0;

	char PicFile[_MAX_PATH];

	BOOL LButtonDown, bLine, bEdit, bLfdNrCorrect;
	BOOL bOkStatus, bReadOnlyStatus, bChangeSkizze, bDebug;
	int xText, yText, dxText, dyText, xMove, yMove, CurrentDlg;

	HWND hLfdNr, hNutzerList, hMaterialList, hTab;

	HDC hDC, hMetaDC;
	HPEN hPenWhite, hPenBlack;

	enum {ProbeSkizzeDlg= 1, DefaultDlg};

	// Dialogfensterhandle wird von einigen Funktionen benoetigt
	HWND hwndDlg;

	// Zeiger auf die aktuelle Instanz der Protokollbuchklasse
	TProtocol *Protocol;
};


// LastLine


