//******************************************************************************
//Datei     : TProtocolTopography.h
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Interface der Klasse TProtocolTopography
//******************************************************************************
//!neu klier Protokollbuch

class TProtocolTopography : public TProtocol
{
public:
#include "protocol\TProtocolTopographyParameter.h" // enthlt enum TTopographyParameter

	TProtocolTopography( void );
	BOOL SearchProtocolString( LPCSTR );
	BOOL SearchProtocolString( LPCSTR, LPCSTR, LPCSTR, LPCSTR, LPCSTR,
							   LPCSTR, LPCSTR );

	BOOL IsMaxLfdNr( void );
	BOOL TestLfdNr( LPCSTR );
	BOOL TestLfdNr( LPCSTR , LPCSTR );
	BOOL TestLfdNr( LPCSTR , LPCSTR, LPCSTR );
	LPSTR GetParameterLfdNr( LPSTR );
	LPSTR GetParameterDate( LPSTR );
	void SetParameterDate( LPCSTR );
	void SaveLfdNr( LPCSTR );
	void SaveLfdNr( LPCSTR , LPCSTR, LPCSTR );
	LPSTR GetNewLfdNr( LPSTR );
	LPSTR GetLfdNrBereich( LPSTR );
	LPSTR GetLfdNrNummer( LPSTR );
	LPSTR GetRTKNr( LPSTR );

private:

	LPCSTR GetPName( void );
	LPCSTR GetPDirectory( void );
	LPCSTR GetPBackupDirectory( void );
	BOOL SetPBackupDirectory( LPCSTR );
	LPCSTR GetPFile( void );
	BOOL SetPFile( LPCSTR );
	void SetOnDefaultParameterReadOnly( void );
	void SetDefaultParameterReadOnly( void );
	void InitializeDefaultParameter( void );
	void SetDefaultParameter( void );
	void ClearOldParameter( void );

	char DefaultKKruemmung[MaxString];
	char DefaultImpMax[MaxString];
	char DefaultHWB[MaxString];
	char DefaultSTE[MaxString];
	char DefaultCONLIMIT[MaxString];
	char DefaultCRT[MaxString];
	char DefaultINCDF[MaxString];
	char DefaultNBEXPOS[MaxString];
	char DefaultRSA[MaxString];
	char DefaultABE[MaxString];
	char DefaultEXPT[MaxString];
	char DefaultCONPOINT[MaxString];
};

// LastLine
