// l_layer.cpp
// (C) 1993,1994 by Heiko Damerow MPG AG "Roentgenbeugung"
// Allgemeine Funktionen
#include <direct.h>

#include "internls\evrythng.h"	// GermanVersion
#include "winresrc\rc_def.h"	// Ressourcen-IDs
#include <commdlg.h>			// OPENFILENAME
#pragma hdrstop

#include "internls\l_layer.h"
#include "datavisa\datavisa.h"	// lpDBase

#include "utils\CheckMemory.h"	// CHECKMEM

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

// ! neu Kullmann+Reinecker
class TMainParameters; // forward
TMainParameters			*MainP= 0; // 02.06.2003

class TFileLocations; // forward
TFileLocations      *FileLocations= 0; // 02.06.2003

//Datum: 02.07.2003 int bModulLoaded= FALSE;
HINSTANCE hModuleInstance;
LPDataBase _CURVECLASS lpDBase= 0; // 17.11.2002

static char spVersion[]= "V 1.51 ("__DATE__")";

//#############################################################################
// sprachspezifische Konstanten
//#############################################################################

#ifdef GermanVersion
	const char _TITLE[]= "ber \"%s\"";           // Titelleistenbeschriftung
#else
	const char _TITLE[]= "About \"%s\"";
#endif

//##############################################################################
// TAboutDlg
//##############################################################################

class _CURVECLASS TAboutDlg : public TModalDlg
{
public:
	TAboutDlg ( void ) : TModalDlg( "ABOUT", hModuleInstance )
	{};

private:
	BOOL Dlg_OnInit ( HWND, HWND, LPARAM )
	{
		char *buf= new char[ strlen(_TITLE) + strlen(APPLICATIONTITLE) ];
		sprintf(buf, _TITLE, APPLICATIONTITLE);
		SetWindowText(GetHandle(), buf);
		_FREELIST(buf);
		return TRUE;
	};
};

void _CURVECLASS WINAPI AboutTheMaker ( void )
{
	TAboutDlg *dlg= new TAboutDlg();
	if ( dlg ) dlg->ExecuteDialog(GetFrameHandle());
	_FREEOBJ(dlg);
};

//##############################################################################
// TFileLocations
//##############################################################################

class TFileLocations
{
public:
	TFileLocations ( LPCSTR FileName );

  //auslesen von szDirectory
  LPCSTR GetDirectory ( void ) const
  {
	  return szDirectory;
  }

  //auslesen von szName
  LPCSTR GetName ( void ) const
  {
	  return szName;
  }

  //vollstaendiger Name der Hardware-INI
  LPCSTR GetHWFile ( void ) const
  {
	  return szHWFile;
  }

  //vollstaendiger Name der Conf.-INI
  LPCSTR GetCFile ( void ) const
  {
	  return szCFileName;
  }

  //vollstaendiger Name der Hilfedatei
  LPCSTR GetHelpFile ( void ) const
  {
	  return szHelpFile;
  }

  //auslesen von szPTopoDirectory
  LPCSTR GetPTopoDirectory ( void ) const
  {
	  return szPTopoDirectory;
  }

  //auslesen von szPDiffDirectory
  LPCSTR GetPDiffDirectory ( void ) const
  {
	  return szPDiffDirectory;
  }

  //klier 25.02.2003
  //auslesen von szPTopoBackupDirectory
  LPCSTR GetPTopoBackupDirectory ( void ) const
  {
	  return szPTopoBackupDirectory;
  }

  //klier 25.02.2003
  //auslesen von szPDiffBackupDirectory
  LPCSTR GetPDiffBackupDirectory ( void ) const
  {
	  return szPDiffBackupDirectory;
  }

  //auslesen von szPTopoName
  LPCSTR GetPTopoName ( void ) const
  {
	  return szPTopoName;
  }

  //auslesen von szPName
  LPCSTR GetPDiffName ( void ) const
  {
	  return szPDiffName;
  }

  //vollstaendiger Name der Protokoll-Topographie-Datei
  LPCSTR GetPTopoFile ( void ) const
  {
	  return szPTopoFileName;
  }

  //vollstaendiger Name der Protokoll-Diffraktometrie-Datei
  LPCSTR GetPDiffFile ( void ) const
  {
	  return szPDiffFileName;
  }

  //vollst. Name der "TestDev.dat"
  LPCSTR GetTestDevFile ( void ) const
  {
	  return szTestDevFile;
  }

	//klier 16.03.2003
	//verndern von szPTopoBackupDirectory
	BOOL SetPTopoBackupDirectory ( LPCSTR );

	//klier 16.03.2003
	//verndern von szPDiffBackupDirectory
	BOOL SetPDiffBackupDirectory ( LPCSTR );

	//klier 16.03.2003
	//verndert Name der Protokoll-Topographie-Datei
	BOOL SetPTopoFile ( LPCSTR FileName );

	//klier 16.03.2003
	//verndert Name der Protokoll-Diffraktometrie-Datei
	BOOL SetPDiffFile ( LPCSTR FileName );

	//vollst. Name der <macroname>; <macroname> sollte auf ".mak" enden (z.B. "scan.mak" oder "standard.mak")
	LPCSTR GetMacroFile ( LPCSTR macroname );

private:
	//zerlegt den kompletten Dateinamen in seine Bestandteile
	void SplitFileName ( LPCSTR DirFileName);

	//klier 16.03.2003
	//Testet ob die Protokollverzeichnisse existieren, wenn nicht werden sie erstellt
	BOOL CreatePDirectory( LPSTR PDirectory );

	//Laufwerk+Verzeichnis, aus dem aktuelle Anwendung gestartet wurde
	char szDirectory[_MAX_PATH];

	//Dateiname (ohne Laufwerk+Verzeichnis+Dateierweiterung) der aktuellen Anwendung
	char szName[_MAX_FNAME];

	//klier 25.02.2003
	//Laufwerksbuchstabe der aktuellen Anwendung
	char szDrive[_MAX_DRIVE];

	//Dateiname (mit Laufwerk+Verzeichnis) der aktuellen INI-Datei
	char szCFileName[_MAX_PATH];

	//vollstaendiger Name der Hilfedatei
	char szHelpFile[_MAX_PATH];

	//Laufwerk+Verzeichnis, in dem die aktuelle Topographie-Protokolldatei liegt
	char szPTopoDirectory[_MAX_PATH];

	//Laufwerk+Verzeichnis, in dem die aktuelle Diffraktometrie-Protokolldatei liegt
	char szPDiffDirectory[_MAX_PATH];

	//klier 25.02.2003
	//Laufwerk+Verzeichnis, in dem die Backups der aktuelle Topographie-Protokolldatei liegen
	char szPTopoBackupDirectory[_MAX_PATH];

	//klier 25.02.2003
	//Laufwerk+Verzeichnis, in dem die Backups der aktuelle Diffraktometrie-Protokolldatei liegen
	char szPDiffBackupDirectory[_MAX_PATH];

	//Dateiname (ohne Laufwerk+Verzeichnis+Dateierweiterung) der aktuellen Topographie-Protokolldatei
	char szPTopoName[_MAX_FNAME];

	//Dateiname (ohne Laufwerk+Verzeichnis+Dateierweiterung) der aktuellen Diffraktometrie-Protokolldatei
	char szPDiffName[_MAX_FNAME];

	//Dateiname (ohne Laufwerk+Verzeichnis) der aktuellen Topographie-Protokolldatei
	char szPTopoFileName[_MAX_PATH];

	//Dateiname (ohne Laufwerk+Verzeichnis) der aktuellen Diffraktometrie-Protokolldatei
	char szPDiffFileName[_MAX_PATH];

	//Dateiname (mit Laufwerk+Verzeichnis) der Hardwareinitialisierungsdatei
	char szHWFile[_MAX_PATH];

	//Dateiname (mit Laufwerk+Verzeichnis) der TestDefDatei
	char szTestDevFile[_MAX_PATH];

	//Dateiname (mit Laufwerk+Verzeichnis) der aktuellen Macrodatei
	char szMacroFileName[_MAX_PATH];

	//Hilfsvariablen fr die Bestandteile einen Dateinamens
	char Drive[_MAX_DRIVE], Dir[_MAX_DIR], Name[_MAX_FNAME], Ext[_MAX_EXT], Path[_MAX_PATH];
};

//-----------------------------------------------------------------------------

//klier 25.02.2003 berarbeitet
TFileLocations::TFileLocations ( LPCSTR FileName )
{
	SplitFileName(FileName);
	strcpy(szDirectory, Path);
	strcpy(szName, Name);
	strcpy(szDrive, Drive);
	strupr(szDrive);
	sprintf(szCFileName, "%s%s%s", szDirectory, szName, ".INI" );
	sprintf(szPTopoFileName, "%s%s", szDirectory, "PROTOCOL\\TOPOGRFY\\PROTTOPO.CSV");
	GetPrivateProfileString("ProtocolTopography", "ProtocolFile", szPTopoFileName, szPTopoFileName, _MAX_PATH, szCFileName);
	if (!SetPTopoFile(szPTopoFileName))
	{
		sprintf(szPTopoFileName, "%s%s", szDirectory, "PROTOCOL\\TOPOGRFY\\PROTTOPO.CSV");
		SetPTopoFile(szPTopoFileName);
	}
	sprintf(szPDiffFileName, "%s%s", szDirectory, "PROTOCOL\\DIFRKMTY\\PROTDIFF.CSV");
	GetPrivateProfileString("ProtocolDiffractometry", "ProtocolFile", szPDiffFileName, szPDiffFileName, _MAX_PATH, szCFileName);
	if (!SetPDiffFile(szPDiffFileName))
	{
		sprintf(szPDiffFileName, "%s%s", szDirectory, "PROTOCOL\\DIFRKMTY\\PROTDIFF.CSV");
		SetPDiffFile(szPDiffFileName);
	}
	strcpy(szPTopoBackupDirectory, szPTopoDirectory);
	GetPrivateProfileString("ProtocolTopography", "BackupPath", szPTopoBackupDirectory, szPTopoBackupDirectory, _MAX_PATH, szCFileName);
	if (!CreatePDirectory(szPTopoBackupDirectory))
		SetPTopoBackupDirectory(szPTopoDirectory);
	strcpy(szPDiffBackupDirectory, szPDiffDirectory);
	GetPrivateProfileString("ProtocolDiffractometry", "BackupPath", szPDiffBackupDirectory, szPDiffBackupDirectory, _MAX_PATH, szCFileName);
	if (!CreatePDirectory(szPDiffBackupDirectory))
		SetPDiffBackupDirectory(szPDiffDirectory);
	strcpy(Path, szDirectory);
	GetPrivateProfileString("Steuerprogramm", "HardwareINIFilePath", Path, Path, _MAX_PATH, szCFileName);
	if (Path[strlen(Path) - 1] == '\\')
		sprintf( szHWFile, "%s%s", Path, "HARDWARE.INI" );
	else
		sprintf( szHWFile, "%s%s", Path, "\\HARDWARE.INI" );
	sprintf( szTestDevFile, "%s%s", szDirectory, "TESTDEV.DAT" );
	sprintf( szHelpFile, "%s%s", szDirectory, "SPHELP.HLP" );
}

//klier 16.03.2003
//verndern von szPTopoBackupDirectory
BOOL TFileLocations::SetPTopoBackupDirectory ( LPCSTR lDir )
{
	strcpy(szPTopoBackupDirectory, lDir);
	WritePrivateProfileString("ProtocolTopography", "BackupPath", szPTopoBackupDirectory, szCFileName);
	return CreatePDirectory(szPTopoBackupDirectory);
}

//klier 16.03.2003
//verndern von szPDiffBackupDirectory
BOOL TFileLocations::SetPDiffBackupDirectory ( LPCSTR lDir )
{
	strcpy(szPDiffBackupDirectory, lDir);
	WritePrivateProfileString("ProtocolDiffractometry", "BackupPath", szPDiffBackupDirectory, szCFileName);
	return CreatePDirectory(szPDiffBackupDirectory);
}

//klier 16.03.2003 berarbeitet
//verndert Name der Protokoll-Topographie-Datei
BOOL TFileLocations::SetPTopoFile ( LPCSTR FileName )
{
	SplitFileName(FileName);
	sprintf(szPTopoFileName, "%s%s.CSV", Path, Name);
	if (strcmp(strupr(Ext), ".CSV") != 0)
		WritePrivateProfileString("ProtocolTopography", "ProtocolFile", szPTopoFileName, szCFileName);
	strcpy(szPTopoDirectory, Path);
	strcpy(szPTopoName, Name);
	return CreatePDirectory(szPTopoDirectory);
}

//klier 16.03.2003 berarbeitet
//verndert Name der Protokoll-Diffraktometrie-Datei
BOOL TFileLocations::SetPDiffFile ( LPCSTR FileName )
{
	SplitFileName(FileName);
	sprintf(szPDiffFileName, "%s%s.CSV", Path, Name);
	if (strcmp(strupr(Ext), ".CSV") != 0)
		WritePrivateProfileString("ProtocolDiffractometry", "ProtocolFile", szPDiffFileName, szCFileName);
	strcpy(szPDiffDirectory, Path);
	strcpy(szPDiffName, Name);
	return CreatePDirectory(szPDiffDirectory);
}

//vollst. Name der <macroname>; <macroname> sollte auf ".mak" enden (z.B. "scan.mak" oder "standard.mak")
LPCSTR TFileLocations::GetMacroFile ( LPCSTR macroname )
{
	sprintf( szMacroFileName, "%s%s", szDirectory, macroname );
	return szMacroFileName;
}

//klier 16.03.2003
//Testet ob die Protokollverzeichnisse existieren, wenn nicht werden sie erstellt
BOOL TFileLocations::CreatePDirectory( LPSTR PDirectory )
{
	char buf[_MAX_DIR], *token;

	if (PDirectory[strlen(PDirectory) - 1] != '\\')
		strcat( PDirectory, "\\");
	SplitFileName(PDirectory);
	strupr(Drive);
	_chdrive(Drive[0] - 'A' + 1);
	_chdir("\\");
	strcpy(buf, PDirectory);
	strcat(buf, "\\SKIZZEN");
	token= strtok(buf, "\\");
	while ((token= strtok(NULL, "\\")) != NULL)
		if ( _chdir(token) == -1)
		{
			if (mkdir(token) == -1)
			{
				MessageBox(GetFocus(), token,
						   "Verzeichniss kann nicht erstellt werden!", MBFAILURE);
				return FALSE;
			}
			if (_chdir(token) == -1)
			{
				MessageBox(GetFocus(), token,
						   "Verzeichniss kann nicht gendert werden!", MBFAILURE);
				return FALSE;
			}
		}
	_chdrive(szDrive[0] - 'A' + 1);
	_chdir("\\");
	strcpy(buf, szDirectory);
	token= strtok(buf, "\\");
	while ((token= strtok(NULL, "\\")) != NULL)
		_chdir(token);
	return TRUE;
}

//zerlegt den kompletten Dateinamen in seine Bestandteile
void TFileLocations::SplitFileName ( LPCSTR DirFileName)
{
	_splitpath( DirFileName, Drive, Dir, Name, Ext );
	sprintf( Path, "%s%s", Drive, Dir );
}

////////////////////////////////////////////////////////////////////////////////
// Lesen und Schreiben von FileLocations
////////////////////////////////////////////////////////////////////////////////

void _CURVECLASS WINAPI InitializeFileLocations( LPCSTR aProgPath )
{
  _FREEOBJ(FileLocations);
	FileLocations= new TFileLocations(aProgPath);
}

LPCSTR _CURVECLASS WINAPI GetDirectory( void )
{
	if (FileLocations) return FileLocations->GetDirectory();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetName( void )
{
	if (FileLocations) return FileLocations->GetName();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetHWFile( void )
{
	if (FileLocations) return FileLocations->GetHWFile();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetCFile( void )
{
	if (FileLocations) return FileLocations->GetCFile();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetHelpFile( void )
{
	if (FileLocations) return FileLocations->GetHelpFile();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetPTopoName( void )
{
	if (FileLocations) return FileLocations->GetPTopoName();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetPDiffName( void )
{
	if (FileLocations) return FileLocations->GetPDiffName();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetPTopoFile( void )
{
	if (FileLocations) return FileLocations->GetPTopoFile();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetPDiffFile( void )
{
	if (FileLocations) return FileLocations->GetPDiffFile();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetPTopoDirectory( void )
{
	if (FileLocations) return FileLocations->GetPTopoDirectory();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetPDiffDirectory( void )
{
	if (FileLocations) return FileLocations->GetPDiffDirectory();
  return "";
}

//klier 25.02.2003
LPCSTR _CURVECLASS WINAPI GetPTopoBackupDirectory( void )
{
	if (FileLocations) return FileLocations->GetPTopoBackupDirectory();
  return "";
}

//klier 25.02.2003
LPCSTR _CURVECLASS WINAPI GetPDiffBackupDirectory( void )
{
	if (FileLocations) return FileLocations->GetPDiffBackupDirectory();
  return "";
}

//klier 16.03.2003
BOOL _CURVECLASS WINAPI SetPTopoBackupDirectory( LPCSTR lDir)
{
	if (FileLocations) return FileLocations->SetPTopoBackupDirectory(lDir);
  return FALSE;
}

//klier 16.03.2003
BOOL _CURVECLASS WINAPI SetPDiffBackupDirectory( LPCSTR lDir)
{
	if (FileLocations) return FileLocations->SetPDiffBackupDirectory(lDir);
  return FALSE;
}

//klier 16.03.2003
BOOL _CURVECLASS WINAPI SetPTopoFile( LPCSTR FileName )
{
	if (FileLocations) return FileLocations->SetPTopoFile(FileName);
  return FALSE;
}

//klier 16.03.2003
BOOL _CURVECLASS WINAPI SetPDiffFile( LPCSTR FileName )
{
	if (FileLocations) return FileLocations->SetPDiffFile(FileName);
  return FALSE;
}

LPCSTR _CURVECLASS WINAPI GetTestDevFile( void )
{
	if (FileLocations) return FileLocations->GetTestDevFile();
  return "";
}

LPCSTR _CURVECLASS WINAPI GetMacroFile( LPCSTR macroname )
{
	if (FileLocations) return FileLocations->GetMacroFile( macroname );
  return "";
}

//##############################################################################
// TMainParameters
//##############################################################################

class TMainParameters {
 public:
  TMainParameters(HINSTANCE aInstance, HWND aFrame, HWND aClient, UINT aMsg1, UINT aMsg2, BOOL aDefaults) 
  {
    m_Instance= aInstance;
    m_WndFrame= aFrame;
    m_WndClient= aClient;
	m_WndScan= 0;
    m_DrawMsg= aMsg1;
    m_WakeUpMsg= aMsg2;
    m_CreateIniDefaults= aDefaults;
  }

 public:
   HINSTANCE  GetMainInstance( void ) 
   { 
     return m_Instance; 
   };

   HWND  GetFrameHandle( void ) 
   { 
     return m_WndFrame; 
   };

   HWND  GetScanHandle( void ) 
   { 
     return m_WndScan; 
   };
   void  SetScanHandle( HWND aScan ) 
   { 
     m_WndScan= aScan; 
   };

   HWND  GetClientHandle( void ) 
   { 
     return m_WndClient; 
   };

   UINT  GetDrawMsg( void ) 
   { 
     return m_DrawMsg; 
   };

   UINT  GetWakeUpMsg( void ) 
   { 
     return m_WakeUpMsg; 
   };

   BOOL  CreateDefaults( void ) 
   { 
     return m_CreateIniDefaults; 
   };

private:
  HINSTANCE m_Instance;
  HWND      m_WndFrame; // Handle zum Hauptfenster
  HWND      m_WndClient; // der dunkel hinterlegte Bereich, wo die MDI-Fenster reinkommen
  HWND		m_WndScan; // Handle des LineScan-Fensters
  UINT      m_DrawMsg; // Botschaft fr's Neuzeichen der Statuszeile
  UINT      m_WakeUpMsg; // Botschaft fr's "Aufwachen" von Steering
  BOOL      m_CreateIniDefaults;
};

//##############################################################################
// VERWALTUNG VON MainParameters
//##############################################################################

BOOL _CURVECLASS WINAPI InitializeMainParameters(HINSTANCE aInstance, HWND aFrame, HWND aClient, UINT aMsg1, UINT aMsg2, BOOL aDefaults) 
{
	_FREEOBJ(MainP);
	MainP= new TMainParameters(aInstance, aFrame, aClient, aMsg1, aMsg2, aDefaults);
	return TRUE;
};

HINSTANCE _CURVECLASS WINAPI GetMainInstance(void)
{
	if (MainP) return MainP->GetMainInstance();
	return 0;
};

HWND _CURVECLASS WINAPI GetFrameHandle(void)
{
	if (MainP) return MainP->GetFrameHandle();
	return 0;
};

HWND _CURVECLASS WINAPI GetScanHandle(void)
{
	if (MainP) return MainP->GetScanHandle();
	return 0;
};

void _CURVECLASS WINAPI SetScanHandle(HWND aScan)
{
	if (MainP) MainP->SetScanHandle(aScan);
};

HWND _CURVECLASS WINAPI GetClientHandle(void)
{
	if (MainP) return MainP->GetClientHandle();
	return 0;
};

UINT _CURVECLASS WINAPI GetDrawMsg(void) 
{
	if (MainP) return MainP->GetDrawMsg();
	return 0; // diese Methode kann aufgerufen werden bevor MainP initialisiert ist, weil 
};

UINT _CURVECLASS WINAPI GetWakeUpMsg(void) 
{
	if (MainP) return MainP->GetWakeUpMsg();
	return 0;
};

BOOL _CURVECLASS WINAPI CreateDefaults(void)
{
	if (MainP) return MainP->CreateDefaults();
	return TRUE;
};

//17.11.2002
/*LPDataBase _CURVECLASS WINAPI  GetDataBasePtr ( void ) {
	if (!bModulLoaded) return NULL;
	return (LPDataBase)lpDBase;
};*/

//##############################################################################
// Verwaltung der SPLIB.DLL
//##############################################################################

BOOL WINAPI DllMain(HINSTANCE hModule, DWORD dwFunction, LPVOID)
{
	switch (dwFunction)
	{
		case DLL_PROCESS_ATTACH:
			//Datum: 02.07.2003 bModulLoaded= FALSE;
			hModuleInstance= hModule;
			lpDBase= new TDataBase();
			break;

		case DLL_PROCESS_DETACH:
			_FREEOBJ(MainP);
			_FREEOBJ(FileLocations);
			_FREEOBJ(lpDBase);

			//CHECKMEM("SPLIB.DLL");	//hp
			break;
	}

	return TRUE;
}

LPCSTR _CURVECLASS WINAPI spGetVersion(void)
{
	return((LPCSTR)spVersion);
}

HINSTANCE _CURVECLASS WINAPI spGetInstance(void)
{
	return(hModuleInstance);
}

//##############################################################################
// Rest
//##############################################################################

void _CURVECLASS WINAPI SetInfo(LPCSTR status_txt)
{
	ATOM hAtom;

	hAtom= GlobalAddAtom(status_txt);
	if (hAtom)
		SendMessage(GetFrameHandle(), MainP->GetDrawMsg(), DRAWSTATUS2, (LONG)hAtom);
};

void _CURVECLASS WINAPI SetStaticInfo(LPCSTR status_txt)
{
	ATOM hAtom;

	hAtom= GlobalAddAtom(status_txt);
	if (hAtom)
		PostMessage(GetFrameHandle(), MainP->GetDrawMsg(), DRAWSTATUS0, (LONG)hAtom);
};

void _CURVECLASS WINAPI SetStatus(LPCSTR status_txt)
{
	ATOM hAtom;

	hAtom= GlobalAddAtom(status_txt);
	if (hAtom)
		PostMessage(GetFrameHandle(), MainP->GetDrawMsg(), DRAWSTATUS1, (LONG)hAtom);
};

BOOL _CURVECLASS WINAPI FileOpenDialog(LPCSTR HeadLine, LPSTR szFilter, LPSTR szFileName, LPCSTR StartupPath ) {
	DWORD Filter= 1;
	return FileOpenDialog( HeadLine, szFilter, szFileName, StartupPath, Filter );
}

BOOL _CURVECLASS WINAPI FileOpenDialog(LPCSTR HeadLine, LPSTR szFilter, LPSTR szFileName, LPCSTR StartupPath, DWORD &aFilterIndex)
{
	OPENFILENAME ofnTemp;
	DWORD Errval; 	// Error value
	char buf[5];  	// Error buffer
	char Errstr[50]= "GetOpenFileName returned Error #";
	char	chSeperator= '|';
	int	i;

	ofnTemp.lStructSize= sizeof(OPENFILENAME);
	ofnTemp.hwndOwner= GetFrameHandle(); // An invalid hWnd causes non-modality
	ofnTemp.hInstance= 0;
	ofnTemp.lpstrFilter= (LPSTR)szFilter;  // See previous note concerning string
	ofnTemp.lpstrCustomFilter= 0;
	ofnTemp.nMaxCustFilter= 0;
	ofnTemp.nFilterIndex= aFilterIndex;
	ofnTemp.lpstrFile= (LPSTR)szFileName;  // Stores the result in this variable
	ofnTemp.nMaxFile= _MAX_PATH;
	ofnTemp.lpstrFileTitle= NULL;
	ofnTemp.nMaxFileTitle= 0;
	ofnTemp.lpstrInitialDir= StartupPath;
	ofnTemp.lpstrTitle= HeadLine;
	ofnTemp.Flags= OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
	ofnTemp.nFileOffset= 0;
	ofnTemp.nFileExtension= 0;
	ofnTemp.lpstrDefExt= NULL;
	ofnTemp.lCustData= NULL;
	ofnTemp.lpfnHook= NULL;
	ofnTemp.lpTemplateName= NULL;

	for (i= 0;szFilter[i] != '\0';i++)
		if (szFilter[i] == chSeperator)
			szFilter[i]= '\0';
	if ( !GetOpenFileName(&ofnTemp) )
	{
		Errval= CommDlgExtendedError();
		if (Errval)
		{ // 0 value means user selected Cancel
			sprintf(buf, "%ld", Errval);
			strcat(Errstr, buf);
			MessageBox(GetFrameHandle(), Errstr, "WARNING", MBSTOP);
		}
		return FALSE;
	} else aFilterIndex= ofnTemp.nFilterIndex;
	InvalidateRect(GetFrameHandle(), NULL, TRUE ); // Repaint to display the new name
	return TRUE;
};

BOOL _CURVECLASS WINAPI FileSaveDialog(LPCSTR HeadLine, LPSTR szFilter, LPSTR szFileName, LPCSTR StartupPath ) {
	DWORD Filter= 1;
	return FileSaveDialog( HeadLine, szFilter, szFileName, StartupPath, Filter );
}

BOOL _CURVECLASS WINAPI FileSaveDialog(LPCSTR HeadLine, LPSTR szFilter, LPSTR szFileName, LPCSTR StartupPath, DWORD &aFilterIndex)
{
	OPENFILENAME ofnTemp;
	DWORD Errval; 	// Error value
	char buf[5];  	// Error buffer
	char Errstr[50]= "GetSaveFileName returned Error #";
	char	chSeperator= '|';
	int	i;

	ofnTemp.lStructSize= sizeof(OPENFILENAME);
	ofnTemp.hwndOwner= GetFrameHandle(); // An invalid hWnd causes non-modality
	ofnTemp.hInstance= 0;
	ofnTemp.lpstrFilter= szFilter;  // See previous note concerning string
	ofnTemp.lpstrCustomFilter= 0;
	ofnTemp.nMaxCustFilter= 0;
	ofnTemp.nFilterIndex= aFilterIndex;
	ofnTemp.lpstrFile= (LPSTR)szFileName;  // Stores the result in this variable
	ofnTemp.nMaxFile= _MAX_PATH;
	ofnTemp.lpstrFileTitle= NULL;
	ofnTemp.nMaxFileTitle= 0;
	ofnTemp.lpstrInitialDir= StartupPath;
	ofnTemp.lpstrTitle= HeadLine;
	ofnTemp.Flags= OFN_HIDEREADONLY | OFN_READONLY | OFN_OVERWRITEPROMPT;
	ofnTemp.nFileOffset= 0;
	ofnTemp.nFileExtension= 0;
	ofnTemp.lpstrDefExt= NULL;
	ofnTemp.lCustData= NULL;
	ofnTemp.lpfnHook= NULL;
	ofnTemp.lpTemplateName= NULL;

	for (i= 0;szFilter[i] != '\0';i++)
		if (szFilter[i] == chSeperator)
			szFilter[i]= '\0';
	if ( !GetSaveFileName(&ofnTemp) )
	{
		Errval= CommDlgExtendedError();
		if (Errval)
		{ // 0 value means user selected Cancel
			sprintf(buf, "%ld", Errval);
			strcat(Errstr, buf);
			MessageBox(GetFrameHandle(), Errstr, "WARNING", MBSTOP);
		}
		return FALSE;
	} else aFilterIndex= ofnTemp.nFilterIndex;
	InvalidateRect(GetFrameHandle(), NULL, TRUE); // Repaint to display the new name
	return TRUE;
};

BOOL _CURVECLASS WINAPI PathCanWrite(LPSTR szPath) 
{ 
	OFSTRUCT of;
	char TestFile[ _MAX_PATH ], p[ _MAX_PATH ], drv[ _MAX_DRIVE+1 ], dir[ _MAX_DIR+1 ], name[ _MAX_FNAME+1 ], ext[ _MAX_EXT+1 ];
	strcpy(p, szPath);
	if ( p[ max(0, strlen(p)-1) ] != '\\' )
		strcat( p, "\\" );
	_splitpath( p, drv, dir, name, ext );	

	_makepath( TestFile, drv, dir, "check", "tmp" );
	HFILE hfile= OpenFile( TestFile, &of, OF_CREATE );
	if ( hfile!=HFILE_ERROR ) {
		_lclose( hfile );
		remove( TestFile );
		_makepath( szPath, drv, dir, "", "" );
	} 
	return ( hfile!=HFILE_ERROR );
}

BOOL _CURVECLASS WINAPI SetFPOnData(HFILE hfile)
{
	char data;
	char *buf;
	//! BOOL	  EoH= FALSE;
	int cnt, cntfp;

	// the file pointer will be set on the first character after
	// the key [Data] and any whitespaces (\r \n \t _)
	buf= new char[21];
	_llseek(hfile, 0, FILE_BEGIN);
	cntfp= 0;
	while (_lread(hfile, &data, 1))
	{
		cntfp++;
		if (data == '[')
		{
			cnt= 0;
			while (_lread(hfile, &data, 1))
			{
				cntfp++;
				if ( data == ']' || cnt>5 )
				{
					buf[cnt++]= 0;
					if (strstr(buf, "Data"))
						goto Finish;
					else
						goto SearchAgain;
				}
				buf[cnt++]= data;
			} // after break
			_FREELIST(buf);
			return FALSE;
		}
SearchAgain:
		/*nur eine leere Anweisung, wegen SearchAgain-Label*/;
	}
	_FREELIST(buf);
	return FALSE;
Finish:
	while (_lread(hfile, &data, 1))
	{
		if (data == ' ')
			continue;
		if (data == '\r')
			continue;
		if (data == '\n')
			continue;
		if (data == '\t')
			continue;
		_llseek(hfile, -1, SEEK_CUR);

		_FREELIST(buf);
		return TRUE;
	}
	_FREELIST(buf);
	return FALSE;
}

//Datum: 03.02.2003
/*int _CURVECLASS WINAPI GetBufferLine(LPSTR src,LPSTR dst,int dstsize) {
	static LPSTR Source= NULL;
	static WORD cnt_s;
	BOOL EoL= FALSE;
	char data;
	int cnt_d= 0;
 
	if (src != NULL) 
	{
		Source= src;
		cnt_s= 0;
	}
	if (!Source) return FALSE;
	if (Source[cnt_s] == '\0') return FALSE;
	do {
		data= Source[cnt_s++];
		switch(data) {
			case '\n': 
			case '\r':
				data= Source[cnt_s++];
				if(EoL) goto Ready;
				EoL= TRUE;
				continue;
 
			case '\0':
				dst[cnt_d]= '\0';
				return R_EndOfFile;
 
			default:
		  		dst[cnt_d++]= data;
		}
	} while(cnt_d < dstsize);
Ready:
	dst[cnt_d]= '\0';
	return TRUE;
	};
*/

int _CURVECLASS WINAPI GetFileLine(int hFile, LPSTR dst, int dstsize)
{
	char data;
	BOOL	EoL= FALSE;
	int cnt= 0;
	int rdl;

	dst[cnt]= '\0';
	if (hFile == -1)
		return FALSE;
	do
	{
		rdl= _lread(hFile, &data, 1);
		switch (data)
		{
			case '\n':
			case '\r':
				rdl= _lread(hFile, &data, 1);
				if (EoL)
					goto Ready;
				EoL= TRUE;
				continue;

			case '\0':
				dst[cnt]= '\0';
				return R_EndOfFile;

			default:
				if (EoL)
					goto Ready;
				dst[cnt++]= data;
		}
	} while (cnt < dstsize);
Ready:
	_llseek(hFile, -1, SEEK_CUR);
	dst[cnt]= '\0';
	if (cnt == dstsize)
	{
		// overflow dst
		return R_Overflow;
	};
	if (!rdl)
		return R_EndOfFile;
	return TRUE;
}

EUnitType _CURVECLASS WINAPI UnitEnum(LPSTR sz_unit)
{
	char buf[MaxString];
	strcpy(buf, sz_unit);
	strupr(buf);
	if (strstr((LPSTR)buf, "GRAD"))
		return utGrad;
	if (strstr((LPSTR)buf, "SEKUNDEN"))
		return utSekunden;
	if (strstr((LPSTR)buf, "MINUTEN"))
		return utMinuten;
	if (strstr((LPSTR)buf, "MINUTS"))
		return utMinuten;
	if (strstr((LPSTR)buf, "MILLIMETER"))
		return utMillimeter;
	if (strstr((LPSTR)buf, "MIKROMETER"))
		return utMikrometer;
	if (strstr((LPSTR)buf, "MIKCOMETER"))
		return utMikrometer;
	if (strstr((LPSTR)buf, "CHANNEL"))
		return utChannel;
	return utNone;
}

float _CURVECLASS WINAPI CalcValueInUnit(EUnitType aUnit, float fValParam) 
{
	switch (aUnit)
	{
		case utGrad:
			return ( fValParam / 3600.0 );

		case utMinuten:
			return ( fValParam / 60.0 );
	}
	return fValParam;
}

float _CURVECLASS WINAPI CalcValueFromUnit(EUnitType aUnit, float fValParam) 
{
	switch ( aUnit )
	{
		case utGrad:
			return ( fValParam * 3600 );

		case utMinuten:
			return ( fValParam * 60 );
	}
	return fValParam;
}

//Datum: 03.02.2003
/*LPSTR _CURVECLASS WINAPI UnitStr(TUnitType n_unit) {
	switch(n_unit) {
		case Grad:			
			return "Grad";
		
		case Minuten:   
			return "Minuten";
		
		case Sekunden:  
			return "Sekunden";
		
		case Millimeter:
			return "Millimeter";
		
		case Mikrometer:
			return "Mikrometer";
		
		case Channel:   
			return "Channel";
		
		default: 				
			return "None";

	}
};*/

//hp
static double dCountFreq= 0;
const double dDelayMin= 100;				// Faktor fr Delay()
void _CURVECLASS WINAPI InitializeDelay()
{
	LARGE_INTEGER freq;

	if(QueryPerformanceFrequency(&freq))
	{
		dCountFreq= freq.QuadPart;			// Counts je 1Sekunde
		dCountFreq= dCountFreq / 1000000;	// Counts je 1s
		dCountFreq= dCountFreq * dDelayMin;// unsere Basis, dauer von Delay(1);
	}
	else
		MessageBox(0,"Das System besitzt eine minimale Zeitauflsung von 1 Millisekunde. Dieser ungnstige Wert kann zu Fehlfunktionen fhren.","XCTL",MB_ICONINFORMATION | MB_OK);
}

void _CURVECLASS WINAPI Delay(long count)
{
	LARGE_INTEGER liStartCount, liStopCount;
	//double dPerfCount= liPerfCount.QuadPart
	double dFinishCount= 0; 

	if (dCountFreq)
	{
		QueryPerformanceCounter(&liStartCount);			// Startwert holen
		liStopCount.QuadPart= liStartCount.QuadPart;
		dFinishCount= dCountFreq * count + liStartCount.QuadPart;
		while (dFinishCount > liStopCount.QuadPart)
			QueryPerformanceCounter(&liStopCount);
	}
	else
	{
		if (count == 0)
			return;
		count= count / 100;	
		if(!count)				// leider gibt es auf diesem System keine hherauflsende Funktion als Sleep mit 1ms auflsung
			count= 1;			// daher ist alles unter count 100 gleich 1ms
		Sleep( (DWORD) count );
	}
}

void _CURVECLASS WINAPI ProcessMessages(UINT32 Ticks) {
	UINT start= ::GetTickCount();
	do {
		MSG msg;
		if ( PeekMessage(&msg,NULL,0,0,PM_REMOVE) ) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	} while ( ::GetTickCount()-start<Ticks );
}
/*
void _CURVECLASS WINAPI Delay(long count)
{
	if (count == 0)
		return;
	count= count / 100;	//bei ca 30 Takten/Addition, Bsp: (5000 * 11 + 920) * 30 / 33Mhz => ~ 0,05s= 50ms => faktor 100
	if(!count)				//leider gibt es keine hherauflsende Funktion als Sleep mit 1ms auflsung
		count= 1;			// daher ist alles unter count 100 gleich 1ms
	Sleep( (DWORD) count );
	//hp
}*/
/*
void _CURVECLASS WINAPI Delay(long count)
{

	long d1, corr=920*14, m=0;
	if(count == 0) return;
	if(count>0)
		count--;
	for(d1=0;d1<(count*11+corr);d1++)
		m=m+1;

}*/
void _CURVECLASS WINAPI DelayTime(int MilliSec)
{
	if (MilliSec == 0)
		return;
	Sleep( (DWORD) MilliSec );

}

//Datum: 16.08.2002 maxi, maxl, maxf, maxd, mini, minl, minf, mind verschoben nach U_VALUES.CPP

// __LastLine__
