// m_main.cpp
// (C) 1993,95 by Heiko Damerow MPG AG "Roentgenbeugung"
// (C) 1996 by Heiko Damerow DLR/DFD
#include <direct.h>

#include "internls\evrythng.h" // GermanVersion
#include "winresrc\rc_def.h"   // Ressourcen-IDs
#include "winresrc\rc_prtow.h" // Ressourcen-IDs (! neu: klier Protokollbuch)
#include "help\help_def.h"     // Help-IDs
#include <shellapi.h> 
//!neu ini-Datei klier
// Bibliotheken zum Zugriff auf das Dateisystem (16/32bit)
// damit koennen die Dateiattribute der Hardware-ini-Datei
// geaendert werden
#include <winbase.h>
#include <Commctrl.h>
#pragma hdrstop

#include "utils\u_window.h" 
//#include "datavisa\datavisa.h"
#include "workflow\workflow.h"
#include "detecuse\detecuse.h"
#include "motrstrg\motrstrg.h"

// Diffraktometrie
#include "difrkmty\a_extern.h" // TAreaScanWindow
#include "difrkmty\s_extern.h" // TScanWindow

//! neu: klier Allgemeine Einstellungen
#include "mespara\mespara.h"
#include "mespara\mesparaw.h"

//! neu: klier Protokollbuch
#include "protocol\protocol.h"

//! neu: Automatische Justage
#include "autojust\autojust.h"

// ANFANG 29.11.2002 Kullmann, Reinecker : getrennte Manuelle Justage, Topographie und neue Manuelle Justage
#include "manjust\mj_gui.h"    // neue Manuelle Justage
#include "manjust\mj_ogui.h"   // getrennte Manuelle Justage
#include "manjust\mj_old.h"    // alte ungetrennte Manuelle Justage
#include "topogrfy\tp_gui.h"   // getrennte Topographie
#include "topogrfy\topogrfy.h" // alte Topographie 
// ENDE 29.11.2002

#include "internls\l_layer.h"

#include "utils\CheckMemory.h"	// CHECKMEM

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

TModelessDlg *MacroExecDlg= 0; //! neu Kullmann+Reinecker: TheModeless ersetzt durch MacroExecDlg; extern entfernt
HACCEL TMain::hAccellerator= 0;

const int WatchStart= 0;
const int TargetStart= 15;
const int ReflectionStart= 105;
const int FlagStart= 155;
const int TextStart= 255;
const int WindowMenuPos= 4;
static BOOL bEnvInstalled= FALSE;
static int StatusLineHeight= 25;
static int retval;
static EWorkPlace WorkPlace= RTK;
static BOOL nStartupReport= 0;
static HGDIOBJ testobc;
static BOOL bShutdown= FALSE;
static char buf[MaxString];

HINSTANCE hMDLL;
HINSTANCE CountersDLLInstance;

//!neu klier Allgemeine Einstellungen
TMeasurementParameter MeasurementParameter;

TMain Main; //Datum: 03.08.2002= TMain();
//17.11.2002 LPDataBase lpDBase;

extern TSteering Steering;
extern TTopographyOld TopographyOld;

//Prototypen
//17.11.2002 LPDataBase WINAPI GetDataBasePtr( void );

//!neu ini-Datei klier
BOOL bNoHardwareFile= TRUE;      // Pruefvariable ist TRUE, wenn Hardware-ini-Datei nicht existiert
BOOL bNoConfigurationFile= TRUE; // Pruefvariable ist TRUE, wenn Programm-ini-Datei nicht existiert

BOOL bManualMovesCorrected= FALSE;

static char mainVersion[]= "V 1.52 ("__DATE__")";

#ifdef GermanVersion
  static const char strFailure[]= "Fehler";
  static const char strMessage[]= "Meldung";
  static const char strMessage01[]= "Messung wird abgebrochen";
  static const char strMessage02[]= "MDI-Fenster kann nicht erzeugt werden! Zu viele Fenster?";
  static const char strMessage03[]= "Daten wurden noch nicht gesichert.\nSichern ?";
  static const char strMessage4[]= "kont. &PSD-Anzeige ausschalten";
  static const char strMessage04[]= "Messung &weiterfhren";
  static const char strMessage05[]= "Messung &unterbrechen";
  static const char strMessage5[]= "Makro &unterbrechen";
  static const char strMessage06[]= "Das Motorsteuer-Modul ist noch anderweitig in Benutzung !";
  static const char strMessage07[]= "Neustart";
  static const char strMessage08[]= "Endlage von Motor %d angesprochen.";
  static const char strMessage09[]= "Motor-Steuerung";
  static const char strMessage10[]= "Programm wurde erfolgreich gestartet.";
  static const char strMessage11[]= "Probleme beim Starten des Programms";
  static const char strMessage12[]= "Bitte ein Darstellungs-Fenster ffnen !";
  static const char strMessage13[]= "Die Messung wurde abgeschlossen !";
  static const char strMessage15[]= "Fehler beim Starten einer Me-Funktion.";
  static const char strMessage16[]= "Fehler beim Starten eines MDI-Fensters.";
#else
  static const char strFailure[]= "Failure";
  static const char strMessage[]= "Message";
  static const char strMessage01[]= "Measurement interrupted";
  static const char strMessage02[]= "Can't create MDI-window! Too many windows?";
  static const char strMessage03[]= "The data wasn't saved !\nSaving ?";
  static const char strMessage4[]= "stop cont. &PSD-display";
  static const char strMessage04[]= "&Continue the measurement";
  static const char strMessage05[]= "&Interrupt the measurement";
  static const char strMessage5[]= "&Interrupt &macro";
  static const char strMessage06[]= "The drive module is always used!";
  static const char strMessage07[]= "Restart";
  static const char strMessage08[]= "Limit from drive %d hit";
  static const char strMessage09[]= "Motor-Steering";
  static const char strMessage10[]= "Program started successful.";
  static const char strMessage11[]= "Problems with starting program";
  static const char strMessage12[]= "Please open a view window!";
  static const char strMessage13[]= "Measurement completed !";
  static const char strMessage15[]= "Fehler beim Starten einer Me-Funktion.";
#endif

//******************************************************************************
//******************************************************************************
//******************************************************************************

int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInst, LPSTR, int cmdShow)
{
// ACHTUNG bis nach dem Aufruf von Methode InitializeFileLocations() drfen die Methoden zum Auslesen von FileLocations nicht verwendet werden
	CreateMutex(NULL,true,"XCTL_32_INSTANCE");	//hp Mutexobjekt anlegen
	if ( GetLastError() == ERROR_ALREADY_EXISTS ) //hp prfen ob es schon existiert
	{ // only single instance allowed		
		// SetActivWindow(hPrevInst);
		exit(0);
	}												//hp nderung ntig, da hPrevInst unter Win32 immer 0

// damit die beiden individuellen Meldungen registiert sind
  // bereits bei der Erzeugung des Fensters kann TMain::EventHandler() aufgerufen werden, dazu mssen die Meldungen bereits registiert sein
	InitializeMainParameters(hInstance, 0, 0, RegisterWindowMessage("DrawStatus"), RegisterWindowMessage("WakeUpSteering"), FALSE);

// vollstndigen Programmpfad ermitteln und prfen ob ini-Dateien vorhanden sind (ggf. Programmabbruch)
	char _arg[_MAX_PATH];
	GetModuleFileName(hInstance,_arg,_MAX_PATH);
	InitializeFileLocations( _arg ); // verwaltet in TFileLocations

// Test ob die Programm-ini-Datei existiert (bentigt FileLocations)
	OFSTRUCT of;
	if (OpenFile(GetCFile(), &of, OF_EXIST) == -1) 
	{ 
#ifdef GermanVersion
		MessageBox(GetFocus(), "Kein Konfigurationsfile !", "Fehler", MBSTOP);
#else
		MessageBox(GetFocus(), "Configuration file not found !", "Failure", MBSTOP);
#endif
		exit(4);
	} 
  else 
    bNoConfigurationFile= FALSE; // Datei ist vorhanden

// Test ob die Hardware-ini-Datei existiert (bentigt FileLocations)
	if (OpenFile(GetHWFile(), &of, OF_EXIST) == -1) 
	{ 
#ifdef GermanVersion
		MessageBox(GetFocus(), "Kein Hardwarekonfigurationsfile !", "Fehler", MBSTOP);
#else
		MessageBox(GetFocus(), "Hardware configuration file not found !", "Failure", MBSTOP);
#endif
		exit(4);
	} 
  else 
    bNoHardwareFile= FALSE; // Datei ist vorhanden

// Gre der Messagequeue auf 100 Eintrge setzen (in Win32 eigentlich obsolete)
	int cnt= 100;
	while (!SetMessageQueue(cnt--))	
		/* increase messagequeue-size*/;

// Hauptprogramm, incl. Fenstern initialisieren
	if ( !Main.Init(hInstance, cmdShow) ) nStartupReport += 1;

// Testen ob Timer verfgbar sind (benoetigt das Hauptfenster)
	cnt= SetTimer(GetFrameHandle(), 2000, 30000, NULL);
	if (cnt)
		KillTimer(GetFrameHandle(), 2000);
	else
#ifdef GermanVersion
		MessageBox(GetFocus(), "Keine Timer verfgbar !", "System-Fehler", MBSTOP);
#else
		MessageBox(GetFocus(), "No Timer available !", "System-Failure", MBSTOP);
#endif

// initialize DLLs, Hardware und Fenster (bentigt Hauptfenster)
	Main.InitHardware();

	return TMain::MessageLoop();
};
//-----------------------------------------------------------------------------

void ShowProgramStatus(HWND hwnd)
{
	char buf[MaxString];
	char fn[MaxString];
	char info[3*MaxString];

	GetModuleFileName(mlGetInstance(), fn, MaxString);
	sprintf(buf, "Drive   : %s [%s]\n\n", mlGetVersion(), fn);
	strcpy(info, buf);
	GetModuleFileName(dlGetInstance(), fn, MaxString);
	sprintf(buf, "Detector  : %s [%s]\n\n", dlGetVersion(), fn);
	strcat(info, buf);
	GetModuleFileName(spGetInstance(), fn, MaxString);
	sprintf(buf, "Library : %s [%s]\n\n", spGetVersion(), fn);
	strcat(info, buf);
	sprintf(buf, "Main    : %s\n", mainVersion);
	strcat(info, buf);
	MessageBox(hwnd, info, "Versionskontrolle", MBINFO);
};

//#############################################################################
// TMain
//#############################################################################

TMain::TMain(void): m_EventHandler(true, true, false), ScanWindow(0), AreaScanWindow(0), hScanWindow(0), hAreaScanWindow(0), hTheMenu(0), hwndStatusBar(NULL), hwndClient(NULL) // 16.06.2004 , bmpStatusLine
{
	// ! neu Kullmann+Reinecker: Es ist immer ratsam ALLE Attribute zu initialisieren !!!
	//Datum 16.05.2003: AdjustmentWindow= NULL;
	//Datum 16.05.2003: CCDLineScanWindow= NULL;
	//Datum 16.05.2003: AreaScanCCDWindow= NULL;
	//Datum 16.05.2003: hCCDLineScanWindow= 0;
	//Datum 16.05.2003: hAreaScanCCDWindow= 0;
	//Datum 16.05.2003: hActualWindow= 0;
	//24.04.2004 CurrentID= 0;
	//24.04.2004 CurrentPopup= 0;
	strcpy(StatusInfo, "");
	strcpy(AdditionalInfo, "");
	// Laden der Einstellungen ausgelagert in WinMain()
	InitializeDelay();
	PRE;	//hp
};
//-----------------------------------------------------------------------------

TMain::~TMain(void)
{ // Mdi-Fenster (u.a. ScanWindow, AreaScanWindow,) sind bereits freigegeben
	// ANFANG 23.01.2003 Kullmann, Reinecker : getrennte Topographie und Manuelle Justage
	IniWriteBool( GetCFile(), "Environment", "NEW-MANUALADJUSTMENT", m_NewManJustage );
	// ENDE 23.01.2003
	if (!bNoHardwareFile && !bNoConfigurationFile)
		SavePos();
	UnInitializeMotorsSimulation();
	MeasurementParameter.Save(GetCFile());
	//!neu ini-Datei klier
	/*
	#ifndef _WIN32
	  _rtl_chmod(GetHWFile(),1,FA_HIDDEN + FA_ARCH + FA_RDONLY); // Schreibschutzattribut der Hardware-
	#else                                                  // ini-Datei wird gesetzt
	  SetFileAttributes(GetHWFile(),FILE_ATTRIBUTE_HIDDEN + FILE_ATTRIBUTE_ARCHIVE
	                    + FILE_ATTRIBUTE_READONLY);
	#endif
	*/ 
	
	// ANFANG: neu Kullmann+Reinecker (31.01.2004) anderen Klassen gestatten auf Ereignisse zur reagieren
	TIndex i= 0;
	while ( i<m_EventHandler.GetCount() ) {
		IMainEvents *act= (IMainEvents *)m_EventHandler[i];
		if ( act ) act->OnLeave(); // benachrichtigen
		if ( i<m_EventHandler.GetCount() && m_EventHandler[i]==act ) i++; // diese Bedingung ist nicht erfllt, wenn sich <act> in OnLeave mit RemoveFromEventList aus der Liste entfernt hat; dann i nicht weitersetzen!!!
	}
	// abschlieend die Liste freigeben
	while ( m_EventHandler.GetCount() ) {
		IMainEvents *act= (IMainEvents *)m_EventHandler.Remove(0);
		if ( act ) _FREEOBJ(act);
	}	
	// ENDE: neu Kullmann+Reinecker (31.01.2004)

	POST;
	DUMPDIFF("TMAIN");	//hp
	CHECKMEM("TMAIN");
};
//-----------------------------------------------------------------------------

BOOL TMain::Init( HINSTANCE hInstance, int cmdShow ) 
{
  //!neu klier Allgemeine Einstellungen
	MeasurementParameter.Load(GetCFile());

	bManualMovesCorrected= GetPrivateProfileInt("ManualMoves", "Correction",
							FALSE, GetCFile());

	// ANFANG 23.01.2003 Kullmann, Reinecker : getrennte Topographie und Manuelle Justage
	m_NewManJustage= IniReadBool( GetCFile(), "Environment", "NEW-MANUALADJUSTMENT", TRUE );
	// ENDE 23.01.2003

//welche Art Arbeitsplatz
	GetPrivateProfileString("Steuerprogramm", "Environment", "RTK", buf, MaxString, GetCFile());
	if ( !strcmp(buf, "HRM") )
		WorkPlace= HRM;
	else if ( !strcmp(buf, "Expert") )
		WorkPlace= Expert;
	else if ( !strcmp(buf, "ScanTable") )
		WorkPlace= ScanTable;
	else if ( !strcmp(buf, "PDI-Diffractometer") )
		WorkPlace= PDI_Diffractometer;
	else if ( !strcmp(buf, "Diff2") )
		WorkPlace= Diff2;
	else if ( !strcmp(buf, "Diff3") )
		WorkPlace= Diff3;
	else
		WorkPlace= RTK; // DEFAULT "RTK"

//welche Features freischalten (benoetigt Art des Arbeitsplatzes)
	AreaScanExtention= ScanExtention= MacroExtention= TopographyExtention= FALSE;
	switch (WorkPlace)
	{
		case HRM:
			AreaScanExtention= ScanExtention= TRUE;
			break;

		case RTK:
			ScanExtention= TopographyExtention= TRUE;
			break;

		case PDI_Diffractometer:
			AreaScanExtention= ScanExtention= TopographyExtention= TRUE;
			break;

		case Diff2:
			AreaScanExtention= ScanExtention= TopographyExtention= TRUE;
			break;

		case Diff3:
			AreaScanExtention= ScanExtention= TopographyExtention= TRUE;
			break;

		case Expert:
			MacroExtention= AreaScanExtention= ScanExtention= TopographyExtention= TRUE;
			break;

		default:
			ScanExtention= TopographyExtention= TRUE;
	}

	// Hauptfenster mit Men
	WNDCLASS wndClass;
	GetClassInfo(NULL, APPLICATIONTITLE, &wndClass);
	wndClass.style= CS_HREDRAW | CS_VREDRAW;
	wndClass.cbClsExtra= 0;
	wndClass.cbWndExtra= 0;
	wndClass.hInstance= hInstance;
	wndClass.hIcon= (HICON)LoadImage( hInstance, MAKEINTRESOURCE(icon_XControl),IMAGE_ICON,0,0,LR_DEFAULTCOLOR);
	wndClass.hCursor= (HCURSOR)LoadImage(NULL, IDC_ARROW,IMAGE_CURSOR,0,0,LR_DEFAULTCOLOR);
	wndClass.hbrBackground= (HBRUSH)COLOR_APPWORKSPACE + 1;
	wndClass.lpszMenuName= NULL;
	wndClass.lpszClassName= APPLICATIONTITLE;
	wndClass.lpfnWndProc= TMain::EventHandler;
	RegisterClass(&wndClass); 
	HWND WndFrame= CreateWindow(APPLICATIONTITLE, APPLICATIONTITLE, MainWindow_Style,
									  5, 5, 500, 500, NULL, NULL, hInstance, NULL); // sendet WM_CREATE an TMain::EventHandler

	// Clientbereich (wo sich die MDI-Fenster rein kommen)
	CLIENTCREATESTRUCT ClientCreate;
	ClientCreate.hWindowMenu= GetSubMenu(hTheMenu, 1);
	ClientCreate.idFirstChild= 2000;
	ClientCreate.hWindowMenu= GetSubMenu(hTheMenu, WindowMenuPos);
	hwndClient= CreateWindow( (LPSTR)"MdiClient", 0, ClientWindow_Style,
							   0, 0, 0, 0, WndFrame, (HMENU)NULL, hInstance, (LPSTR) &ClientCreate);
	ShowWindow(hwndClient, SW_SHOW); 

	// Statuszeile
	CreateStatusBar(hInstance, WndFrame);

	// Hauptfenster anzeigen und Statuszeile erzeugen; Tastenkombinationen laden
	ShowWindow(WndFrame, cmdShow);
	UpdateWindow(WndFrame);
	TMain::hAccellerator= LoadAccelerators(hInstance, MAKEINTRESOURCE(ACC_Main)); // Tastenkombinationen laden

	// die gemeinsam genutzen Attribute in TMainParameters verwalten (die bereits oben registrierten Meldungen verwenden, nicht neu registrieren)
	BOOL createDefs= IniReadBool(GetCFile(), "Steuerprogramm", "CreateIniDefaults", TRUE);
	BOOL result= InitializeMainParameters(hInstance, WndFrame, hwndClient, GetDrawMsg(), GetWakeUpMsg(), createDefs);

	//bentigt MainParameters
	CreateMenuBar();
	LoadPos();

	// jetzt erst den neuen Hintergrund zeigen
	DefMdiClientProc= (WNDPROC) SetWindowLong(hwndClient, GWL_WNDPROC, (LONG) TMain::EventHandlerMdiClient);
	return result;
}
//-----------------------------------------------------------------------------

void TMain::InitHardware() {
//MOTORS.DLL
	InitializeMotorsSimulation(GetHWFile());

	if (!mlInitializeMotorsDLL())
		nStartupReport += 2;
	mlSetAxis(0);

//COUNTERS.DLL
	CountersDLLInstance= GetModuleHandle("counters.dll");
	if (!CountersDLLInstance)
		MessageBox(GetFocus(), "Bibliothek counters.dll nicht geladen !", "Fehler", MBSTOP);

//PROTOCOL.DLL
	InitializeProtocol(GetFrameHandle(), &MeasurementParameter);

//Steering
	//!
	if (! Steering.Initialize( GetFrameHandle(), mlGetAxis(), TDetectorManager::DetectorManager().GetDetector() ))
	{
		exit(0);
	}

//Topography
	TopographyOld.Initialize();

	bEnvInstalled= TRUE;

//Autokalibierung?
	BOOL bAutoCalibration= GetPrivateProfileInt("Steuerprogramm", "AutoCalibration",
												 FALSE, GetCFile());
	if (bAutoCalibration)
		mlInquireReferencePointDlg(99);

//zeige gewnschte Fenster an
	int nStartup= 0;
	GetPrivateProfileString("Steuerprogramm", "Startup", "Scan", buf, MaxString, GetCFile());
	if ( !strcmp(buf, "AreaScan") )
		nStartup= 0;
	else if ( !strcmp(buf, "Detector") )
		nStartup= 1;
	else if ( !strcmp(buf, "ManualAdjustment") )
		nStartup= 3;
	else if ( !strcmp(buf, "ScanPlace") )
		nStartup= 4;
	else if ( !strcmp(buf, "ExecuteMacro") )
		nStartup= 5;
	else if ( !strcmp(buf, "Nothing") )
		nStartup= 6;
	else if ( !strcmp(buf, "AreaScanCCD") )
		nStartup= 7;
	else
		nStartup= 2; // DEFAULT "Scan"
	switch (nStartup)
	{
			case 0:
				if (AreaScanExtention && !AreaScanWindow)							
					(new TAreaScanWindow(GetMainInstance()))->Show(); // bei TAreaScanWindow.Create() wird auch AreaScanWindow auf dieses Fenster gesetzt
				(new TCounterWindow(GetMainInstance()))->Show(); 
				break;

			case 1:
				(new TCounterWindow(GetMainInstance()))->Show(); 
				break;

			case 2:
				if (ScanExtention && !ScanWindow )
					(new TScanWindow(GetMainInstance()))->Show(); // bei TScanWindow.Create() wird auch ScanWindow auf dieses Fenster gesetzt
				(new TCounterWindow(GetMainInstance()))->Show(); 
				break;

			case 3:
				(new TCounterWindow(GetMainInstance()))->Show(); 
				PostMessage(GetFrameHandle(), WM_COMMAND, cm_AngleControl, 0);
				break;

			case 5:
				if (MacroExtention)
					PostMessage(GetFrameHandle(), WM_COMMAND, cm_CallExecuteMacro, 0);
				break;

			case 6:
				/* do not execute default-path */;
				break;

			default:
				(new TCounterWindow(GetMainInstance()))->Show(); 
	}
	if (nStartupReport)
		sprintf(buf, "%s (%d)", strMessage11, nStartupReport);
	else
		sprintf(buf, "%s", strMessage10);
	SetInfo(buf);
}
//-----------------------------------------------------------------------------

void TMain::CreateStatusBar( HINSTANCE hInstance, HWND hWnd )
{ // GetMainInstance und GetFrameHandle drfen noch nicht verwendet werden, 
  // weil InitializeMainParameters noch nicht aufgerufen wurde - deshalb 
  // werden HINSTANCE und HWND bergeben

	INITCOMMONCONTROLSEX InitCtrls;
	int PartArray[6]= { WatchStart, TargetStart, ReflectionStart, FlagStart, TextStart, -1 };

    // CommonControl DLL laden
	InitCtrls.dwSize= sizeof(INITCOMMONCONTROLSEX);
	InitCtrls.dwICC= ICC_BAR_CLASSES;
	if (!InitCommonControlsEx(&InitCtrls)) return; 

    // StatusBar erzeugen 
    hwndStatusBar= CreateWindowEx( 
        0,                       // no extended styles 
        STATUSCLASSNAME,         // name of status bar class 
        (LPCTSTR) NULL,          // no text when first created 
        SBARS_SIZEGRIP |         // includes a sizing grip 
        WS_CHILD | WS_VISIBLE,   // creates a child window 
        0, 0, 0, 0,              // ignores size and position 
        hWnd,                    // handle to parent window 
        (HMENU) id_STATUS_BAR,   // child window identifier 
        hInstance,       // handle to application instance 
        NULL);                   // no window creation data 
 
    // Nachricht an StatusBar, wie die Unterteilungen aussehen sollen
    SendMessage(hwndStatusBar, SB_SETPARTS, (WPARAM) 6, (LPARAM) PartArray); 
}
//-----------------------------------------------------------------------------
//ph

HMENU TMain::CreateMenuBar ( void )
{
	hTheMenu= LoadMenu(GetMainInstance(), MAKEINTRESOURCE(menu_Main));

	if ( !ScanExtention )
		RemoveMenu(hTheMenu, cm_CallExecuteScan, MF_BYCOMMAND);
	if ( !AreaScanExtention )
		RemoveMenu(hTheMenu, cm_CallExecuteAreaScan, MF_BYCOMMAND);
	if ( !TopographyExtention )
		RemoveMenu(hTheMenu, cm_CallExecuteTopograpy, MF_BYCOMMAND);

	if ( !TopographyExtention )
		RemoveMenu(hTheMenu, cm_CallTopographyExec, MF_BYCOMMAND); // 03.01.2003 Kullmann, Reinecker : neue Topografie

	if ( !MacroExtention )
		RemoveMenu(hTheMenu, cm_CallExecuteMacro, MF_BYCOMMAND);
	if ( !TopographyExtention )
		RemoveMenu(hTheMenu, cm_TopograpyParam, MF_BYCOMMAND);

	if ( !TopographyExtention )
		RemoveMenu(hTheMenu, cm_TopographyAdjust, MF_BYCOMMAND); // 03.01.2003 Kullmann, Reinecker : neue Topografie


	SetMenu(GetFrameHandle(), hTheMenu);
	return NULL;
};
//-----------------------------------------------------------------------------

void TMain::LoadPos(void)
{
	RECT rc;

	rc.left= GetPrivateProfileInt("Steuerprogramm", "xo", 500, GetCFile());
	rc.top= GetPrivateProfileInt("Steuerprogramm", "yo", 400, GetCFile());
	rc.right= GetPrivateProfileInt("Steuerprogramm", "x1", 670, GetCFile());
	rc.bottom= GetPrivateProfileInt("Steuerprogramm", "y1", 450, GetCFile());
	SetWindowPos(GetFrameHandle(), NULL, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, SWP_NOZORDER);
};
//-----------------------------------------------------------------------------

void TMain::SavePos(void)
{
	char buf[MaxString];
	RECT rc;

	GetWindowRect(GetFrameHandle(), &rc);
	sprintf(buf, "%ld", min(max(0l, (long)rc.left), 900l));
	WritePrivateProfileString("Steuerprogramm", "xo", buf, GetCFile());
	sprintf(buf, "%ld", min(max(0l, (long)rc.top), 600l));
	WritePrivateProfileString("Steuerprogramm", "yo", buf, GetCFile());
	sprintf(buf, "%ld", min(max((long)rc.left + 100l, (long)rc.right), 1000l));
	WritePrivateProfileString("Steuerprogramm", "x1", buf, GetCFile());
	sprintf(buf, "%ld", min(max((long)rc.top + 70l, (long)rc.bottom), 750l));
	WritePrivateProfileString("Steuerprogramm", "y1", buf, GetCFile());
};
//-----------------------------------------------------------------------------

// ANFANG: neu Kullmann+Reinecker (31.01.2004) anderen Klassen gestatten auf Ereignisse zur reagieren
bool TMain::AddToEventList(IMainEvents *toAdd)
{ // zur Liste hinzufgen	
	return m_EventHandler.Append(toAdd);
}
//-----------------------------------------------------------------------------

bool TMain::RemoveFromEventList(IMainEvents *toRemove)
{ // aus der Liste entfernen	
	return ( m_EventHandler.RemoveData(toRemove)!=0 );
}
//-----------------------------------------------------------------------------
// ENDE: neu Kullmann+Reinecker (31.01.2004)

void TMain::OnSize(HWND hWindow)
{
	RECT rect, stat_rect;
	LONG stat_heigth;

	GetClientRect(hWindow, &rect);
	GetWindowRect(hwndStatusBar, &stat_rect);
	stat_heigth= stat_rect.bottom - stat_rect.top; 
	MoveWindow(GetClientHandle(), 0, 0, rect.right, rect.bottom - stat_heigth, 1);
	SendMessage(hwndStatusBar, WM_SIZE, 0, 0);
};
//-----------------------------------------------------------------------------

void TMain::OnPaint(HWND hWindow)
{
	if (bShutdown)
		return;

	BlastStatusLine(hWindow, 0);
	SetWatchIndicator(3);
	SendMessage(hwndStatusBar, WM_PAINT, 0, 0);
};
//-----------------------------------------------------------------------------

void TMain::OnMenuInit( void ) 
{ // wird nach dem ffnen, aber vor dem Anzeigen des Hauptmens aufgerufen
	BOOL bNew= FALSE, bOpen= FALSE, bSave= FALSE, bScanning= FALSE, bShowPsdContinuous= FALSE, bInterrupted= FALSE;
	HWND hwnd= (HWND)SendMessage(GetClientHandle(), WM_MDIGETACTIVE, 0, 0l);
	// Ermitteln des des Fenster-Struktur-Zeigers
	TMDIWindow *window= (TMDIWindow *)GetWindowLong(hwnd, 1);
	if ( window && hwnd) {
      bNew= window->CanNew();
	  bOpen= window->CanOpenFile();
	  bSave= window->CanSave();
	  bScanning= window->IsScanning(bShowPsdContinuous);
	  bInterrupted= window->IsInterrupted();
	}
	EnableMenuItem(hTheMenu, cm_New, (bNew) ? MF_ENABLED : MF_GRAYED);
	EnableMenuItem(hTheMenu, cm_Open, (bOpen) ? MF_ENABLED : MF_GRAYED);
	EnableMenuItem(hTheMenu, cm_Save, (bSave) ? MF_ENABLED : MF_GRAYED);
	EnableMenuItem(hTheMenu, cm_SaveAs, (bSave) ? MF_ENABLED : MF_GRAYED);
	// Beschriftung von Menpunkt cm_InterruptAction aktualisieren
	if ( bShowPsdContinuous )
		ModifyMenu( hTheMenu, cm_InterruptAction, MF_BYCOMMAND, cm_InterruptAction, strMessage4);
	else if ( bScanning && bInterrupted )
		ModifyMenu( hTheMenu, cm_InterruptAction, MF_BYCOMMAND, cm_InterruptAction, strMessage04);
	else if ( bScanning && !bInterrupted )
		ModifyMenu( hTheMenu, cm_InterruptAction, MF_BYCOMMAND, cm_InterruptAction, strMessage05);
	else 
		ModifyMenu( hTheMenu, cm_InterruptAction, MF_BYCOMMAND, cm_InterruptAction, strMessage5);
	EnableMenuItem(hTheMenu, cm_InterruptAction, (Steering.IsActive() || bScanning || bShowPsdContinuous) ? MF_ENABLED : MF_GRAYED);
	DrawMenuBar(GetFrameHandle());
}
//-----------------------------------------------------------------------------

void TMain::OnMenuSelect(HWND hWindow, WPARAM wParam, LPARAM lParam)
{ // Beschreibung fr Menpunkte in der Statuszeile anzeigen, wenn ein Menpunkt ausgewhlt wird
	char *MsgString= 0;
	UINT menuResId= GET_WM_COMMAND_ID(wParam, lParam);
	if ( menuResId!=NULL && menuResId>20/*Summe der Hauptmens und Mens mit Untermens*/ && menuResId!=0xFFFFFFFF ) {
		int actLen= 50;
		while (1) {	
			MsgString= new char[actLen+1];
			int len= ::LoadString( GetMainInstance(), menuResId, MsgString, actLen );
			if ( len>=actLen-1 && actLen<512 ) { // in jedem Durchlauf 10 Zeichen mehr Platz gewhren
				_FREELIST(MsgString);
				actLen+= 10; 
				continue;
			}
			if ( !len ) { // Eintrag ist nicht vorhanden
				_FREELIST(MsgString);
				const char prae[]= "RESID-FEHLER!!! Fr RessourcenId %d ist kein StringTable-Eintrag verfgbar.";
				char *buf= new char[ strlen(prae)+_MAXLENDOUBLE+1 ];
				sprintf(buf, prae, menuResId);	
				TraceErr(buf);
				_FREEOBJ(buf);

				MsgString= new char[ 1+1 ]; // Leerzeichen + Nullterminierung
				strcpy(MsgString, " ");
			}
			break;
		}
	} else { // fr Separator, Mens mit Untermens und Verlassen des Mens
		MsgString= new char[ 1+1 ]; // Leerzeichen + Nullterminierung
		strcpy(MsgString, " ");
	}
	if ( !MsgString ) return;
	ATOM hAtom= GlobalAddAtom( (LPSTR)MsgString );
	_FREELIST(MsgString);
	if (hAtom)
		PostMessage(hWindow, GetDrawMsg(), 4, (LPARAM)hAtom);
};
//-----------------------------------------------------------------------------

void TMain::SetWatchIndicator(long st)
{
	char chr[2];

	chr[0]= 0;
	chr[1]= 0;
	switch (st % 4)
	{
			case 0:
				chr[0]= '\\';
				break;

			case 1:
				chr[0]= '|';
				break;

			case 2:
				chr[0]= '/';
				break;

			case 3:
				chr[0]= '-';
				break;
	}

	SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM) 1  , (LPARAM) chr);
										// 1 basierter index der "unterkstchen"
};
//-----------------------------------------------------------------------------

/*BOOL TMain::GetDataDlg(LPSTR text, int *val)
{
	int dref;
	TModalDlg *dlg= 0;

	dref= *val;
	dlg= new TGetDataDlg(text, &dref);
	if ( dlg ) dlg->ExecuteDialog(GetFrameHandle());
	*val= dref;
	_FREEOBJ(dlg);
	return TRUE;
};*/

void TMain::BlastStatusLine(HWND hWindow, int StatusId)
{
	char buf[MaxString], buf2[20];
	switch (StatusId)
	{
		case 0:   // Alles Neuzeichnen nach Paint			
			//StatusInfo an TextStart= id 5
			SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM) 5, (LPARAM) StatusInfo);
			
			//buf an TargetStart =id 2
			sprintf(buf, "%s", MeasurementParameter.GetTarget());
			SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM) 2  , (LPARAM) buf);
			
			
			//buf an ReflectionStart= id 3
			MeasurementParameter.GetReflection(buf2);
			sprintf(buf, "%s", buf2);
			SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM) 3  , (LPARAM) buf);
			
			//an FlagStart= id 4
			strcpy(buf, Main.AdditionalInfo); 
			SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM) 4  , (LPARAM) buf);
			break;

		case DRAWSTATUS0:   // Ausgabe der aktuellen Probe und des untersuchten Reflex	
			sprintf(buf, "%s", MeasurementParameter.GetTarget());
			SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM) 2  , (LPARAM) buf);
			//buf an TargetStart =id 2
			//----
			MeasurementParameter.GetReflection(buf2);
			sprintf(buf, "%s", buf2);
			SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM) 3  , (LPARAM) buf);
			//buf an ReflectionStart= id 3
			break;

		case DRAWSTATUS1:   // Ausgabe der Zustands-Information			
			strcpy(buf, Main.AdditionalInfo); //an FlagStart= id 4
			SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM) 4  , (LPARAM) buf);
			break;

		case DRAWSTATUS2:
		case 4:		 // Ausgabe der Status-Information
			SendMessage(hwndStatusBar, SB_SETTEXT, (WPARAM) 5  , (LPARAM) StatusInfo);
			//StatusInfo an TextStart= id 5
			break;
	}
};
//-----------------------------------------------------------------------------

void TMain::DrawStatus(HWND hWindow, ATOM hAtom, int InfoId)
{
	if (bShutdown)
		return;

	switch (InfoId)
	{
		case 0:
			strcpy(StatusInfo, "");
			break;

		case DRAWSTATUS1:
			if (!hAtom)
				break;
			GlobalGetAtomName(hAtom, (LPSTR)AdditionalInfo, MaxString);
			GlobalDeleteAtom(hAtom);
			break;

		case DRAWSTATUS2:
		case 4:
			if (!hAtom)
				break;
			GlobalGetAtomName(hAtom, (LPSTR)StatusInfo, MaxString);
			GlobalDeleteAtom(hAtom);
			break;
	}
	BlastStatusLine(hWindow, InfoId);
};
//-----------------------------------------------------------------------------

LRESULT TMain::OnCommand(HWND hwnd, WPARAM wParam, LPARAM lParam)
{
	TModalDlg *dlg= 0;

	switch (GET_WM_COMMAND_ID(wParam, lParam))
	{
		case cm_Exit:
			// Iterate through all child windows.  If still can close then
			FORWARD_WM_DESTROY(hwnd, PostMessage);
			return TRUE;

		case cm_PosControl:
			mlPositionControlDlg();
			return TRUE;

		case cm_Calibrate:
			mlInquireReferencePointDlg(0);
			return TRUE;

		case cm_CallExecuteMacro:
			if ( !MacroExtention )
				return TRUE;

			//! neu Kullmann+Reinecker: TheModeless ersetzt durch MacroExecDlg; extern entfernt
			if ( (!MacroExecDlg) || (!MacroExecDlg->GetHandle()) )
			{ // !GetHandle() ist wichtig fr den Fall, dass sich das Dialogfenster selbst zerstrt hat !!!
				MacroExecDlg= new TMacroExecuteDlg(&MacroExecDlg);
				if ( MacroExecDlg ) MacroExecDlg->Initialize( GetMainInstance(), GetFrameHandle() );
			}
			else
			{ // sonst verbergen
				_FREEOBJ(MacroExecDlg);
			}
			return TRUE;

		case cm_CallExecuteCounter:
			(new TCounterWindow(GetMainInstance()))->Show(); 
			return TRUE;

		//! neu: klier Allgemeine Einstellungen
		case cm_MeasurementParameterDlg:
			dlg= new TMeasurementParameterDlg("MeasurementParameterDlg");
			if ( dlg ) dlg->ExecuteDialog(hwnd);
			_FREEOBJ(dlg);
			SetInfo("");
			return TRUE;

		//! neu: klier Protokollbuch
		case cm_ProtocolTopographyDlg:
			ViewProtocolTopographyDlg();
			SetInfo("");
			return TRUE;

		//! neu: klier Protokollbuch
		case cm_ProtocolDiffractometryDlg:
			ViewProtocolDiffractometryDlg();
			SetInfo("");
			return TRUE;

		case cm_AngleControl:
			// ANFANG 29.11.2002 Kullmann, Reinecker : getrennte Manuelle Justage
			if ( HasNewManJustage() )
				dlg= new TAngleCtlDlg(); // Funktionalitt und Oberflche getrennt
			else
				dlg= new TAngleControlDlg(); //ALT
			// ENDE 29.11.2002
			if ( dlg ) dlg->ExecuteDialog(hwnd);
			_FREEOBJ(dlg);
			return TRUE;

		// ANFANG 29.11.2002 Kullmann, Reinecker : neue Manuelle Justage
		case cm_ManualJustage:
			dlg= new TManJustageDlg;
			if ( dlg ) dlg->ExecuteDialog(hwnd);
			_FREEOBJ(dlg);
			return TRUE;
		// ENDE 29.11.2002


		//! neu: Automatische Justage (S.Freund, D.Hepp)
		case cm_AutomaticAngleControl:
			dlg= (TAutomaticAngleControlDlg *)new TAutomaticAngleControlDlg();
			if ( dlg ) dlg->ExecuteDialog(hwnd);
			_FREEOBJ(dlg);
			return TRUE;

		case cm_SetWatchIndicator:
			SetWatchIndicator(lParam);
			return TRUE;

		case cm_LimitHitOccure:
			char buf[MaxString];

			sprintf(buf, strMessage08, (int)lParam);
			MessageBox(hwnd, buf, strMessage09, MBINFO);
			return TRUE;

		// ANFANG 23.01.2003 Kullmann, Reinecker : die alte und neue getrennte Topografie
		case cm_TopograpyParam:
			dlg= new TTopographySetParamDlg(FALSE); // die ALTE
			if ( dlg ) dlg->ExecuteDialog(hwnd);
			_FREEOBJ(dlg);
			return TRUE;

		case cm_TopographyAdjust:
			dlg= new TTopographyAdjustDlg(FALSE); // die NEUE : Funktionalitt und Oberflche getrennt
			if ( dlg ) dlg->ExecuteDialog(hwnd);
			_FREEOBJ(dlg);
			return TRUE;
		// ENDE 23.01.2003

		case cm_MotorParam:
			mlSetParametersDlg();
			return TRUE;

		case cm_SensorParam:
			TDetectorGUI::RunCommonDevParamDialog(hwnd);
			return TRUE;

		case cm_OptimizeDC:
			// operates the actual motor
			mlOptimizingDlg();
			return TRUE;

		case cm_SetAngleDefault:
			mlSetAngleDefault();
			return TRUE;

		//! neu: Ausgabe der verwendeten Compiler-Version und des Compile-Datums
		case cm_Version:
		{
			char buf[MaxString];
#ifdef GermanVersion
				sprintf(buf, "Microsoft Visual C++ Compiler Version %x\n"
						"\nerstellt am: %s um %s Uhr",
						_MSC_VER, __DATE__, __TIME__);

				MessageBox(GetFocus(), buf, "Info ber erstellte Version", MBINFO);
#else
				sprintf(buf, "Microsoft Visual C++ Compiler Version %x\n"
						"\nbuild date: %s, %s",
						_MSC_VER, __DATE__, __TIME__);
				MessageBox(GetFocus(), buf, "Version built Info", MBINFO);
#endif
			return TRUE;
		}			

		case cm_About:
			AboutTheMaker();
			return TRUE;

		case cm_AllVersions:
			ShowProgramStatus(hwnd);
			return TRUE;

		case cm_Directories:
			dlg= new TModalDlg("Directories", GetMainInstance());
			if ( dlg ) dlg->ExecuteDialog(hwnd);
			_FREEOBJ(dlg);
			return TRUE;

		// ANFANG 23.01.2003 Kullmann, Reinecker : die alte und neue getrennte Topografie
		case cm_CallExecuteTopograpy:
			dlg= new TTopographyExecuteDlg(); // die ALTE
			if ( dlg ) dlg->ExecuteDialog(hwnd);
			_FREEOBJ(dlg);
			return TRUE;

		case cm_CallTopographyExec:
			dlg= new TTopographyExecDlg(); // die NEUE : Funktionalitt und Oberflche getrennt
			if ( dlg ) dlg->ExecuteDialog(hwnd);
			_FREEOBJ(dlg);
			return TRUE;
		// ENDE 23.01.2003

		case cm_CallExecuteCmd:
			dlg= (TExecuteCmdDlg*)new TExecuteCmdDlg();
			if ( dlg ) dlg->ExecuteDialog(hwnd);
			_FREEOBJ(dlg);
			return TRUE;

		case cm_CallExecuteScan:
			if (ScanExtention)
				if ( ScanWindow ) ScanWindow->Show(); // in den Vordergrund und markieren
				else (new TScanWindow(GetMainInstance()))->Show(); // bei TScanWindow.Create() wird auch ScanWindow auf dieses Fenster gesetzt
			return TRUE;

		case cm_CallExecuteAreaScan:
			if (AreaScanExtention)
				if ( AreaScanWindow ) AreaScanWindow->Show(); // in den Vordergrund und markieren
				else (new TAreaScanWindow(GetMainInstance()))->Show(); // bei TAreaScanWindow.Create() wird auch Main.AreaScanWindow auf dieses Fenster gesetzt
			return TRUE;

		case cm_Tile:
			SendMessage(GetClientHandle(), WM_MDITILE, 0, 0L);
			return TRUE;

		case cm_Cascade:
			SendMessage(GetClientHandle(), WM_MDICASCADE, 0, 0L);
			return TRUE;

		case cm_ArrangeIcons:
			SendMessage(GetClientHandle(), WM_MDIICONARRANGE, 0, 0L);
			return TRUE;

		case cm_H_Index:
			WinHelp(hwnd, GetHelpFile(), HELP_CONTEXT, Help_Contents);
			break;

		default:
			HWND hChildWnd= (HWND)(SendMessage(GetClientHandle(), WM_MDIGETACTIVE, 0, NULL));
			if (IsWindow(hChildWnd))
				SendMessage(hChildWnd, WM_COMMAND, wParam, lParam);
			break;
	}
	return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
// STATIC
///////////////////////////////////////////////////////////////////////////////

int TMain::MessageLoop(void)
{
	MSG msg;
	//!   BOOL  fQuit= FALSE;

	while (GetMessage(&msg, NULL, 0, 0))
	{		
		if ( !TranslateMDISysAccel(GetClientHandle(), &msg) &&
			!TranslateAccelerator(GetFrameHandle(), TMain::hAccellerator, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return 0;
};
//-----------------------------------------------------------------------------

	void DrawTransparentBitmap(HDC hdc, HBITMAP hBitmap, short xStart,
							   short yStart)
	{
	   BITMAP     bm;
	   COLORREF   cColor;
	   HBITMAP    bmAndBack, bmAndObject, bmAndMem, bmSave;
	   HBITMAP    bmBackOld, bmObjectOld, bmMemOld, bmSaveOld;
	   HDC        hdcMem, hdcBack, hdcObject, hdcTemp, hdcSave;
	   POINT      ptSize;

	   hdcTemp = CreateCompatibleDC(hdc);
	   SelectObject(hdcTemp, hBitmap);   // Select the bitmap

	   GetObject(hBitmap, sizeof(BITMAP), (LPSTR)&bm);
	   ptSize.x = bm.bmWidth;            // Get width of bitmap
	   ptSize.y = bm.bmHeight;           // Get height of bitmap
	   DPtoLP(hdcTemp, &ptSize, 1);      // Convert from device

										 // to logical points

	   // choose this color as transparent, that is most often in the corners
	   COLORREF corners[4];
	   corners[0]= GetPixel(hdcTemp, 0, 0);
	   corners[1]= GetPixel(hdcTemp, bm.bmWidth-1, 0);
	   corners[2]= GetPixel(hdcTemp, bm.bmWidth-1, bm.bmHeight-1);
	   corners[3]= GetPixel(hdcTemp, 0, bm.bmHeight-1);
	   COLORREF cTransparentColor= corners[0];
	   int bestCount= 0;
	   for (int i=0; i<4; i++) {
		   int iCount= 0;
		   for (int j=0; j<4; j++) if ( corners[i]==corners[j] ) iCount++;
		   if ( iCount>bestCount ) {
			   bestCount= iCount;
			   cTransparentColor= corners[i];
		   }
	   }

	   // Create some DCs to hold temporary data.
	   hdcBack   = CreateCompatibleDC(hdc);
	   hdcObject = CreateCompatibleDC(hdc);
	   hdcMem    = CreateCompatibleDC(hdc);
	   hdcSave   = CreateCompatibleDC(hdc);

	   // Create a bitmap for each DC. DCs are required for a number of
	   // GDI functions.

	   // Monochrome DC
	   bmAndBack   = CreateBitmap(ptSize.x, ptSize.y, 1, 1, NULL);

	   // Monochrome DC
	   bmAndObject = CreateBitmap(ptSize.x, ptSize.y, 1, 1, NULL);

	   bmAndMem    = CreateCompatibleBitmap(hdc, ptSize.x, ptSize.y);
	   bmSave      = CreateCompatibleBitmap(hdc, ptSize.x, ptSize.y);

	   // Each DC must select a bitmap object to store pixel data.
	   bmBackOld   = (HBITMAP)SelectObject(hdcBack, bmAndBack);
	   bmObjectOld = (HBITMAP)SelectObject(hdcObject, bmAndObject);
	   bmMemOld    = (HBITMAP)SelectObject(hdcMem, bmAndMem);
	   bmSaveOld   = (HBITMAP)SelectObject(hdcSave, bmSave);

	   // Set proper mapping mode.
	   SetMapMode(hdcTemp, GetMapMode(hdc));

	   // Save the bitmap sent here, because it will be overwritten.
	   BitBlt(hdcSave, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0, SRCCOPY);

	   // Set the background color of the source DC to the color.
	   // contained in the parts of the bitmap that should be transparent
	   cColor = SetBkColor(hdcTemp, cTransparentColor);

	   // Create the object mask for the bitmap by performing a BitBlt
	   // from the source bitmap to a monochrome bitmap.
	   BitBlt(hdcObject, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0,
			  SRCCOPY);

	   // Set the background color of the source DC back to the original
	   // color.
	   SetBkColor(hdcTemp, cColor);

	   // Create the inverse of the object mask.
	   BitBlt(hdcBack, 0, 0, ptSize.x, ptSize.y, hdcObject, 0, 0,
			  NOTSRCCOPY);

	   // Copy the background of the main DC to the destination.
	   BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y, hdc, xStart, yStart,
			  SRCCOPY);

	   // Mask out the places where the bitmap will be placed.
	   BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y, hdcObject, 0, 0, SRCAND);

	   // Mask out the transparent colored pixels on the bitmap.
	   BitBlt(hdcTemp, 0, 0, ptSize.x, ptSize.y, hdcBack, 0, 0, SRCAND);

	   // XOR the bitmap with the background on the destination DC.
	   BitBlt(hdcMem, 0, 0, ptSize.x, ptSize.y, hdcTemp, 0, 0, SRCPAINT);

	   // Copy the destination to the screen.
	   BitBlt(hdc, xStart, yStart, ptSize.x, ptSize.y, hdcMem, 0, 0,
			  SRCCOPY);

	   // Place the original bitmap back into the bitmap sent here.
	   BitBlt(hdcTemp, 0, 0, ptSize.x, ptSize.y, hdcSave, 0, 0, SRCCOPY);

	   // Delete the memory bitmaps.
	   DeleteObject(SelectObject(hdcBack, bmBackOld));
	   DeleteObject(SelectObject(hdcObject, bmObjectOld));
	   DeleteObject(SelectObject(hdcMem, bmMemOld));
	   DeleteObject(SelectObject(hdcSave, bmSaveOld));

	   // Delete the memory DCs.
	   DeleteDC(hdcMem);
	   DeleteDC(hdcBack);
	   DeleteDC(hdcObject);
	   DeleteDC(hdcSave);
	   DeleteDC(hdcTemp);
	}

LRESULT CALLBACK TMain::EventHandlerMdiClient(HWND hWindow, UINT message, WPARAM wParam, LPARAM lParam) {
	switch ( message ) {
		case WM_ERASEBKGND:
			return 00;

		case WM_PAINT:
			// DoubleBuffered-Ausgabe vorbereiten
			RECT rect;
			PAINTSTRUCT ps;
			GetClientRect(hWindow, (LPRECT)&rect);
			HDC hdc= BeginPaint(hWindow, &ps);
			HBITMAP hMemBmp= CreateCompatibleBitmap(hdc, rect.right-rect.left, rect.bottom-rect.top);
			HDC hMemDC= CreateCompatibleDC(hdc);	
			HGDIOBJ hOldMemBmp= SelectObject(hMemDC, hMemBmp);			

			// Hintergrund flchig ausfllen
			BITMAP bmInfo;
			HBITMAP hBitmap= LoadBitmap( GetMainInstance(), MAKEINTRESOURCE(bmp_Background) );
			GetObject(hBitmap, sizeof(bmInfo), &bmInfo);
			HDC hBmpDC= CreateCompatibleDC(hdc);
			HGDIOBJ hOldBitmap= SelectObject(hBmpDC, hBitmap);
			for (int y= 0; y<rect.bottom-rect.top+bmInfo.bmHeight; y+= bmInfo.bmHeight)
				for (int x= 0; x<rect.right-rect.left+bmInfo.bmWidth; x+= bmInfo.bmWidth)
					BitBlt(hMemDC, x, y, bmInfo.bmWidth, bmInfo.bmHeight,
						   hBmpDC, 0, 0, SRCCOPY);
			SelectObject(hBmpDC, hOldBitmap);
			DeleteObject(hBitmap);
			DeleteDC(hBmpDC);

			// zentriert und transparent eine Bitmap
			hBitmap= LoadBitmap( GetMainInstance(), MAKEINTRESOURCE(bmp_CenterBack) );
			GetObject(hBitmap, sizeof(bmInfo), &bmInfo);
			DrawTransparentBitmap(hMemDC, hBitmap, (rect.right-rect.left)/2 - bmInfo.bmWidth/2, (rect.bottom-rect.top)/2 - bmInfo.bmHeight/2);
			DeleteObject(hBitmap);

			// Trennungslinie zum Menu
			HPEN hPen= CreatePen( PS_SOLID, 1, RGB(0,0,0) );
			HGDIOBJ hOldPen= SelectObject(hMemDC, hPen);
			POINT p;
			MoveToEx(hMemDC, 0, 0, &p);
			LineTo(hMemDC, rect.right-rect.left, 0);
			SelectObject(hMemDC, hOldPen);
			DeleteObject(hPen);

			// auf den Bildschirm und aufrumen
			BitBlt(hdc, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top,
				   hMemDC, 0, 0, SRCCOPY);
			SelectObject(hMemDC, hOldMemBmp);
			DeleteObject(hMemBmp);
			DeleteDC(hMemDC);
			EndPaint(hWindow, &ps);
			return 01;
	}
	return CallWindowProc(Main.DefMdiClientProc, hWindow, message, wParam, lParam);
}
//-----------------------------------------------------------------------------

LRESULT CALLBACK TMain::EventHandler(HWND hWindow, UINT message, WPARAM wParam, LPARAM lParam)
{
	// main window handler, called first
	TDetector *detector= 0;
	int nDetector;
	HWND hwnd;
	TMDIWindow *window;

	switch (message)
	{
		case WM_TIMER:
			nDetector= GET_WM_COMMAND_ID(wParam, lParam) - DetectorTimerIdStart;
			if (TDetectorManager::DetectorManager().IsValidId(nDetector))
			{
				detector= TDetectorManager::DetectorManager().GetDetector(nDetector);
				if (detector->PollDetector() == R_Failure)
				{
					detector->MeasureStop();
					SetStatus(strMessage07);
					MessageBeep(0);
					detector->MeasureStart();
				}
			}
			break;

		case WM_SIZE:
			Main.OnSize(hWindow);
			// immediately return, otherhand case no write of status line.
			return 0l;

		case WM_PAINT:
			Main.OnPaint(hWindow);
			break;

		case WM_COMMAND:
			Main.OnCommand(hWindow, wParam, lParam);
			break;

		case WM_SYSCOMMAND:
			if (wParam == SC_CLOSE)
			{
				do
				{ // Es sind eventuell Daten noch nicht gespeichert worden
					hwnd= (HWND)SendMessage(GetClientHandle(), WM_MDIGETACTIVE, 0, 0l);
					// Ermitteln des des Fenster-Strucktur-Zeigers
					window= (TMDIWindow *)GetWindowLong(hwnd, 1);
					if ( window && hwnd)
					{
						if (window->CanClose())
						{
							SendMessage(GetClientHandle(), WM_MDIDESTROY, (WPARAM)(HWND)hwnd, 0l);
							continue;
						}
						else
						{
							bShutdown= FALSE;
							return 1l;
						}
					}
					break;
				} while (1);
				bShutdown= TRUE;
				PostMessage(GetFrameHandle(), WM_DESTROY, 0, 0l);
				return 1;
			} //if
			break;

		case WM_DESTROY:
			bShutdown= TRUE;
			do
			{
				hwnd= (HWND)SendMessage(GetClientHandle(), WM_MDIGETACTIVE, 0, 0l);
				// Ermitteln des des Fenster-Struktur-Zeigers
				window= (TMDIWindow *)GetWindowLong(hwnd, 1);
				if ( window && hwnd)
				{
					if (window->CanClose())
						SendMessage(GetClientHandle(), WM_MDIDESTROY, (WPARAM)(HWND)hwnd, 0l);
					continue;
				}
				break;
			} while (1);

			if (bEnvInstalled)
			{
				/* 16.06.2004 if (Main.bmpStatusLine)
				{
					DeleteObject(Main.bmpStatusLine);
					Main.bmpStatusLine= 0;
				}*/
				//! Ctl3dUnregister((const HINSTANCE__ near*)GetFrameHandle());
				mlSaveModuleSettings();
				bEnvInstalled= FALSE;
			}
			Main.SavePos();
			PostQuitMessage(0);
			return 0l;

		case WM_INITMENU:
			Main.OnMenuInit();
			break;

		case WM_MENUSELECT:
			Main.OnMenuSelect(hWindow, wParam, lParam);
			break;

		default:
			// die folgenden Varianten sind keine Konstanten (deshalb nicht als case realisierbar)
			if (message == GetDrawMsg())
				Main.DrawStatus(hWindow, (ATOM)lParam, GET_WM_COMMAND_ID(wParam, lParam));
			if (message == GetWakeUpMsg())
				Steering.WakeUp();
	} // end switch
	return DefFrameProc(hWindow, Main.hwndClient, message, wParam, lParam);
};

//#############################################################################
// TMDIWindow
//#############################################################################

int TMDIWindow::s_WindowCount= 0;

TMDIWindow::TMDIWindow(HINSTANCE aInstance) : TBasicMDIWindow( aInstance ), hHoleMenu(0), TheMenu(0)
{
	bUserPaint= false;
	s_WindowCount++;
	bInterrupted= FALSE;
	bPaintPoint= FALSE;	
};
//-----------------------------------------------------------------------------

TMDIWindow::~TMDIWindow()
{
	s_WindowCount--;
	if (hHoleMenu) {
		DestroyMenu(hHoleMenu);
		hHoleMenu= 0;
		TheMenu= 0; // ist Untermen von hHoleMenu
	}
	if (TheMenu) {
		DestroyMenu(TheMenu);
		TheMenu= 0;
	}
};
//-----------------------------------------------------------------------------

LRESULT TMDIWindow::Show( void )
{
	if ( !strcmp(m_Title, "") )
		strcpy(m_Title, ClassName());
	return TBasicMDIWindow::Show( GetClientHandle() ); 
};
//-----------------------------------------------------------------------------

BOOL TMDIWindow::CanOpen(void)
{
	return ( s_WindowCount <= 5 );
};
//-----------------------------------------------------------------------------

BOOL TMDIWindow::CanClose(void)
{
	BOOL temp= FALSE;
	if ( IsScanning(temp) && !bInterrupted)
		Interrupt();
	return TRUE;
};
//-----------------------------------------------------------------------------

HICON TMDIWindow::GetIcon ( void ) const
{
    return (HICON)LoadImage( GetMainInstance(), MAKEINTRESOURCE(icon_MdiWindow),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
};
//-----------------------------------------------------------------------------

void TMDIWindow::UpdateWnd(EPaintType act)
{
	bUserPaint= true;
	switch (act)
	{
		case ptPaintPoint:
			bPaintPoint= TRUE;
			SetTitle();
			InvalidateRect(GetHandle(), NULL, !bPaintPoint);
			break;

		case ptFlush: {
				PAINTSTRUCT ps;
				HDC hdc= BeginPaint(GetHandle(), &ps);
				DoPaint(hdc, &ps);
				EndPaint(GetHandle(), &ps);
			break;
		}

		default: // ptEntire
			SetTitle();
			InvalidateRect(GetHandle(), NULL, !bPaintPoint);
	}
};
//-----------------------------------------------------------------------------

BOOL TMDIWindow::WholeWnd(void)
{
	int b= bPaintPoint;
	bPaintPoint= FALSE;
	return !b;
};
//-----------------------------------------------------------------------------

void TMDIWindow::OnRButtonDown ( WPARAM, LPARAM lParam) 
{
	if ( !TheMenu ) return;

	Show(); // zuerst Fenster fokussieren
	//! darstellen des Menues an der Mausposition
	POINT pp;
	pp.x= LOWORD( lParam );
	pp.y= HIWORD( lParam );
	ClientToScreen( GetHandle(), &pp );
	TrackPopupMenu( TheMenu, 0, pp.x, pp.y, 0, GetHandle(), NULL );	
}; 
//-----------------------------------------------------------------------------

void TMDIWindow::OnMenuSelect ( WPARAM wParam, LPARAM ) 
{ // Beschreibung fr Menpunkte in der Statuszeile anzeigen, wenn ein Menpunkt ausgewhlt wird
	char *MsgString= 0;
	UINT menuResId= GET_WM_COMMAND_ID(wParam, lParam);
	if ( menuResId!=NULL && menuResId>10/*Summe der Hauptmens und Mens mit Untermens*/ && menuResId!=0xFFFFFFFF ) 
		MsgString= LoadString(menuResId);

	if ( !MsgString || strlen(MsgString)==0 ) {
		if ( MsgString ) _FREELIST(MsgString);
		MsgString= new char[1+1]; // Leerzeichen + Nullterminierung
		strcpy(MsgString, " "); // Leerstring wrde keine nderung in Statuszeile zur Folge haben
	}
	ATOM hAtom= GlobalAddAtom( (LPSTR)MsgString );
	_FREELIST(MsgString);
	if (hAtom)
		PostMessage(GetFrameHandle(), GetDrawMsg(), 4, (LPARAM)hAtom);
};
//-----------------------------------------------------------------------------

void TMDIWindow::Interrupt()
{
	BOOL temp= FALSE;
	if ( !IsScanning(temp) ) { // vielleicht Makroverarbeitung aktiv?
		if ( Steering.IsActive() ) Steering.ToggleInterrupt();
	} else {
		bInterrupted= !bInterrupted;
	}
};

///////////////////////////////////////////////////////////////////////////////
// Botschaften
///////////////////////////////////////////////////////////////////////////////

void TMDIWindow::OnTimer ( WPARAM wParam, LPARAM lParam )
{
	if ( GET_WM_COMMAND_ID(wParam, lParam) == TimerIdSteering )
		TimerRequest(GET_WM_COMMAND_ID(wParam, lParam));
}
//-----------------------------------------------------------------------------

void TMDIWindow::OnNotCreated ( void )
{
	MessageBox(strMessage02, strFailure, MBFAILURE);
}
//-----------------------------------------------------------------------------

LRESULT TMDIWindow::OnCommand(WPARAM wParam, LPARAM lParam)
{
	WPARAM Cmd;
	Cmd= GET_WM_COMMAND_ID(wParam, lParam);
	switch (Cmd)
	{
		case cm_Copy:   // alle MDI
			DoCopy();
			return 0l;

		/* Datum 16.05.2003: case cm_PSD_Scan: case cm_PSD_AreaScan: case cm_InquireCCDLine: case cm_ShowHistogram:
			InitializeTask(wParam, lParam);
			return 0l;*/

		/* Datum 16.05.2003: case cm_SetupCCDLineScan: case cm_ImageSaveOptions:
			InitializeDlg(wParam, lParam);
			return 0l;*/

		case cm_InterruptAction: // Makroverarbeitung oder Area-/ StepScan beenden/ fortsetzen
			MessageBeep(0);
			Interrupt();
			return 0l;

		case cm_StopAll:   // alle MDI
			int id;
			id= 0;
			while (mlSetAxis(id++))
				mStopDrive(0);
			MessageBox("Trial to stop all drives !", "Message", MBINFO);
			return 0l;

		/* 16.05.2003 case cm_GrabPicture:   // Dialogfenster CCDParameter
			return 0l;*/

		//Datum 16.05.2003: case cm_GetHistogram: case cm_AccuPicture: case cm_EventCounting: return 0l;

		case cm_SensorParam:
			// TDetectorGUI::RunCommonDevParamDialog(GetHandle()); fhrte zum Absturz, wenn das Fenster geschlossen wurde.
			// Dort wurde das TCounterWindow freigegeben, diese Objektmethode (OnCommand) existiert dann nicht mehr! --> Prozessorfehler!
			// Deshalb POSTMessage (zeitversetzt verarbeiten) zum Hauptfenster und dort verarbeiten lassen (dort war die Behandlung bereits fr den gleichnamigen Meneintrag impl.).
			PostMessage(GetFrameHandle(), WM_COMMAND, (WPARAM)cm_SensorParam, 0);
			return TRUE;

		//*** Ablauf-Steuerung *************************
		case cm_SteeringReady:
			SteeringReady(lParam);
			return 0l;

		case cm_SteeringReset:
			SteeringReset(lParam);
			return 01;

		//Datum 05.06.2004
		/*case cm_DistanceSet:
			DistanceSetRequest(lParam);
			return 0l;*/

		// *** Detektor
		case cm_CounterSet:
			CounterSetRequest(lParam);
			return 0l;

		//Datum 16.05.2003
		/*case cm_PlotCurve:
			PickUpData(lParam);
			SendMessage(GetHandle(),WM_SETFOCUS,0,0l);
			return 0l;*/

		//Datum 16.05.2003
		/*case cm_SetProperties:
			  SetKSProperties((TKSProperties*)lParam);
			  return 0l;*/

		//Datum 16.05.2003
		/*case cm_SetRanges:
			  SetRanges();
			  if (lParam) UpdateWnd();
			  return 0l;*/
	}
	return 100000l;
};

//#############################################################################
// TFileWindow
//#############################################################################

TFileWindow::TFileWindow( HINSTANCE aInstance ) : TMDIWindow(aInstance) {
	strcpy(FileName, "*.*");
	strcpy(szFilter, "Alle Dateien (*.*)|*.*||");
	strcpy(szExtension, "*");
	strcpy(szDataPath, "");
	bOldDataLoaded= FALSE;	
	bIsNewFile= TRUE;
	bFileChanged= FALSE;
}
//-----------------------------------------------------------------------------

BOOL TFileWindow::CanClose( void ) {
	if ( !TMDIWindow::CanClose() ) return FALSE;

	if ( bFileChanged ) {
		int res= MessageBox(strMessage03, strMessage, MB_YESNOCANCEL | MB_ICONQUESTION);
		if ( res==IDCANCEL ) return FALSE;
		if ( res==IDYES ) SaveFile();
		if ( res==IDNO ) bFileChanged= FALSE; // nicht erneut fragen, ob gespeichert werden 
	}
	return TRUE;
}
//-----------------------------------------------------------------------------

BOOL TFileWindow::New(void)
{
	bFileChanged= FALSE;
	bInterrupted= FALSE;
	bPaintPoint= FALSE;
	bOldDataLoaded= FALSE;
	UpdateWnd();
	return TRUE;
};
//-----------------------------------------------------------------------------

BOOL TFileWindow::LoadOldData() {
	bFileChanged= FALSE;
	bPaintPoint= FALSE;
	bOldDataLoaded= TRUE;
	UpdateWnd();
	return FALSE;
};
//-----------------------------------------------------------------------------

BOOL TFileWindow::SaveFile(EAskType) {
	bFileChanged= FALSE;
	return FALSE;
};
//-----------------------------------------------------------------------------

BOOL TFileWindow::SaveFileAs(void)
{
	char Old_FileName[_MAX_PATH];
	//! BOOL Old_bFileChanged= bFileChanged;
	BOOL Old_bIsNewFile= bIsNewFile;

	strcpy(Old_FileName, FileName);
	bFileChanged= TRUE;
	bIsNewFile= TRUE;
	strcpy(FileName, "");
	if ( SaveFile(atNewName) )
		return TRUE;
	strcpy(FileName, Old_FileName);
	bIsNewFile= Old_bIsNewFile;
	return FALSE;
};
//-----------------------------------------------------------------------------

BOOL TFileWindow::SetFileName(LPSTR fn)
{
	if (strstr("\\", fn))
		sprintf(FileName, "%s", fn);
	else
		sprintf(FileName, "%s%s", szDataPath, fn);
	bIsNewFile= (0 == strlen(FileName));
	return TRUE;
};
//-----------------------------------------------------------------------------

LRESULT TFileWindow::OnCommand(WPARAM wParam, LPARAM lParam)
{
	WPARAM Cmd;
	Cmd= GET_WM_COMMAND_ID(wParam, lParam);
	switch (Cmd)
	{
		case cm_New:   
			Interrupt(); // zuerst aktive Messung oder Spektrenanzeige beenden
			SetFileName("");
			New(); // Interrupt und SetFileName drfen nicht in New() verschoben werden = NUR HIER wenn Menpunkt geklickt wurde
			return 0l;

		case cm_Open:   
			Interrupt(); // zuerst aktive Messung oder Spektrenanzeige beenden
			LoadOldData(); // Interrupt darf nicht in New() verschoben werden = NUR HIER wenn Menpunkt geklickt wurde
			return 0l;

		case cm_Save:   
			SaveFile();
			return 0l;

		case cm_SaveAs:   
			SaveFileAs();
			return 0l;

		case cm_UpdateFile:
			UpdateFile();
			return 0l;

	}
	return TMDIWindow::OnCommand(wParam, lParam);
}

//******************************************************************************
// __LastLine__


