//******************************************************************************
//Datei     : mesparaw.cpp
//Projekt   : XCTL
//Subsystem : Allgemeine Einstellungen
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Implementation der Klasse TMeasurementParameterDlg
//******************************************************************************
//!neu klier Allgemeine Einstellungen

#include "utils\u_utils.h"
#include "winresrc\rc_def.h" // Ressourcen-IDs
#include "help\help_def.h"   // Help-IDs
#include <commdlg.h>

#include "mespara\mespara.h"
#include "mespara\mesparaw.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

extern TMeasurementParameter MeasurementParameter;

TMeasurementParameterDlg::TMeasurementParameterDlg(LPSTR Dlg) : TModalDlg(Dlg, GetMainInstance() )
{}
;


BOOL TMeasurementParameterDlg::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
	//Datum: 27.07.2002 TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);
	RefreshAll(hwnd);
	SetDlgItemText(hwnd, id_Status, "");
	return TRUE;
};

void TMeasurementParameterDlg::Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	char buf[_MAX_PATH];
	BOOL fl;

	switch (id)
	{
		case IDOK:
			GetDlgItemText(GetHandle(), id_Reflection, buf, MaxString);
			if (!MeasurementParameter.SetReflection(buf))
			{
				MessageBox("Ungltiger Wert Reflex!\n --> [yxz] x,y,z= -9..9", "Fehler", MBSTOP);
				MeasurementParameter.GetReflection(buf);
				SetDlgItemText(hwnd, id_Reflection, buf);
				SetDlgItemText(hwnd, id_Status, "Eingabe Reflex korrigieren");
				SetFocus(GetDlgItem(hwnd, id_Reflection));
				break;
			}
			GetDlgItemText(GetHandle(), id_Orientation, buf, MaxString);
			if (!MeasurementParameter.SetOrientation(buf))
			{
				MessageBox("Ungltiger Wert Orientierung!\n --> [yxz] x,y,z= -9..9", "Fehler", MBSTOP);
				MeasurementParameter.GetOrientation(buf);
				SetDlgItemText(hwnd, id_Orientation, buf);
				SetDlgItemText(hwnd, id_Status, "Eingabe Orientierung korrigieren");
				SetFocus(GetDlgItem(hwnd, id_Orientation));
				break;
			}
			GetDlgItemText(GetHandle(), id_Target, buf, MaxString);
			MeasurementParameter.SetTarget(buf);
			GetDlgItemText(GetHandle(), id_TargetBulk, buf, MaxString);
			MeasurementParameter.SetTargetBulk(buf);
			GetDlgItemText(GetHandle(), id_WaveLength, buf, MaxString);
			if (!MeasurementParameter.SetWaveLength(buf))
			{
				MessageBox("Ungltiger Wert WaveLength!", "Fehler", MBSTOP);
				MeasurementParameter.GetWaveLength(buf);
				SetDlgItemText(hwnd, id_WaveLength, buf);
				SetDlgItemText(hwnd, id_Status, "Eingabe WaveLength korrigieren");
				SetFocus(GetDlgItem(hwnd, id_WaveLength));
				break;
			}
			GetDlgItemText(GetHandle(), id_User, buf, MaxString);
			MeasurementParameter.SetUser(buf);
			if (!MeasurementParameter.SetCurrent(GetDlgItemInt(GetHandle(), id_Current, &fl, FALSE)))
			{
				MessageBox("Ungltiger Wert Current!", "Fehler", MBSTOP);
				MeasurementParameter.GetCurrent(buf);
				SetDlgItemText(hwnd, id_Current, buf);
				SetDlgItemText(hwnd, id_Status, "Eingabe Current korrigieren");
				SetFocus(GetDlgItem(hwnd, id_Current));
				break;
			}
			if (!MeasurementParameter.SetVoltage(GetDlgItemInt(GetHandle(), id_Voltage, &fl, FALSE)))
			{
				MessageBox("Ungltiger Wert Voltage!", "Fehler", MBSTOP);
				MeasurementParameter.GetVoltage(buf);
				CtrlSetText(id_Voltage, buf);
				CtrlSetText(id_Status, "Eingabe Voltage korrigieren");
				SetFocus(Ctrl(id_Voltage));
				break;
			}
			GetDlgItemText(GetHandle(), id_Comment, buf, 2*MaxString);
			MeasurementParameter.SetComment(buf);
			MeasurementParameter.Save(GetCFile());
			CtrlSetText(id_Status, "");
			SetStaticInfo("");
			// Kullmann+Reinecker: Hier muss es direkt weitergehen zu TModalDlg::Dlg_OnCommand!

		default:
			TModalDlg::Dlg_OnCommand(hwnd, id, hwndCtl, codeNotify);
	}
}

void TMeasurementParameterDlg::RefreshAll(HWND hwnd)
{
	char buf[MaxString];

	SetDlgItemText(hwnd, id_Target, MeasurementParameter.GetTarget());
	SetDlgItemText(hwnd, id_TargetBulk, MeasurementParameter.GetTargetBulk());
	SetDlgItemText(hwnd, id_WaveLength, MeasurementParameter.GetWaveLength(buf));
	SetDlgItemText(hwnd, id_User, MeasurementParameter.GetUser());
	SetDlgItemText(hwnd, id_Current, MeasurementParameter.GetCurrent(buf));
	SetDlgItemText(hwnd, id_Voltage, MeasurementParameter.GetVoltage(buf));
	SetDlgItemText(hwnd, id_Reflection, MeasurementParameter.GetReflection(buf));
	SetDlgItemText(hwnd, id_Orientation, MeasurementParameter.GetOrientation(buf));
	SetDlgItemText(hwnd, id_Comment, MeasurementParameter.GetComment());
	SetDlgItemText(hwnd, id_IniFile, GetCFile());
	SetFocus(GetDlgItem(hwnd, IDOK));
};

// LastLine

