//******************************************************************************
//Datei     : TProtocolDiffractometryDlg.cpp
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Implementation der Klasse TProtocolDiffractometryDlg
//******************************************************************************
//!neu klier Protokollbuch
#include "internls\evrythng.h"
#include "winresrc\rc_prtow.h" // Ressourcen-IDs
#include <commdlg.h>
#include <commctrl.h>

//! neu: klier Allgemeine Einstellungen
//#include "mespara\mespara.h"

#include "protocol\TProtocolLanguage.h"
#include "protocol\TProtocol.h"
#include "protocol\TProtocolDiffractometry.h"
#include "protocol\TProtocolDlg.h"
#include "protocol\TProtocolDiffractometryDlg.h"
#include "protocol\TProtocolManagePrintDlg.h"
#include "protocol\TProtocolDiffractometryManagePrintDlg.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

extern TProtocolLanguage *ProtocolLanguage;
extern TProtocolDiffractometry *ProtocolDiffractometry;
extern HINSTANCE hModuleInstance;

extern TModelessDlg *ProtoPrintDlg; //! neu Kullmann+Reinecker: TheModeless ersetzt durch ProtoPrintDlg

//!neu klier Allgemeine Einstellungen
//extern TMeasurementParameter *MeasurementParameter;


TProtocolDiffractometryDlg::TProtocolDiffractometryDlg(LPSTR Dlg, int idDlg) : TModalDlg(Dlg,hModuleInstance)
{
	Protocol= ProtocolDiffractometry;
	ProtocolCombobox.InitializeManageComboboxProtocolDlg(Protocol);
	CurrentDlg= idDlg;
};


void TProtocolDiffractometryDlg::ShowDialog( int id , int idShow)
{
	int ButtonShow;

	switch (idShow)
	{
		case SHOW:
			ShowDialog(CurrentDlg, HIDE);
			ButtonShow= HIDE;
			CurrentDlg= id;
			ProtocolDiffractometry->SetCurrentDlg(id);
			RefreshDlg(hwndDlg, CurrentDlg);
			break;

		case HIDE:
			ButtonShow= SHOW;
			break;

		default:
			return;
	}

	switch (id)
	{
		case MessungDlg:
			if (idShow==SHOW) TabCtrl_SetCurSel(hTab, 0);
			ShowDlgItem( id_GruppeMessungParameter, idShow );
			ShowDlgItem( id_SpannungText, idShow );
			ShowDlgItem( id_StromText, idShow );
			ShowDlgItem( id_WellenlaengeText, idShow );
			ShowDlgItem( id_MessdateiText, idShow );
			ShowDlgItem( id_Spannung, idShow );
			ShowDlgItem( id_SpannungEinheit, idShow );
			ShowDlgItem( id_Strom, idShow );
			ShowDlgItem( id_StromEinheit, idShow );
			ShowDlgItem( id_Wellenlaenge, idShow );
			ShowDlgItem( id_WellenlaengeEinheit, idShow );
			ShowDlgItem( id_Messdatei, idShow );
			break;

		case ScanDlg:
			if (idShow==SHOW) TabCtrl_SetCurSel(hTab, 1);
			ShowDlgItem( id_GruppeScan, idShow );
			ShowDlgItem( id_ScantypText, idShow );
			ShowDlgItem( id_ScanachseText, idShow );
			ShowDlgItem( id_SOffsetText, idShow );
			ShowDlgItem( id_MinimumText, idShow );
			ShowDlgItem( id_SchrittweiteText, idShow );
			ShowDlgItem( id_MaximumText, idShow );
			ShowDlgItem( id_Scantyp, idShow );
			ShowDlgItem( id_Scanachse, idShow );
			ShowDlgItem( id_SOffset, idShow );
			ShowDlgItem( id_Minimum, idShow );
			ShowDlgItem( id_Schrittweite, idShow );
			ShowDlgItem( id_Maximum, idShow );
			if ( AreaScan || Omega2Theta || (idShow == HIDE) )
			{
				ShowDlgItem( id_Scanachse1, idShow );
				ShowDlgItem( id_Scanachse2, idShow );
			}
			if ( Continuous || (idShow == HIDE) )
			{
				ShowDlgItem( id_GeschwindigkeitText, idShow );
				ShowDlgItem( id_Geschwindigkeit, idShow );
			}
			break;

		case BlendeAbsorberDlg:
			if (idShow==SHOW) TabCtrl_SetCurSel(hTab, 2);
			ShowDlgItem( id_GruppeBlende, idShow );
			ShowDlgItem( id_GruppeAbsorber, idShow );
			ShowDlgItem( id_BhorizontalText, idShow );
			ShowDlgItem( id_BvertikalText, idShow );
			ShowDlgItem( id_BPSText, idShow );
			ShowDlgItem( id_BPShorizontal, idShow );
			ShowDlgItem( id_BPSvertikal, idShow );
			ShowDlgItem( id_BPShorizontalEinheit, idShow );
			ShowDlgItem( id_BPSvertikalEinheit, idShow );
			ShowDlgItem( id_BDText, idShow );
			ShowDlgItem( id_BDhorizontal, idShow );
			ShowDlgItem( id_BDvertikal, idShow );
			ShowDlgItem( id_BDhorizontalEinheit, idShow );
			ShowDlgItem( id_BDvertikalEinheit, idShow );
			ShowDlgItem( id_AArtText, idShow );
			ShowDlgItem( id_AFaktorText, idShow );
			ShowDlgItem( id_AArt, idShow );
			ShowDlgItem( id_AFaktor, idShow );
			break;

		case DetektorDlg:
			if (idShow==SHOW) TabCtrl_SetCurSel(hTab, 3);
			ShowDlgItem( id_GruppeDetektor, idShow );
			ShowDlgItem( id_GruppeMonitor, idShow );
			ShowDlgItem( id_DetektorText, idShow );
			ShowDlgItem( id_MesszeitText, idShow );
			ShowDlgItem( id_MesszeitEinheit, idShow );
			ShowDlgItem( id_ImpulseText, idShow );
			ShowDlgItem( id_MonitorText, idShow );
			ShowDlgItem( id_Detektor, idShow );
			ShowDlgItem( id_Messzeit, idShow );
			ShowDlgItem( id_Impulse, idShow );
			ShowDlgItem( id_Monitor, idShow );
			if ( PSD || (idShow == HIDE) )
			{
				ShowDlgItem( id_GruppePSD, idShow );
				ShowDlgItem( id_MesskanalText, idShow );
				ShowDlgItem( id_WinkelbereichText, idShow );
				ShowDlgItem( id_WinkelbereichEinheit, idShow );
				ShowDlgItem( id_KanalabstandText, idShow );
				ShowDlgItem( id_KanalabstandEinheit, idShow );
				ShowDlgItem( id_AddiereText, idShow );
				ShowDlgItem( id_AddiereEinheit, idShow );
				ShowDlgItem( id_Messkanal, idShow );
				ShowDlgItem( id_Winkelbereich, idShow );
				ShowDlgItem( id_Kanalabstand, idShow );
				ShowDlgItem( id_Addiere, idShow );
			}
			if ( !PSD || (idShow == HIDE) )
			{
				ShowDlgItem( id_DistanzText, idShow );
				ShowDlgItem( id_Distanz, idShow );
				ShowDlgItem( id_DistanzEinheit, idShow );
			}
			break;

		case BemerkungDlg:
			if(idShow==SHOW) TabCtrl_SetCurSel(hTab, 4);
			ShowDlgItem( id_GruppeBemerkung, idShow );
			ShowDlgItem( id_BemerkungText, idShow );
			ShowDlgItem( id_Bemerkung, idShow );
			break;
	}
};

void TProtocolDiffractometryDlg::EnableAreaScan( BOOL Status )
{
	switch (Status)
	{
		case ENABLE:
			AreaScan= TRUE;
			ProtocolCombobox.DeleteComboboxItem(hScanmethodeList, "ContinuousScan");
			CheckDlgButton(hwndDlg, id_Scanachse1, 1);
			CheckDlgButton(hwndDlg, id_Scanachse2, 0);
			if ( CurrentDlg == ScanDlg )
			{
				ShowDlgItem( id_Scanachse1, SHOW );
				ShowDlgItem( id_Scanachse2, SHOW );
			}
			if (Continuous)
				EnableContinuous( FALSE );
			break;

		case DISABLE:
			AreaScan= FALSE;
			ProtocolCombobox.AddComboboxItem(hScanmethodeList, "ContinuousScan");
			if (!Omega2Theta)
			{
				ScanachseAnzahl= 1;
				Scanachse= Scanachse1;
				if ( CurrentDlg == ScanDlg )
				{
					ShowDlgItem( id_Scanachse1, HIDE );
					ShowDlgItem( id_Scanachse2, HIDE );
				}
			}
			if (Continuous)
				EnableContinuous( TRUE );
			break;
	}
};

void TProtocolDiffractometryDlg::EnableOmega2Theta( BOOL Status )
{
	switch (Status)
	{
		case ENABLE:
			Omega2Theta= TRUE;
			ScanachseAnzahl= 2;
			Scanachse= Scanachse1;
			CheckDlgButton(hwndDlg, id_Scanachse1, 1);
			CheckDlgButton(hwndDlg, id_Scanachse2, 0);
			if ( CurrentDlg == ScanDlg )
			{
				ShowDlgItem( id_Scanachse1, SHOW );
				ShowDlgItem( id_Scanachse2, SHOW );
			}
			break;

		case DISABLE:
			Omega2Theta= FALSE;
			if (!AreaScan)
			{
				ScanachseAnzahl= 1;
				Scanachse= Scanachse1;
				if ( CurrentDlg == ScanDlg )
				{
					ShowDlgItem( id_Scanachse1, HIDE );
					ShowDlgItem( id_Scanachse2, HIDE );
				}
			}
			break;
	}
};

void TProtocolDiffractometryDlg::EnableContinuous( BOOL Status )
{
	switch (Status)
	{
		case ENABLE:
			Continuous= TRUE;
			ProtocolCombobox.DeleteComboboxItem(hScantypList, "Omega2Theta");
			SetDlgItemText(hwndDlg, id_MinimumText, ProtocolLanguage->TranslateParameter("Start:"));
			SetDlgItemText(hwndDlg, id_MaximumText, ProtocolLanguage->TranslateParameter("Ende:"));
			SetDlgItemText(hwndDlg, id_SchrittweiteText, ProtocolLanguage->TranslateParameter("Bereichsgre:"));
			if ( CurrentDlg == ScanDlg )
			{
				ShowDlgItem( id_GeschwindigkeitText, SHOW );
				ShowDlgItem( id_Geschwindigkeit, SHOW );
			}
			if (Omega2Theta)
				EnableOmega2Theta( FALSE );
			if (AreaScan)
				EnableAreaScan( FALSE );
			break;

		case DISABLE:
			Continuous= FALSE;
			ProtocolCombobox.AddComboboxItem(hScantypList, "Omega2Theta");
			SetDlgItemText(hwndDlg, id_MinimumText, ProtocolLanguage->TranslateParameter("Minimum:"));
			SetDlgItemText(hwndDlg, id_MaximumText, ProtocolLanguage->TranslateParameter("Maximum:"));
			SetDlgItemText(hwndDlg, id_SchrittweiteText, ProtocolLanguage->TranslateParameter("Schrittweite:"));
			ShowDlgItem( id_GeschwindigkeitText, HIDE );
			ShowDlgItem( id_Geschwindigkeit, HIDE );
			if (Omega2Theta)
				EnableOmega2Theta( TRUE );
			if (AreaScan)
				EnableAreaScan( TRUE );
			break;
	}
};

void TProtocolDiffractometryDlg::EnablePSD( BOOL Status )
{
	switch (Status)
	{
		case ENABLE:
			PSD= TRUE;
			if ( (Protocol->IsProtocolOn() || Protocol->IsProtocolReadOnly()) &&
					!Protocol->IsProtocolDelete() )
				Protocol->SetParameterReadOnly(Winkelbereich);
			else
				Protocol->SetParameterReadWrite(Winkelbereich);
			ShowDlgItem( id_DistanzText, HIDE );
			ShowDlgItem( id_Distanz, HIDE );
			ShowDlgItem( id_DistanzEinheit, HIDE );
			if ( CurrentDlg == DetektorDlg )
			{
				ShowDlgItem( id_GruppePSD, SHOW );
				ShowDlgItem( id_MesskanalText, SHOW );
				ShowDlgItem( id_WinkelbereichText, SHOW );
				ShowDlgItem( id_WinkelbereichEinheit, SHOW );
				ShowDlgItem( id_KanalabstandText, SHOW );
				ShowDlgItem( id_KanalabstandEinheit, SHOW );
				ShowDlgItem( id_AddiereText, SHOW );
				ShowDlgItem( id_AddiereEinheit, SHOW );
				ShowDlgItem( id_Messkanal, SHOW );
				ShowDlgItem( id_Winkelbereich, SHOW );
				ShowDlgItem( id_Kanalabstand, SHOW );
				ShowDlgItem( id_Addiere, SHOW );
			}
			break;

		case DISABLE:
			PSD= FALSE;
			Protocol->SetParameterReadWrite(Winkelbereich);
			ShowDlgItem( id_GruppePSD, HIDE );
			ShowDlgItem( id_MesskanalText, HIDE );
			ShowDlgItem( id_WinkelbereichText, HIDE );
			ShowDlgItem( id_WinkelbereichEinheit, HIDE );
			ShowDlgItem( id_KanalabstandText, HIDE );
			ShowDlgItem( id_KanalabstandEinheit, HIDE );
			ShowDlgItem( id_AddiereText, HIDE );
			ShowDlgItem( id_AddiereEinheit, HIDE );
			ShowDlgItem( id_Messkanal, HIDE );
			ShowDlgItem( id_Winkelbereich, HIDE );
			ShowDlgItem( id_Kanalabstand, HIDE );
			ShowDlgItem( id_Addiere, HIDE );
			if ( CurrentDlg == DetektorDlg )
			{
				ShowDlgItem( id_DistanzText, SHOW );
				ShowDlgItem( id_Distanz, SHOW );
				ShowDlgItem( id_DistanzEinheit, SHOW );
			}
			break;
	}
};

void TProtocolDiffractometryDlg::InitializeDlgItems(HWND hwnd)
{
	PSD= Continuous= Omega2Theta= FALSE;
	ScanachseAnzahl= 1;
	Scanachse= Scanachse1;

	hLfdNr= GetDlgItem( hwndDlg, id_LfdNr );

	ProtocolCombobox.InitializeCombobox(hwnd, hNutzerList, id_Nutzer, Nutzer, "Nutzer");
	ProtocolCombobox.InitializeCombobox(hwnd, hMaterialList, id_Material, Material, "Material");
	ProtocolCombobox.InitializeCombobox(hwnd, hAArtList, id_AArt, AArt, "Absorber");
	ProtocolCombobox.InitializeCombobox(hwnd, hScanartList, id_Scanart, Scanart, "-,LineScan,AreaScan");
	ProtocolCombobox.InitializeCombobox(hwnd, hScanmethodeList, id_Scanmethode, Scanmethode, "-,StepScan,ContinuousScan");
	ProtocolCombobox.InitializeCombobox(hwnd, hScantypList, id_Scantyp, Scantyp, "-,Omega,Omega2Theta");
	ProtocolCombobox.InitializeCombobox(hwnd, hScanachseList, id_Scanachse, Scanachse, "Motor");
	ProtocolCombobox.InitializeCombobox(hwnd, hDetektorList, id_Detektor, Detektor, "Device");
	ProtocolCombobox.InitializeCombobox(hwnd, hMonitorList, id_Monitor, Monitor, "Device");

	CheckRadioButton( hwndDlg, id_Scanachse1, id_Scanachse2, id_Scanachse1);
};

void TProtocolDiffractometryDlg::SaveDlgItems(HWND hwnd)
{
	ProtocolCombobox.SaveCombobox(hwnd, id_Nutzer, "Nutzer");
	ProtocolCombobox.SaveCombobox(hwnd, id_Material, "Material");
	ProtocolCombobox.SaveCombobox(hwnd, id_AArt, "Absorber");
};

LPSTR TProtocolDiffractometryDlg::GetDlgItemText_LfdNr(HWND hwnd, LPSTR lLfdNr)
{
	char buf[MaxString];

	GetDlgItemText(hwnd, id_LfdNr, buf, MaxString);
	strcpy(lLfdNr, buf);
	return lLfdNr;
};

BOOL TProtocolDiffractometryDlg::TestDlgItemText_LfdNr(HWND hwnd, LPSTR lLfdNr)
{
	char buf[MaxLfdNr];

	strcpy(lLfdNr, "");
	GetDlgItemText(hwnd, id_LfdNr, buf, MaxLfdNr);
	if (ProtocolDiffractometry->TestLfdNr(buf))
	{
		strcpy(lLfdNr, buf);
		return TRUE;
	}
	return FALSE;
};

BOOL TProtocolDiffractometryDlg::IsDlgItemModify(void)
{
	BOOL bEdit;

	bEdit= Edit_GetModify(hLfdNr);
	if (bEdit)
		Edit_SetModify(hLfdNr, 0);
	return bEdit;
};

void TProtocolDiffractometryDlg::SetDlgItemText_LfdNr(HWND hwnd)
{
	char buf[MaxString];

	Edit_LimitText(hLfdNr, 8);
	SetDlgItemText(hwnd, id_LfdNr, ProtocolDiffractometry->GetLfdNr(buf));
};

void TProtocolDiffractometryDlg::EnableDlgItem_LfdNr(BOOL Status)
{
	EnableDlgItem(id_LfdNr, Status);
};

BOOL TProtocolDiffractometryDlg::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
    TCITEM titem;
	char buf[MaxString];
	int iTab=0;
	
	TProtocolDlg::Dlg_OnInit(hwnd, hwndCtl, lParam);

	titem.mask= TCIF_TEXT;
	titem.pszText= buf;
    titem.cchTextMax= MaxString;
	titem.iImage= -1;

    strcpy(buf,"Messung");
	TabCtrl_InsertItem(hTab, iTab++, &titem);

    strcpy(buf,"Scan");
	TabCtrl_InsertItem(hTab, iTab++, &titem);

    strcpy(buf,"Blende/Absorber");
	TabCtrl_InsertItem(hTab, iTab++, &titem);

    strcpy(buf,"Detektoren");
	TabCtrl_InsertItem(hTab, iTab++, &titem);

    strcpy(buf,"Bemerkung");
	TabCtrl_InsertItem(hTab, iTab++, &titem);

	ProtocolLanguage->SetDiffractometryDlgLanguage(hwnd);

	return TRUE;
};

void TProtocolDiffractometryDlg::Dlg_OnDestroy( HWND hwnd )
{
	TProtocolDlg::Dlg_OnDestroy(hwnd);
};


BOOL TProtocolDiffractometryDlg::Dlg_OnSysCommand(HWND hwnd, int id, LPARAM lParam)
{
	RECT Rect;

	switch ( id )
	{
		case cm_ProtcolDeutsch:
		case cm_ProtcolEnglisch:
			ProtocolLanguage->SetDiffractometryDlgLanguage(hwnd, id);
			if ( ProtoPrintDlg )
			{
				_FREEOBJ(ProtoPrintDlg);
				GetClientRect( GetDlgItem(hwndDlg, id_Skizze), &Rect );
				ProtoPrintDlg= new TProtocolDiffractometryManagePrintDlg( "ProtocolDiffractometryManagePrintDlg", this, Rect.right, Rect.bottom, &ProtoPrintDlg );
				if ( ProtoPrintDlg )
					ProtoPrintDlg->Initialize( hModuleInstance, GetFrameHandle() );
				SetActiveWindow(hwnd);
			}
			return TRUE;
		
		default:
			return FALSE;
	}
};

void TProtocolDiffractometryDlg::Dlg_OnNotify(HWND hwnd, int message, UINT id, UINT wParam)
{
    int iTab;
	
    if (message!=WM_NOTIFY || id!=id_Tab ) return;

	iTab=TabCtrl_GetCurFocus(hTab)+2;
	if (CurrentDlg!=iTab)
		switch ( iTab )
		{
			case MessungDlg:
				SaveDlg( hwnd, CurrentDlg);
				ShowDialog( MessungDlg, SHOW );
				SetDlgItemText(hwnd, id_StatusLine, "Parameter Messung");
				break;

			case ScanDlg:
				SaveDlg( hwnd, CurrentDlg);
				ShowDialog( ScanDlg, SHOW );
				SetDlgItemText(hwnd, id_StatusLine, "Parameter Scan");
				break;

			case BlendeAbsorberDlg:
				SaveDlg( hwnd, CurrentDlg);
				ShowDialog( BlendeAbsorberDlg, SHOW );
				SetDlgItemText(hwnd, id_StatusLine, "Parameter Blende/Absorber");
				break;

			case DetektorDlg:
				SaveDlg( hwnd, CurrentDlg);
				ShowDialog( DetektorDlg, SHOW );
				SetDlgItemText(hwnd, id_StatusLine, "Parameter Detektor");
				break;

			case BemerkungDlg:
				SaveDlg( hwnd, CurrentDlg);
				ShowDialog( BemerkungDlg, SHOW );
				SetDlgItemText(hwnd, id_StatusLine, "Parameter Bemerkung");
				break;
	} // switch ( iTab )
};

void TProtocolDiffractometryDlg::Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	char buf[MaxString];
	RECT Rect;

	if (TProtocolDlg::Dlg_OnCommand(hwnd, id, codeNotify))
		return;

	switch (id)
	{
		case id_Scanart:
			if ( codeNotify==CBN_SELCHANGE ) 
			{
				ComboBox_GetText(hScanartList, buf, MaxString);
				if (strstr(buf, "AreaScan") == NULL)
				{
					EnableAreaScan(DISABLE);
				}
				else
				{
					EnableAreaScan(ENABLE);
				}			
			}
			break;

		case id_Scanmethode:
			if ( codeNotify==CBN_SELCHANGE ) 
			{
				ComboBox_GetText(hScanmethodeList, buf, MaxString);
				if (strstr(buf, "Continuous") == NULL)
				{
					EnableContinuous(DISABLE);
				}
				else
				{
					EnableContinuous(ENABLE);
				}
			}
			break;

		case id_Scantyp:
			if ( codeNotify==CBN_SELCHANGE )
			{
				ComboBox_GetText(hScantypList, buf, MaxString);
				if (strstr(buf, "Omega2Theta") == NULL)
				{
					EnableOmega2Theta(DISABLE);
				}
				else
				{
					EnableOmega2Theta(ENABLE);
				}
				RefreshScanachse(Scanachse);
				ManageDlgItem(hwnd, id_SOffset, SOffset1, Refresh);
				ManageDlgItem(hwnd, id_Minimum, Minimum1, Refresh);
				ManageDlgItem(hwnd, id_Maximum, Maximum1, Refresh);
				ManageDlgItem(hwnd, id_Schrittweite, Schrittweite1, Refresh);
				ManageDlgItem(hwnd, id_Geschwindigkeit, Geschwindigkeit1, Refresh);
				break;
			}
			break;

		case id_Scanachse1:
			SaveDlg( hwnd, CurrentDlg);
			Scanachse= Scanachse1;
			RefreshDlg(hwnd, CurrentDlg);
			break;
		
		case id_Scanachse2:
			SaveDlg( hwnd, CurrentDlg);
			Scanachse= Scanachse2;
			RefreshDlg(hwnd, CurrentDlg);
			break;
		
		case id_Detektor:
			if ( codeNotify==CBN_SELCHANGE ) 
			{
				ComboBox_GetText(hDetektorList, buf, MaxString);
				if (strstr(buf, "PSD") == NULL)
				{
					EnablePSD(DISABLE);
					ManageDlgItem(hwnd, id_Distanz, Winkelbereich, Refresh);
				}
				else
				{
					EnablePSD(ENABLE);
					ManageDlgItem(hwnd, id_Winkelbereich, Winkelbereich, Refresh);
				}
			}
			break;

		case IDPRINT:
			if ( !ProtoPrintDlg )
			{
				GetClientRect( GetDlgItem(hwndDlg, id_Skizze), &Rect );
				ProtoPrintDlg= new TProtocolDiffractometryManagePrintDlg( "ProtocolDiffractometryManagePrintDlg", this, Rect.right, Rect.bottom, &ProtoPrintDlg );
				if ( ProtoPrintDlg )
					ProtoPrintDlg->Initialize( hModuleInstance, GetFrameHandle() );
			}
			break;

		default:
			TModalDlg::Dlg_OnCommand(hwnd, id, hwndCtl, codeNotify);
	}
};

BOOL TProtocolDiffractometryDlg::TestPflichtDlg(HWND hwnd)
{
	/*char buf[MaxLine];

	MeasurementParameter->SetUser(GetMeasurementParameter(hwnd, id_Nutzer, Nutzer, buf));
	if( !MeasurementParameter->SetOrientation(GetMeasurementParameter(hwnd, id_Orientierung, Orientierung, buf)) ) {
		MeasurementParameterError(hwnd, id_Orientierung, Orientierung, buf);
		return FALSE;
	}
	if( !MeasurementParameter->SetReflection(GetMeasurementParameter(hwnd, id_UReflex, UReflex, buf)) ) {
		MeasurementParameterError(hwnd, id_UReflex, UReflex, buf);
		return FALSE;
	}
	if( !MeasurementParameter->SetVoltage(GetMeasurementParameter(hwnd, id_Spannung, Spannung, buf)) ) {
		MeasurementParameterError(hwnd, id_Spannung, Spannung, buf);
		return FALSE;
	}
	if( !MeasurementParameter->SetCurrent(GetMeasurementParameter(hwnd, id_Strom, Strom, buf)) ) {
		MeasurementParameterError(hwnd, id_Strom, Strom, buf);
		return FALSE;
	}
	if( !MeasurementParameter->SetWaveLength(GetMeasurementParameter(hwnd, id_Wellenlaenge, Wellenlaenge, buf)) ) {
		MeasurementParameterError(hwnd, id_Wellenlaenge, Wellenlaenge, buf);
		return FALSE;
	}
	*/
	if ( !ManageDlgItem(hwnd, id_Datum, Datum, DefaultTest) )
		return FALSE;
	if ( !ManageDlgItem(hwnd, id_ProbenNr, ProbenNr, DefaultTest) )
		return FALSE;
	if ( !ManageDlgItem(hwnd, id_BPShorizontal, BPShorizontal, DefaultTest) )
		return FALSE;
	if ( !ManageDlgItem(hwnd, id_BPSvertikal, BPSvertikal, DefaultTest) )
		return FALSE;
	if ( !ManageDlgItem(hwnd, id_BDhorizontal, BDhorizontal, DefaultTest) )
		return FALSE;
	if ( !ManageDlgItem(hwnd, id_BDvertikal, BDvertikal, DefaultTest) )
		return FALSE;
	return TRUE;
};

/*
LPSTR TProtocolDiffractometryDlg::GetMeasurementParameter(HWND hwnd, int id, int Nr, LPSTR buf)
{
    if( IsWindowVisible(GetDlgItem( hwnd, id)) )
          GetDlgItemText(hwnd,id, buf, MaxParameterString);
     else Protocol->GetProtocolValue(Nr, buf);
    return buf;
}

void TProtocolDiffractometryDlg::MeasurementParameterError(HWND hwnd, int id, int Nr, LPSTR buf)
{
  char buf2[MaxString];
  HWND DlgHwnd;

    DlgHwnd=GetDlgItem( hwnd, id);
    sprintf(buf, ProtocolLanguage->GetMessage(28), Protocol->GetParameterNamen(Nr, buf2));
    SetDlgItemText(hwnd,id_StatusLine,buf);
    MessageBox(GetFocus(),buf,ProtocolLanguage->GetFailure(), MBFAILURE);
    if( !IsWindowVisible(DlgHwnd) ) {
        SaveDlg( hwnd, CurrentDlg);
        ShowDialog( GetDlg(id), SHOW );
    }
    SetFocus(DlgHwnd);
};
*/

void TProtocolDiffractometryDlg::RefreshScanachse( int id )
{
	char buf[MaxString];

	ProtocolDiffractometry->GetProtocolValue(id, buf);
	ProtocolCombobox.AddAndSelectComboboxItem(hScanachseList, buf);
};

void TProtocolDiffractometryDlg::RefreshDetektor( )
{
	char buf[MaxString];

	ProtocolDiffractometry->GetProtocolValue(Detektor, buf);
	if (strstr(buf, "PSD") == NULL)
		EnablePSD(DISABLE);
	else
		EnablePSD(ENABLE);
	ProtocolCombobox.AddAndSelectComboboxItem(hDetektorList, buf);

	ProtocolDiffractometry->GetProtocolValue(Monitor, buf);
	ProtocolCombobox.AddAndSelectComboboxItem(hMonitorList, buf);
};

void TProtocolDiffractometryDlg::RefreshCombobox( )
{
	char buf[MaxString];

	ProtocolDiffractometry->GetProtocolValue(Scanart, buf);
	if (strstr(buf, "AreaScan") == NULL)
		EnableAreaScan( DISABLE );
	else
		EnableAreaScan( ENABLE );
	ComboBox_SelectString(hScanartList, -1, buf);

	ProtocolDiffractometry->GetProtocolValue(Scanmethode, buf);
	if (strstr(buf, "Continuous") == NULL)
		EnableContinuous( DISABLE );
	else
		EnableContinuous( ENABLE );
	ComboBox_SelectString(hScanmethodeList, -1, buf);

	ProtocolDiffractometry->GetProtocolValue(Scantyp, buf);
	if (strstr(buf, "Omega2Theta") == NULL)
		EnableOmega2Theta( DISABLE );
	else
		EnableOmega2Theta( ENABLE );
	ComboBox_SelectString(hScantypList, -1, buf);

	Scanachse= Scanachse1;
	RefreshScanachse(Scanachse);
	RefreshDetektor();
};

BOOL TProtocolDiffractometryDlg::ManageDlg(HWND hwnd, int id, TAction Action)
{
	switch (id)
	{
		case ProbeSkizzeDlg:
			if ( !ManageDlgItem(hwnd, id_Datum, Datum, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Nutzer, Nutzer, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_ProbenNr, ProbenNr, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Material, Material, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_FehlWinkel, FehlWinkel, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_FehlRichtung, FehlRichtung, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Orientierung, Orientierung, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_UReflex, UReflex, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Scanart, Scanart, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Scanmethode, Scanmethode, Action) )
				return FALSE;
			break;

		case MessungDlg:
			if ( !ManageDlgItem(hwnd, id_Spannung, Spannung, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Strom, Strom, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Wellenlaenge, Wellenlaenge, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Messdatei, Messdatei, Action) )
				return FALSE;
			break;

		case ScanDlg:
			if ( !ManageDlgItem(hwnd, id_Scantyp, Scantyp, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Scanachse, Scanachse, Action) )
				return FALSE;
			if ( Action == Refresh )
				RefreshScanachse(Scanachse);
			if ( Scanachse == Scanachse1 )
			{
				if ( !ManageDlgItem(hwnd, id_SOffset, SOffset1, Action) )
					return FALSE;
				if ( !ManageDlgItem(hwnd, id_Minimum, Minimum1, Action) )
					return FALSE;
				if ( !ManageDlgItem(hwnd, id_Maximum, Maximum1, Action) )
					return FALSE;
				if ( !ManageDlgItem(hwnd, id_Schrittweite, Schrittweite1, Action) )
					return FALSE;
				if ( !ManageDlgItem(hwnd, id_Geschwindigkeit, Geschwindigkeit1, Action) )
					return FALSE;
			}
			else
			{
				if ( !ManageDlgItem(hwnd, id_SOffset, SOffset2, Action) )
					return FALSE;
				if ( !ManageDlgItem(hwnd, id_Minimum, Minimum2, Action) )
					return FALSE;
				if ( !ManageDlgItem(hwnd, id_Maximum, Maximum2, Action) )
					return FALSE;
				if ( !ManageDlgItem(hwnd, id_Schrittweite, Schrittweite2, Action) )
					return FALSE;
				if ( !ManageDlgItem(hwnd, id_Geschwindigkeit, Geschwindigkeit2, Action) )
					return FALSE;
			}
			break;

		case BlendeAbsorberDlg:
			if ( !ManageDlgItem(hwnd, id_BPShorizontal, BPShorizontal, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_BPSvertikal, BPSvertikal, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_BDhorizontal, BDhorizontal, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_BDvertikal, BDvertikal, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_AArt, AArt, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_AFaktor, AFaktor, Action) )
				return FALSE;
			break;

		case DetektorDlg:
			if ( !ManageDlgItem(hwnd, id_Detektor, Detektor, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Messzeit, Messzeit, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Impulse, Impulse, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Monitor, Monitor, Action) )
				return FALSE;
			if ( Action == Refresh )
				RefreshDetektor();
			if ( !ManageDlgItem(hwnd, id_Kanalabstand, Kanalabstand, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Messkanal, Messkanal, Action) )
				return FALSE;
			if ( !ManageDlgItem(hwnd, id_Addiere, Addiere, Action) )
				return FALSE;
			if ( PSD )
			{
				if ( !ManageDlgItem(hwnd, id_Winkelbereich, Winkelbereich, Action) )
					return FALSE;
			}
			else
			{
				if ( !ManageDlgItem(hwnd, id_Distanz, Winkelbereich, Action) )
					return FALSE;
			}
			break;

		case BemerkungDlg:
			if ( !ManageDlgItem(hwnd, id_Bemerkung, Bemerkung, Action) )
				return FALSE;
			break;
	}
	SetFocus(GetDlgItem(hwnd, IDOK));
	return TRUE;
};

int TProtocolDiffractometryDlg::GetDlg(int id)
{
	switch (id)
	{
		case id_Datum:
		case id_Nutzer:
		case id_ProbenNr:
		case id_Material:
		case id_FehlWinkel:
		case id_FehlRichtung:
		case id_Orientierung:
		case id_UReflex:
		case id_Scanart:
		case id_Scanmethode:
			return ProbeSkizzeDlg;

		case id_Spannung:
		case id_Strom:
		case id_Wellenlaenge:
		case id_Messdatei:
			return MessungDlg;

		case id_Scantyp:
		case id_Scanachse:
		case id_SOffset:
		case id_Minimum:
		case id_Maximum:
		case id_Schrittweite:
		case id_Geschwindigkeit:
			return ScanDlg;

		case id_BPShorizontal:
		case id_BPSvertikal:
		case id_BDhorizontal:
		case id_BDvertikal:
		case id_AArt:
		case id_AFaktor:
			return BlendeAbsorberDlg;

		case id_Detektor:
		case id_Messzeit:
		case id_Impulse:
		case id_Monitor:
		case id_Winkelbereich:
		case id_Kanalabstand:
		case id_Messkanal:
		case id_Addiere:
		case id_Distanz:
			return DetektorDlg;

		case id_Bemerkung:
			return BemerkungDlg;
	}
	return -1;
};

int TProtocolDiffractometryDlg::GetStatusId( void )
{
	return Status;
};

int TProtocolDiffractometryDlg::GetDatumId( void )
{
	return Datum;
};

BOOL TProtocolDiffractometryDlg::CanClose(void)
{
	return TRUE;
};

void TProtocolDiffractometryDlg::Dlg_OnRButtonDown(HWND hwnd, UINT codeNotify1, int x, int y, UINT codeNotify2)
{
	TProtocolDlg::Dlg_OnRButtonDown(hwnd, codeNotify1, x, y, codeNotify2);
};

void TProtocolDiffractometryDlg::Dlg_OnLButtonDown(HWND hwnd, UINT codeNotify1, int x, int y, UINT codeNotify2)
{
	TProtocolDlg::Dlg_OnLButtonDown(hwnd, codeNotify1, x, y, codeNotify2);
};

void TProtocolDiffractometryDlg::Dlg_OnLButtonUp(HWND hwnd, int x, int y, UINT codeNotify)
{
	TProtocolDlg::Dlg_OnLButtonUp(hwnd, x, y, codeNotify);
};

void TProtocolDiffractometryDlg::Dlg_OnMouseMove(HWND hwnd, int x, int y, UINT codeNotify)
{
	TProtocolDlg::Dlg_OnMouseMove(hwnd, x, y, codeNotify);
};


// LastLine


