//******************************************************************************
//Datei     : TProtocolDiffractometryManagePrintDlg.cpp
//Projekt   : XCTL
//Subsystem : Protokollbuch
//Autor     : Jens Klier <klier@informatik.hu-berlin.de>
//            Institut fuer Informatik,
//            Humboldt-Universitaet Berlin
//Inhalt    : Implementation der Klasse TProtocolDiffractometryManagePrintDlg
//******************************************************************************
//!neu klier Protokollbuch
#include "internls\evrythng.h"
#include "winresrc\rc_prtow.h" // Ressourcen-IDs
#include <commdlg.h>
#include <commctrl.h>

#include "protocol\TProtocolLanguage.h"
#include "protocol\TProtocol.h"
#include "protocol\TProtocolDlg.h"
#include "protocol\TProtocolDiffractometry.h"
#include "protocol\TProtocolDiffractometryDlg.h"
#include "protocol\TProtocolManagePrintDlg.h"
#include "protocol\TProtocolDiffractometryManagePrintDlg.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

extern TProtocolLanguage *ProtocolLanguage;
extern TProtocolDiffractometry *ProtocolDiffractometry;
extern HINSTANCE hModuleInstance;

TProtocolDiffractometryManagePrintDlg::TProtocolDiffractometryManagePrintDlg(LPSTR Dlg, TProtocolDiffractometryDlg *ProtocolDiffractometryDlg, int x, int y, TModelessDlg **aRef) :
		TProtocolManagePrintDlg(Feldelemente, x, y), TModelessDlg(Dlg, aRef,hModuleInstance)
{
	Protocol= ProtocolDiffractometry;
	ProtocolCombobox.InitializeManageComboboxProtocolDlg(Protocol);
	ProtocolDlg= ProtocolDiffractometryDlg;
};

BOOL TProtocolDiffractometryManagePrintDlg::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
    int iCol=0;
	char buf[MaxString];
 
	TProtocolManagePrintDlg::Dlg_OnInit(hwnd, hwndCtl, lParam);
	ProtocolCombobox.InitializeCombobox(hwnd, hMaterialList, id_PrnMaterial, Material, "Material");

    if (!PListView_InsertColumn(hSuchList, iCol++, ProtocolDiffractometry->GetParameterNamen(LfdNr, buf))) 
            return FALSE; 
    if (!PListView_InsertColumn(hSuchList, iCol++, ProtocolDiffractometry->GetParameterNamen(Datum, buf))) 
            return FALSE; 
    if (!PListView_InsertColumn(hSuchList, iCol++, ProtocolDiffractometry->GetParameterNamen(ProbenNr, buf))) 
            return FALSE; 
    if (!PListView_InsertColumn(hSuchList, iCol++, ProtocolDiffractometry->GetParameterNamen(Material, buf))) 
            return FALSE; 

	ListView_SetExtendedListViewStyle(hSuchList, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES );

	ProtocolLanguage->SetDiffractometryManagePrintDlgLanguage(hwnd);

	return TRUE;
};

void TProtocolDiffractometryManagePrintDlg::Dlg_OnNotify(HWND hwnd, int message, UINT id, UINT wParam)
{
    TProtocolManagePrintDlg::Dlg_OnNotify(hwnd, message, id, wParam);
};

void TProtocolDiffractometryManagePrintDlg::Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	if (TProtocolManagePrintDlg::Dlg_OnCommand(hwnd, id, codeNotify))
		return;

	TModelessDlg::Dlg_OnCommand(hwnd, id, hwndCtl, codeNotify);
};

LPSTR TProtocolDiffractometryManagePrintDlg::GetDlgItemText_LfdNr( HWND hwnd, LPSTR lLfdNr)
{
	GetDlgItemText(hwnd, id_PrnLfdNr, lLfdNr, MaxString);
	return lLfdNr;
};

void TProtocolDiffractometryManagePrintDlg::GetDlgItemText_SearchParameter( HWND hwnd, TSearchParameter SearchParameter )
{
	GetDlgItemText(hwnd, id_PrnProbenNr, SearchParameter[0], MaxString);
	GetDlgItemText(hwnd, id_PrnMaterial, SearchParameter[1], MaxString);
	strcpy(SearchParameter[2], "");
	strcpy(SearchParameter[3], "");
};

BOOL TProtocolDiffractometryManagePrintDlg::SearchProtocolString( LPCSTR lLfdNr, const TSearchDate SearchDate, const TSearchParameter SearchParameter )
{
	return ProtocolDiffractometry->SearchProtocolString(lLfdNr, SearchDate[0], SearchDate[1],
			SearchParameter[0], SearchParameter[1]);
};

void TProtocolDiffractometryManagePrintDlg::MakeListString( int iIndex)
{
	char buf[MaxString];
	int iCol=1;

	PListView_InsertItem(hSuchList, iIndex, ProtocolDiffractometry->GetProtocolValue(LfdNr, buf));

	PListView_SetItemText(hSuchList, iIndex, iCol++, ProtocolDiffractometry->GetProtocolValue(Datum, buf));
	PListView_SetItemText(hSuchList, iIndex, iCol++, ProtocolDiffractometry->GetProtocolValue(ProbenNr, buf));
	PListView_SetItemText(hSuchList, iIndex, iCol++, ProtocolDiffractometry->GetProtocolValue(Material, buf));
};

int TProtocolDiffractometryManagePrintDlg::GetPages( int SelCount )
{
	return SelCount;
};

int TProtocolDiffractometryManagePrintDlg::GetColumn( void )
{
	return 2;
};

LPSTR TProtocolDiffractometryManagePrintDlg::GetSelLfdNr(LPSTR lLfdNr, int Index )
{
    char buf[MaxString];

    ListView_GetItemText(hSuchList,Index,0,buf,MaxString);
	strcpy(lLfdNr, buf);
	return lLfdNr;
};

BOOL TProtocolDiffractometryManagePrintDlg::PrintSkizze(int i)
{
	if (i == Orientierung)
		return TRUE;
	return FALSE;
};

BOOL TProtocolDiffractometryManagePrintDlg::PrintLine(int i)
{
	if ( (i == LfdNr) || (i == Nutzer) || (i == Material) || (i == FehlRichtung) ||
			(i == Scanmethode) || (i == Messdatei) || (i == Scantyp) ||
			((i == Schrittweite1) && !Continuous) ||
			((i == Schrittweite2) && !Continuous) ||
			((i == Geschwindigkeit1) && Continuous) ||
			((i == Geschwindigkeit2) && Continuous) ||
			(i == BPSvertikal) || (i == BDvertikal) || (i == AFaktor) ||
			(i == Addiere) || (i == Monitor) )
		return TRUE;
	return FALSE;
};

void TProtocolDiffractometryManagePrintDlg::GetParameterName(int& i, LPSTR Parameter)
{
	char *token, ParameterValue[MaxParameterString];

	if ( (( i == Geschwindigkeit1) || (i == Geschwindigkeit2)) && !Continuous)
		i++;
	if ( (i == Scanachse2) && !Omega2Theta)
		i += 6;
	if ( (i == Kanalabstand) && !PSD)
		i += 3;

	ProtocolDiffractometry->GetParameterNamen(i, Parameter);

	if ( ( !Continuous &&
			((i == Minimum1) || (i == Maximum1) || (i == Schrittweite1) ||
			 (i == Minimum2) || (i == Maximum2) || (i == Schrittweite2)) ) ||
			( !PSD && (i == Winkelbereich) ) )
	{
		strcpy(ParameterValue, Parameter);
		token= strtok(ParameterValue, "/");
		if (token != NULL)
			strcpy(Parameter, token);
	}
	else
	{
		strcpy(ParameterValue, Parameter);
		token= strtok(ParameterValue, "/");
		token= strtok(NULL, "/");
		if (token != NULL)
			strcpy(Parameter, token);
	}
	strcat(Parameter, ":");
};

BOOL TProtocolDiffractometryManagePrintDlg::GetParameter(int& i, LPSTR Parameter, LPCSTR lLfdNr)
{
	char ParameterValue[MaxParameterString];

	if ( strcmp(ProtocolDiffractometry->GetLfdNr(ParameterValue), lLfdNr) != 0)
		if ( ProtocolDiffractometry->LoadProtocolString(lLfdNr) != 0 )
			return FALSE;

	ProtocolDiffractometry->GetProtocolValue( i, Parameter);
	if (strlen(Parameter) == 0)
		strcpy(Parameter, "-");

	if (i == Scanmethode)
	{
		if (strstr(Parameter, "Continuous") != NULL)
			Continuous= TRUE;
		else
			Continuous= FALSE;
	}
	if (i == Scantyp)
	{
		if (strstr(Parameter, "Omega2Theta") != NULL)
			Omega2Theta= TRUE;
		else
			Omega2Theta= FALSE;
	}
	if (i == Detektor)
	{
		if (strstr(Parameter, "PSD") != NULL)
			PSD= TRUE;
		else
			PSD= FALSE;
	}
	return TRUE;
};


// LastLine


