//#############################################################################
//                                                                           //
// M_DLG.CPP                                                                 //
//                                                                           //
// Subsystem : Develop; GUI-Oberflchenfenster                               //
// Benutung durch andere Subsysteme erforderlich: NEIN                       //
// Deklaration: M_DLG.H                                                      //
//---------------------------------------------------------------------------//
// letzte Bearbeitung: Thomas Kullmann, Gnther Reinecker                    //
// Stand:   27.07.2002                                                       //
//                                                                           //
//#############################################################################

#include "utils\u_utils.h"
#include "winresrc\rc_def.h" // Ressourcen-IDs
#pragma hdrstop

//#include "datavisa\datavisa.h"
#include "workflow\workflow.h"

#include "detecuse\detecuse.h"
#include "motrstrg\motrstrg.h"

#include "swintrac\m_dlg.h"

//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--//--||--\\--||--

// 11.01.2003 Kullmann+Reinecker: verschoben aus M_DLG.H
struct TCScanParam
{ 
	float fStartPoint, fSpeed, fExposureTime;
	int nNumberPoints;
	int nMotorId;
	int nDetectorId;
	BOOL bFastScanActive;
};

// variables related to continuous scan's
TCScanParam CScan;

//#############################################################################
// TExecuteCmdDlg
//#############################################################################

TExecuteCmdDlg::TExecuteCmdDlg(): TModalDlg("ExecuteCmd", GetMainInstance() )
{
	ExecutionId= 0;
};

//! neu Kullmann+Reinecker
BOOL TExecuteCmdDlg::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
	//Datum: 27.07.2002 TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);
	nMotor= mlGetAxis();
	//Datum: 02.08.2002 SetDlgItemText(hwnd,cm_RotateMotor,mGetAxisName());
	SetFocus(GetDlgItem(hwnd, id_CommandLine));
	return TRUE;
};

void TExecuteCmdDlg::Dlg_OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
	//! static int   i= 0;
	HWND hwndCmd= GetDlgItem(hwnd, id_Response);
	char cmd[MaxString + 1];
	char *lpszToken;

	switch (id)
	{
		case IDOK:
			GetDlgItemText(hwnd, id_CommandLine, cmd, 34);
			strcat(cmd, "\r");
			if (R_OK == mExecuteCmd(cmd))
			{
				lpszToken= strtok(cmd, "\n\3\r");
				while (lpszToken)
				{
					if (strlen(lpszToken) > 1)
						ComboBox_AddString(hwndCmd, lpszToken);
					lpszToken= strtok(NULL, "\n\3\r");
				}
			}
			break;

		//Datum: 02.08.2002
		/*case cm_RotateMotor:
			 mlSetAxis(1+mlGetAxis());
			 SetDlgItemText(hwnd,cm_RotateMotor,(LPSTR)mGetAxisName());
			 SetFocus(GetDlgItem(hwnd,id_CommandLine));
			 break;*/

		default:
			TModalDlg::Dlg_OnCommand(hwnd, id, hwndCtl, codeNotify);
	}
};

//#############################################################################
// TGetDataDlg
//#############################################################################

TGetDataDlg::TGetDataDlg(LPSTR dt, int* dr) : TModalDlg("GetData", GetMainInstance() )
{
	dataref= dr;
	strcpy(datatext, dt);
};

//! neu Kullmann+Reinecker
BOOL TGetDataDlg::Dlg_OnInit(HWND hwnd, HWND hwndCtl, LPARAM lParam)
{
	char buf[30];

	//Datum: 27.07.2002 TModalDlg::Dlg_OnInit(hwnd,hwndCtl,lParam);
	itoa(*dataref, buf, 10);
	SetDlgItemText(hwnd, id_GetDataText, datatext);
	SetDlgItemText(hwnd, id_GetDataValue, buf);
	return TRUE;
};

BOOL TGetDataDlg::CanClose(void)
{
	char buf[30];

	GetDlgItemText(GetHandle(), id_GetDataValue, buf, 29);
	*dataref= atoi(buf);
	return TRUE;
};

//#############################################################################
// LastLine
//#############################################################################





